/* Settings.c generated by valac 0.45.3, the Vala compiler
 * generated from Settings.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <granite.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>

#define NOISE_SETTINGS_TYPE_MAIN (noise_settings_main_get_type ())
#define NOISE_SETTINGS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_SETTINGS_TYPE_MAIN, NoiseSettingsMain))
#define NOISE_SETTINGS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_SETTINGS_TYPE_MAIN, NoiseSettingsMainClass))
#define NOISE_SETTINGS_IS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_SETTINGS_TYPE_MAIN))
#define NOISE_SETTINGS_IS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_SETTINGS_TYPE_MAIN))
#define NOISE_SETTINGS_MAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_SETTINGS_TYPE_MAIN, NoiseSettingsMainClass))

typedef struct _NoiseSettingsMain NoiseSettingsMain;
typedef struct _NoiseSettingsMainClass NoiseSettingsMainClass;
typedef struct _NoiseSettingsMainPrivate NoiseSettingsMainPrivate;
typedef enum  {
	NOISE_SETTINGS_SHUFFLE_OFF,
	NOISE_SETTINGS_SHUFFLE_ALL
} NoiseSettingsShuffle;

#define NOISE_SETTINGS_TYPE_SHUFFLE (noise_settings_shuffle_get_type ())
typedef enum  {
	NOISE_SETTINGS_REPEAT_OFF,
	NOISE_SETTINGS_REPEAT_MEDIA,
	NOISE_SETTINGS_REPEAT_ALL,
	NOISE_SETTINGS_REPEAT_ALBUM,
	NOISE_SETTINGS_REPEAT_ARTIST
} NoiseSettingsRepeat;

#define NOISE_SETTINGS_TYPE_REPEAT (noise_settings_repeat_get_type ())
enum  {
	NOISE_SETTINGS_MAIN_0_PROPERTY,
	NOISE_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY,
	NOISE_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY,
	NOISE_SETTINGS_MAIN_SHUFFLE_MODE_PROPERTY,
	NOISE_SETTINGS_MAIN_REPEAT_MODE_PROPERTY,
	NOISE_SETTINGS_MAIN_PATH_STRING_PROPERTY,
	NOISE_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY,
	NOISE_SETTINGS_MAIN_NUM_PROPERTIES
};
static GParamSpec* noise_settings_main_properties[NOISE_SETTINGS_MAIN_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_SETTINGS_TYPE_EQUALIZER (noise_settings_equalizer_get_type ())
#define NOISE_SETTINGS_EQUALIZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_SETTINGS_TYPE_EQUALIZER, NoiseSettingsEqualizer))
#define NOISE_SETTINGS_EQUALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_SETTINGS_TYPE_EQUALIZER, NoiseSettingsEqualizerClass))
#define NOISE_SETTINGS_IS_EQUALIZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_SETTINGS_TYPE_EQUALIZER))
#define NOISE_SETTINGS_IS_EQUALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_SETTINGS_TYPE_EQUALIZER))
#define NOISE_SETTINGS_EQUALIZER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_SETTINGS_TYPE_EQUALIZER, NoiseSettingsEqualizerClass))

typedef struct _NoiseSettingsEqualizer NoiseSettingsEqualizer;
typedef struct _NoiseSettingsEqualizerClass NoiseSettingsEqualizerClass;
typedef struct _NoiseSettingsEqualizerPrivate NoiseSettingsEqualizerPrivate;
enum  {
	NOISE_SETTINGS_EQUALIZER_0_PROPERTY,
	NOISE_SETTINGS_EQUALIZER_EQUALIZER_ENABLED_PROPERTY,
	NOISE_SETTINGS_EQUALIZER_AUTO_SWITCH_PRESET_PROPERTY,
	NOISE_SETTINGS_EQUALIZER_SELECTED_PRESET_PROPERTY,
	NOISE_SETTINGS_EQUALIZER_CUSTOM_PRESETS_PROPERTY,
	NOISE_SETTINGS_EQUALIZER_NUM_PROPERTIES
};
static GParamSpec* noise_settings_equalizer_properties[NOISE_SETTINGS_EQUALIZER_NUM_PROPERTIES];

#define NOISE_TYPE_EQUALIZER_PRESET (noise_equalizer_preset_get_type ())
#define NOISE_EQUALIZER_PRESET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPreset))
#define NOISE_EQUALIZER_PRESET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPresetClass))
#define NOISE_IS_EQUALIZER_PRESET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_EQUALIZER_PRESET))
#define NOISE_IS_EQUALIZER_PRESET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_EQUALIZER_PRESET))
#define NOISE_EQUALIZER_PRESET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPresetClass))

typedef struct _NoiseEqualizerPreset NoiseEqualizerPreset;
typedef struct _NoiseEqualizerPresetClass NoiseEqualizerPresetClass;

struct _NoiseSettingsMain {
	GraniteServicesSettings parent_instance;
	NoiseSettingsMainPrivate * priv;
};

struct _NoiseSettingsMainClass {
	GraniteServicesSettingsClass parent_class;
};

struct _NoiseSettingsMainPrivate {
	gchar* _music_mount_name;
	gchar* _music_folder;
	NoiseSettingsShuffle _shuffle_mode;
	NoiseSettingsRepeat _repeat_mode;
	gchar* _path_string;
	gchar** _plugins_disabled;
	gint _plugins_disabled_length1;
	gint __plugins_disabled_size_;
};

struct _NoiseSettingsEqualizer {
	GraniteServicesSettings parent_instance;
	NoiseSettingsEqualizerPrivate * priv;
};

struct _NoiseSettingsEqualizerClass {
	GraniteServicesSettingsClass parent_class;
};

struct _NoiseSettingsEqualizerPrivate {
	gboolean _equalizer_enabled;
	gboolean _auto_switch_preset;
	gchar* _selected_preset;
	gchar** _custom_presets;
	gint _custom_presets_length1;
	gint __custom_presets_size_;
};

static gint NoiseSettingsMain_private_offset;
static gpointer noise_settings_main_parent_class = NULL;
static NoiseSettingsMain* noise_settings_main_main_settings;
static NoiseSettingsMain* noise_settings_main_main_settings = NULL;
static gint NoiseSettingsEqualizer_private_offset;
static gpointer noise_settings_equalizer_parent_class = NULL;
static NoiseSettingsEqualizer* noise_settings_equalizer_equalizer;
static NoiseSettingsEqualizer* noise_settings_equalizer_equalizer = NULL;

GType noise_settings_main_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NoiseSettingsMain, g_object_unref)
GType noise_settings_shuffle_get_type (void) G_GNUC_CONST;
GType noise_settings_repeat_get_type (void) G_GNUC_CONST;
NoiseSettingsMain* noise_settings_main_get_default (void);
static NoiseSettingsMain* noise_settings_main_new (void);
static NoiseSettingsMain* noise_settings_main_construct (GType object_type);
gboolean noise_settings_main_privacy_mode_enabled (NoiseSettingsMain* self);
const gchar* noise_settings_main_get_music_folder (NoiseSettingsMain* self);
void noise_settings_main_set_music_folder (NoiseSettingsMain* self,
                                           const gchar* value);
const gchar* noise_settings_main_get_music_mount_name (NoiseSettingsMain* self);
void noise_settings_main_set_music_mount_name (NoiseSettingsMain* self,
                                               const gchar* value);
NoiseSettingsShuffle noise_settings_main_get_shuffle_mode (NoiseSettingsMain* self);
void noise_settings_main_set_shuffle_mode (NoiseSettingsMain* self,
                                           NoiseSettingsShuffle value);
NoiseSettingsRepeat noise_settings_main_get_repeat_mode (NoiseSettingsMain* self);
void noise_settings_main_set_repeat_mode (NoiseSettingsMain* self,
                                          NoiseSettingsRepeat value);
const gchar* noise_settings_main_get_path_string (NoiseSettingsMain* self);
void noise_settings_main_set_path_string (NoiseSettingsMain* self,
                                          const gchar* value);
gchar** noise_settings_main_get_plugins_disabled (NoiseSettingsMain* self,
                                                  gint* result_length1);
void noise_settings_main_set_plugins_disabled (NoiseSettingsMain* self,
                                               gchar** value,
                                               gint value_length1);
static gchar** _vala_array_dup1 (gchar** self,
                          int length);
static void noise_settings_main_finalize (GObject * obj);
static void _vala_noise_settings_main_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_noise_settings_main_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
GType noise_settings_equalizer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NoiseSettingsEqualizer, g_object_unref)
NoiseSettingsEqualizer* noise_settings_equalizer_get_default (void);
static NoiseSettingsEqualizer* noise_settings_equalizer_new (void);
static NoiseSettingsEqualizer* noise_settings_equalizer_construct (GType object_type);
GType noise_equalizer_preset_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NoiseEqualizerPreset, g_object_unref)
GeeCollection* noise_settings_equalizer_get_presets (NoiseSettingsEqualizer* self);
gchar** noise_settings_equalizer_get_custom_presets (NoiseSettingsEqualizer* self,
                                                     gint* result_length1);
NoiseEqualizerPreset* noise_equalizer_preset_new_from_string (const gchar* data);
NoiseEqualizerPreset* noise_equalizer_preset_construct_from_string (GType object_type,
                                                                    const gchar* data);
gboolean noise_settings_equalizer_get_equalizer_enabled (NoiseSettingsEqualizer* self);
void noise_settings_equalizer_set_equalizer_enabled (NoiseSettingsEqualizer* self,
                                                     gboolean value);
gboolean noise_settings_equalizer_get_auto_switch_preset (NoiseSettingsEqualizer* self);
void noise_settings_equalizer_set_auto_switch_preset (NoiseSettingsEqualizer* self,
                                                      gboolean value);
const gchar* noise_settings_equalizer_get_selected_preset (NoiseSettingsEqualizer* self);
void noise_settings_equalizer_set_selected_preset (NoiseSettingsEqualizer* self,
                                                   const gchar* value);
void noise_settings_equalizer_set_custom_presets (NoiseSettingsEqualizer* self,
                                                  gchar** value,
                                                  gint value_length1);
static gchar** _vala_array_dup2 (gchar** self,
                          int length);
static void noise_settings_equalizer_finalize (GObject * obj);
static void _vala_noise_settings_equalizer_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_noise_settings_equalizer_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
noise_settings_main_get_instance_private (NoiseSettingsMain* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseSettingsMain_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 43 "../core/Settings.vala"
	return self ? g_object_ref (self) : NULL;
#line 250 "Settings.c"
}

NoiseSettingsMain*
noise_settings_main_get_default (void)
{
	NoiseSettingsMain* result = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp2_;
	NoiseSettingsMain* _tmp3_;
#line 41 "../core/Settings.vala"
	_tmp0_ = noise_settings_main_main_settings;
#line 41 "../core/Settings.vala"
	if (_tmp0_ == NULL) {
#line 264 "Settings.c"
		NoiseSettingsMain* _tmp1_;
#line 42 "../core/Settings.vala"
		_tmp1_ = noise_settings_main_new ();
#line 42 "../core/Settings.vala"
		_g_object_unref0 (noise_settings_main_main_settings);
#line 42 "../core/Settings.vala"
		noise_settings_main_main_settings = _tmp1_;
#line 272 "Settings.c"
	}
#line 43 "../core/Settings.vala"
	_tmp2_ = noise_settings_main_main_settings;
#line 43 "../core/Settings.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 43 "../core/Settings.vala"
	result = _tmp3_;
#line 43 "../core/Settings.vala"
	return result;
#line 282 "Settings.c"
}

gboolean
noise_settings_main_privacy_mode_enabled (NoiseSettingsMain* self)
{
	gboolean result = FALSE;
	GSettings* privacy_settings = NULL;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GSettings* _tmp2_;
#line 46 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 47 "../core/Settings.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.privacy");
#line 47 "../core/Settings.vala"
	privacy_settings = _tmp0_;
#line 48 "../core/Settings.vala"
	_tmp2_ = privacy_settings;
#line 48 "../core/Settings.vala"
	if (g_settings_get_boolean (_tmp2_, "remember-app-usage")) {
#line 48 "../core/Settings.vala"
		_tmp1_ = TRUE;
#line 305 "Settings.c"
	} else {
		GSettings* _tmp3_;
#line 49 "../core/Settings.vala"
		_tmp3_ = privacy_settings;
#line 49 "../core/Settings.vala"
		_tmp1_ = g_settings_get_boolean (_tmp3_, "remember-recent-files");
#line 312 "Settings.c"
	}
#line 48 "../core/Settings.vala"
	result = !_tmp1_;
#line 48 "../core/Settings.vala"
	_g_object_unref0 (privacy_settings);
#line 48 "../core/Settings.vala"
	return result;
#line 320 "Settings.c"
}

static NoiseSettingsMain*
noise_settings_main_construct (GType object_type)
{
	NoiseSettingsMain * self = NULL;
	const gchar* _tmp0_;
#line 53 "../core/Settings.vala"
	self = (NoiseSettingsMain*) granite_services_settings_construct (object_type, "io.elementary.music.settings");
#line 54 "../core/Settings.vala"
	_tmp0_ = self->priv->_music_folder;
#line 54 "../core/Settings.vala"
	if (g_strcmp0 (_tmp0_, "") == 0) {
#line 334 "Settings.c"
		const gchar* _tmp1_;
#line 55 "../core/Settings.vala"
		_tmp1_ = g_get_user_special_dir (G_USER_DIRECTORY_MUSIC);
#line 55 "../core/Settings.vala"
		noise_settings_main_set_music_folder (self, _tmp1_);
#line 340 "Settings.c"
	}
#line 52 "../core/Settings.vala"
	return self;
#line 344 "Settings.c"
}

static NoiseSettingsMain*
noise_settings_main_new (void)
{
#line 52 "../core/Settings.vala"
	return noise_settings_main_construct (NOISE_SETTINGS_TYPE_MAIN);
#line 352 "Settings.c"
}

const gchar*
noise_settings_main_get_music_mount_name (NoiseSettingsMain* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../core/Settings.vala"
	_tmp0_ = self->priv->_music_mount_name;
#line 31 "../core/Settings.vala"
	result = _tmp0_;
#line 31 "../core/Settings.vala"
	return result;
#line 368 "Settings.c"
}

void
noise_settings_main_set_music_mount_name (NoiseSettingsMain* self,
                                          const gchar* value)
{
#line 31 "../core/Settings.vala"
	g_return_if_fail (self != NULL);
#line 31 "../core/Settings.vala"
	if (g_strcmp0 (value, noise_settings_main_get_music_mount_name (self)) != 0) {
#line 379 "Settings.c"
		gchar* _tmp0_;
#line 31 "../core/Settings.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../core/Settings.vala"
		_g_free0 (self->priv->_music_mount_name);
#line 31 "../core/Settings.vala"
		self->priv->_music_mount_name = _tmp0_;
#line 31 "../core/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_settings_main_properties[NOISE_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY]);
#line 389 "Settings.c"
	}
}

const gchar*
noise_settings_main_get_music_folder (NoiseSettingsMain* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../core/Settings.vala"
	_tmp0_ = self->priv->_music_folder;
#line 32 "../core/Settings.vala"
	result = _tmp0_;
#line 32 "../core/Settings.vala"
	return result;
#line 406 "Settings.c"
}

void
noise_settings_main_set_music_folder (NoiseSettingsMain* self,
                                      const gchar* value)
{
#line 32 "../core/Settings.vala"
	g_return_if_fail (self != NULL);
#line 32 "../core/Settings.vala"
	if (g_strcmp0 (value, noise_settings_main_get_music_folder (self)) != 0) {
#line 417 "Settings.c"
		gchar* _tmp0_;
#line 32 "../core/Settings.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../core/Settings.vala"
		_g_free0 (self->priv->_music_folder);
#line 32 "../core/Settings.vala"
		self->priv->_music_folder = _tmp0_;
#line 32 "../core/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_settings_main_properties[NOISE_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY]);
#line 427 "Settings.c"
	}
}

NoiseSettingsShuffle
noise_settings_main_get_shuffle_mode (NoiseSettingsMain* self)
{
	NoiseSettingsShuffle result;
	NoiseSettingsShuffle _tmp0_;
#line 33 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 33 "../core/Settings.vala"
	_tmp0_ = self->priv->_shuffle_mode;
#line 33 "../core/Settings.vala"
	result = _tmp0_;
#line 33 "../core/Settings.vala"
	return result;
#line 444 "Settings.c"
}

void
noise_settings_main_set_shuffle_mode (NoiseSettingsMain* self,
                                      NoiseSettingsShuffle value)
{
#line 33 "../core/Settings.vala"
	g_return_if_fail (self != NULL);
#line 33 "../core/Settings.vala"
	if (noise_settings_main_get_shuffle_mode (self) != value) {
#line 33 "../core/Settings.vala"
		self->priv->_shuffle_mode = value;
#line 33 "../core/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_settings_main_properties[NOISE_SETTINGS_MAIN_SHUFFLE_MODE_PROPERTY]);
#line 459 "Settings.c"
	}
}

NoiseSettingsRepeat
noise_settings_main_get_repeat_mode (NoiseSettingsMain* self)
{
	NoiseSettingsRepeat result;
	NoiseSettingsRepeat _tmp0_;
#line 34 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "../core/Settings.vala"
	_tmp0_ = self->priv->_repeat_mode;
#line 34 "../core/Settings.vala"
	result = _tmp0_;
#line 34 "../core/Settings.vala"
	return result;
#line 476 "Settings.c"
}

void
noise_settings_main_set_repeat_mode (NoiseSettingsMain* self,
                                     NoiseSettingsRepeat value)
{
#line 34 "../core/Settings.vala"
	g_return_if_fail (self != NULL);
#line 34 "../core/Settings.vala"
	if (noise_settings_main_get_repeat_mode (self) != value) {
#line 34 "../core/Settings.vala"
		self->priv->_repeat_mode = value;
#line 34 "../core/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_settings_main_properties[NOISE_SETTINGS_MAIN_REPEAT_MODE_PROPERTY]);
#line 491 "Settings.c"
	}
}

const gchar*
noise_settings_main_get_path_string (NoiseSettingsMain* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../core/Settings.vala"
	_tmp0_ = self->priv->_path_string;
#line 35 "../core/Settings.vala"
	result = _tmp0_;
#line 35 "../core/Settings.vala"
	return result;
#line 508 "Settings.c"
}

void
noise_settings_main_set_path_string (NoiseSettingsMain* self,
                                     const gchar* value)
{
#line 35 "../core/Settings.vala"
	g_return_if_fail (self != NULL);
#line 35 "../core/Settings.vala"
	if (g_strcmp0 (value, noise_settings_main_get_path_string (self)) != 0) {
#line 519 "Settings.c"
		gchar* _tmp0_;
#line 35 "../core/Settings.vala"
		_tmp0_ = g_strdup (value);
#line 35 "../core/Settings.vala"
		_g_free0 (self->priv->_path_string);
#line 35 "../core/Settings.vala"
		self->priv->_path_string = _tmp0_;
#line 35 "../core/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_settings_main_properties[NOISE_SETTINGS_MAIN_PATH_STRING_PROPERTY]);
#line 529 "Settings.c"
	}
}

gchar**
noise_settings_main_get_plugins_disabled (NoiseSettingsMain* self,
                                          gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 36 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../core/Settings.vala"
	_tmp0_ = self->priv->_plugins_disabled;
#line 36 "../core/Settings.vala"
	_tmp0__length1 = self->priv->_plugins_disabled_length1;
#line 36 "../core/Settings.vala"
	_tmp1_ = _tmp0_;
#line 36 "../core/Settings.vala"
	_tmp1__length1 = _tmp0__length1;
#line 36 "../core/Settings.vala"
	if (result_length1) {
#line 36 "../core/Settings.vala"
		*result_length1 = _tmp1__length1;
#line 556 "Settings.c"
	}
#line 36 "../core/Settings.vala"
	result = _tmp1_;
#line 36 "../core/Settings.vala"
	return result;
#line 562 "Settings.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
#line 36 "../core/Settings.vala"
	result = g_new0 (gchar*, length + 1);
#line 36 "../core/Settings.vala"
	for (i = 0; i < length; i++) {
#line 575 "Settings.c"
		gchar* _tmp0_;
#line 36 "../core/Settings.vala"
		_tmp0_ = g_strdup (self[i]);
#line 36 "../core/Settings.vala"
		result[i] = _tmp0_;
#line 581 "Settings.c"
	}
#line 36 "../core/Settings.vala"
	return result;
#line 585 "Settings.c"
}

void
noise_settings_main_set_plugins_disabled (NoiseSettingsMain* self,
                                          gchar** value,
                                          gint value_length1)
{
	gint old_value_length;
#line 36 "../core/Settings.vala"
	g_return_if_fail (self != NULL);
#line 36 "../core/Settings.vala"
	if (noise_settings_main_get_plugins_disabled (self, &old_value_length) != value) {
#line 598 "Settings.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 36 "../core/Settings.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup1 (value, value_length1) : ((gpointer) value);
#line 36 "../core/Settings.vala"
		_tmp0__length1 = value_length1;
#line 36 "../core/Settings.vala"
		self->priv->_plugins_disabled = (_vala_array_free (self->priv->_plugins_disabled, self->priv->_plugins_disabled_length1, (GDestroyNotify) g_free), NULL);
#line 36 "../core/Settings.vala"
		self->priv->_plugins_disabled = _tmp0_;
#line 36 "../core/Settings.vala"
		self->priv->_plugins_disabled_length1 = _tmp0__length1;
#line 36 "../core/Settings.vala"
		self->priv->__plugins_disabled_size_ = self->priv->_plugins_disabled_length1;
#line 36 "../core/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_settings_main_properties[NOISE_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY]);
#line 615 "Settings.c"
	}
}

static void
noise_settings_main_class_init (NoiseSettingsMainClass * klass,
                                gpointer klass_data)
{
#line 30 "../core/Settings.vala"
	noise_settings_main_parent_class = g_type_class_peek_parent (klass);
#line 30 "../core/Settings.vala"
	g_type_class_adjust_private_offset (klass, &NoiseSettingsMain_private_offset);
#line 30 "../core/Settings.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_settings_main_get_property;
#line 30 "../core/Settings.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_settings_main_set_property;
#line 30 "../core/Settings.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_settings_main_finalize;
#line 30 "../core/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY, noise_settings_main_properties[NOISE_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY] = g_param_spec_string ("music-mount-name", "music-mount-name", "music-mount-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY, noise_settings_main_properties[NOISE_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY] = g_param_spec_string ("music-folder", "music-folder", "music-folder", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SETTINGS_MAIN_SHUFFLE_MODE_PROPERTY, noise_settings_main_properties[NOISE_SETTINGS_MAIN_SHUFFLE_MODE_PROPERTY] = g_param_spec_enum ("shuffle-mode", "shuffle-mode", "shuffle-mode", NOISE_SETTINGS_TYPE_SHUFFLE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SETTINGS_MAIN_REPEAT_MODE_PROPERTY, noise_settings_main_properties[NOISE_SETTINGS_MAIN_REPEAT_MODE_PROPERTY] = g_param_spec_enum ("repeat-mode", "repeat-mode", "repeat-mode", NOISE_SETTINGS_TYPE_REPEAT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SETTINGS_MAIN_PATH_STRING_PROPERTY, noise_settings_main_properties[NOISE_SETTINGS_MAIN_PATH_STRING_PROPERTY] = g_param_spec_string ("path-string", "path-string", "path-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY, noise_settings_main_properties[NOISE_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY] = g_param_spec_boxed ("plugins-disabled", "plugins-disabled", "plugins-disabled", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 645 "Settings.c"
}

static void
noise_settings_main_instance_init (NoiseSettingsMain * self,
                                   gpointer klass)
{
#line 30 "../core/Settings.vala"
	self->priv = noise_settings_main_get_instance_private (self);
#line 654 "Settings.c"
}

static void
noise_settings_main_finalize (GObject * obj)
{
	NoiseSettingsMain * self;
#line 30 "../core/Settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_SETTINGS_TYPE_MAIN, NoiseSettingsMain);
#line 31 "../core/Settings.vala"
	_g_free0 (self->priv->_music_mount_name);
#line 32 "../core/Settings.vala"
	_g_free0 (self->priv->_music_folder);
#line 35 "../core/Settings.vala"
	_g_free0 (self->priv->_path_string);
#line 36 "../core/Settings.vala"
	self->priv->_plugins_disabled = (_vala_array_free (self->priv->_plugins_disabled, self->priv->_plugins_disabled_length1, (GDestroyNotify) g_free), NULL);
#line 30 "../core/Settings.vala"
	G_OBJECT_CLASS (noise_settings_main_parent_class)->finalize (obj);
#line 673 "Settings.c"
}

GType
noise_settings_main_get_type (void)
{
	static volatile gsize noise_settings_main_type_id__volatile = 0;
	if (g_once_init_enter (&noise_settings_main_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSettingsMainClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_settings_main_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSettingsMain), 0, (GInstanceInitFunc) noise_settings_main_instance_init, NULL };
		GType noise_settings_main_type_id;
		noise_settings_main_type_id = g_type_register_static (GRANITE_SERVICES_TYPE_SETTINGS, "NoiseSettingsMain", &g_define_type_info, 0);
		NoiseSettingsMain_private_offset = g_type_add_instance_private (noise_settings_main_type_id, sizeof (NoiseSettingsMainPrivate));
		g_once_init_leave (&noise_settings_main_type_id__volatile, noise_settings_main_type_id);
	}
	return noise_settings_main_type_id__volatile;
}

static void
_vala_noise_settings_main_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	NoiseSettingsMain * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_SETTINGS_TYPE_MAIN, NoiseSettingsMain);
#line 30 "../core/Settings.vala"
	switch (property_id) {
#line 30 "../core/Settings.vala"
		case NOISE_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY:
#line 30 "../core/Settings.vala"
		g_value_set_string (value, noise_settings_main_get_music_mount_name (self));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case NOISE_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY:
#line 30 "../core/Settings.vala"
		g_value_set_string (value, noise_settings_main_get_music_folder (self));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case NOISE_SETTINGS_MAIN_SHUFFLE_MODE_PROPERTY:
#line 30 "../core/Settings.vala"
		g_value_set_enum (value, noise_settings_main_get_shuffle_mode (self));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case NOISE_SETTINGS_MAIN_REPEAT_MODE_PROPERTY:
#line 30 "../core/Settings.vala"
		g_value_set_enum (value, noise_settings_main_get_repeat_mode (self));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case NOISE_SETTINGS_MAIN_PATH_STRING_PROPERTY:
#line 30 "../core/Settings.vala"
		g_value_set_string (value, noise_settings_main_get_path_string (self));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case NOISE_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY:
#line 732 "Settings.c"
		{
			int length;
#line 30 "../core/Settings.vala"
			g_value_set_boxed (value, noise_settings_main_get_plugins_disabled (self, &length));
#line 737 "Settings.c"
		}
#line 30 "../core/Settings.vala"
		break;
#line 741 "Settings.c"
		default:
#line 30 "../core/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../core/Settings.vala"
		break;
#line 747 "Settings.c"
	}
}

static void
_vala_noise_settings_main_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	NoiseSettingsMain * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_SETTINGS_TYPE_MAIN, NoiseSettingsMain);
#line 30 "../core/Settings.vala"
	switch (property_id) {
#line 30 "../core/Settings.vala"
		case NOISE_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY:
#line 30 "../core/Settings.vala"
		noise_settings_main_set_music_mount_name (self, g_value_get_string (value));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case NOISE_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY:
#line 30 "../core/Settings.vala"
		noise_settings_main_set_music_folder (self, g_value_get_string (value));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case NOISE_SETTINGS_MAIN_SHUFFLE_MODE_PROPERTY:
#line 30 "../core/Settings.vala"
		noise_settings_main_set_shuffle_mode (self, g_value_get_enum (value));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case NOISE_SETTINGS_MAIN_REPEAT_MODE_PROPERTY:
#line 30 "../core/Settings.vala"
		noise_settings_main_set_repeat_mode (self, g_value_get_enum (value));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case NOISE_SETTINGS_MAIN_PATH_STRING_PROPERTY:
#line 30 "../core/Settings.vala"
		noise_settings_main_set_path_string (self, g_value_get_string (value));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case NOISE_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY:
#line 793 "Settings.c"
		{
			gpointer boxed;
#line 30 "../core/Settings.vala"
			boxed = g_value_get_boxed (value);
#line 30 "../core/Settings.vala"
			noise_settings_main_set_plugins_disabled (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 800 "Settings.c"
		}
#line 30 "../core/Settings.vala"
		break;
#line 804 "Settings.c"
		default:
#line 30 "../core/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../core/Settings.vala"
		break;
#line 810 "Settings.c"
	}
}

static inline gpointer
noise_settings_equalizer_get_instance_private (NoiseSettingsEqualizer* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseSettingsEqualizer_private_offset);
}

NoiseSettingsEqualizer*
noise_settings_equalizer_get_default (void)
{
	NoiseSettingsEqualizer* result = NULL;
	NoiseSettingsEqualizer* _tmp0_;
	NoiseSettingsEqualizer* _tmp2_;
	NoiseSettingsEqualizer* _tmp3_;
#line 71 "../core/Settings.vala"
	_tmp0_ = noise_settings_equalizer_equalizer;
#line 71 "../core/Settings.vala"
	if (_tmp0_ == NULL) {
#line 831 "Settings.c"
		NoiseSettingsEqualizer* _tmp1_;
#line 72 "../core/Settings.vala"
		_tmp1_ = noise_settings_equalizer_new ();
#line 72 "../core/Settings.vala"
		_g_object_unref0 (noise_settings_equalizer_equalizer);
#line 72 "../core/Settings.vala"
		noise_settings_equalizer_equalizer = _tmp1_;
#line 839 "Settings.c"
	}
#line 73 "../core/Settings.vala"
	_tmp2_ = noise_settings_equalizer_equalizer;
#line 73 "../core/Settings.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 73 "../core/Settings.vala"
	result = _tmp3_;
#line 73 "../core/Settings.vala"
	return result;
#line 849 "Settings.c"
}

static NoiseSettingsEqualizer*
noise_settings_equalizer_construct (GType object_type)
{
	NoiseSettingsEqualizer * self = NULL;
#line 77 "../core/Settings.vala"
	self = (NoiseSettingsEqualizer*) granite_services_settings_construct (object_type, "io.elementary.music.equalizer");
#line 76 "../core/Settings.vala"
	return self;
#line 860 "Settings.c"
}

static NoiseSettingsEqualizer*
noise_settings_equalizer_new (void)
{
#line 76 "../core/Settings.vala"
	return noise_settings_equalizer_construct (NOISE_SETTINGS_TYPE_EQUALIZER);
#line 868 "Settings.c"
}

GeeCollection*
noise_settings_equalizer_get_presets (NoiseSettingsEqualizer* self)
{
	GeeCollection* result = NULL;
	GeeTreeSet* presets_data = NULL;
	GeeTreeSet* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** _tmp2_;
	gint _tmp2__length1;
	GeeTreeSet* rv = NULL;
	GeeTreeSet* _tmp11_;
	GeeTreeSet* _tmp21_;
	GeeBidirSortedSet* _tmp22_;
	GeeBidirSortedSet* _tmp23_;
#line 80 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 81 "../core/Settings.vala"
	_tmp0_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 81 "../core/Settings.vala"
	presets_data = _tmp0_;
#line 83 "../core/Settings.vala"
	_tmp1_ = noise_settings_equalizer_get_custom_presets (self, &_tmp1__length1);
#line 83 "../core/Settings.vala"
	_tmp2_ = _tmp1_;
#line 83 "../core/Settings.vala"
	_tmp2__length1 = _tmp1__length1;
#line 83 "../core/Settings.vala"
	if (_tmp2_ != NULL) {
#line 900 "Settings.c"
		{
			gint i = 0;
#line 84 "../core/Settings.vala"
			i = 0;
#line 905 "Settings.c"
			{
				gboolean _tmp3_ = FALSE;
#line 84 "../core/Settings.vala"
				_tmp3_ = TRUE;
#line 84 "../core/Settings.vala"
				while (TRUE) {
#line 912 "Settings.c"
					gchar** _tmp5_;
					gint _tmp5__length1;
					gchar** _tmp6_;
					gint _tmp6__length1;
					GeeTreeSet* _tmp7_;
					gchar** _tmp8_;
					gint _tmp8__length1;
					gchar** _tmp9_;
					gint _tmp9__length1;
					const gchar* _tmp10_;
#line 84 "../core/Settings.vala"
					if (!_tmp3_) {
#line 925 "Settings.c"
						gint _tmp4_;
#line 84 "../core/Settings.vala"
						_tmp4_ = i;
#line 84 "../core/Settings.vala"
						i = _tmp4_ + 1;
#line 931 "Settings.c"
					}
#line 84 "../core/Settings.vala"
					_tmp3_ = FALSE;
#line 84 "../core/Settings.vala"
					_tmp5_ = noise_settings_equalizer_get_custom_presets (self, &_tmp5__length1);
#line 84 "../core/Settings.vala"
					_tmp6_ = _tmp5_;
#line 84 "../core/Settings.vala"
					_tmp6__length1 = _tmp5__length1;
#line 84 "../core/Settings.vala"
					if (!(i < _tmp6__length1)) {
#line 84 "../core/Settings.vala"
						break;
#line 945 "Settings.c"
					}
#line 85 "../core/Settings.vala"
					_tmp7_ = presets_data;
#line 85 "../core/Settings.vala"
					_tmp8_ = noise_settings_equalizer_get_custom_presets (self, &_tmp8__length1);
#line 85 "../core/Settings.vala"
					_tmp9_ = _tmp8_;
#line 85 "../core/Settings.vala"
					_tmp9__length1 = _tmp8__length1;
#line 85 "../core/Settings.vala"
					_tmp10_ = _tmp9_[i];
#line 85 "../core/Settings.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp10_);
#line 959 "Settings.c"
				}
			}
		}
	}
#line 89 "../core/Settings.vala"
	_tmp11_ = gee_tree_set_new (NOISE_TYPE_EQUALIZER_PRESET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 89 "../core/Settings.vala"
	rv = _tmp11_;
#line 968 "Settings.c"
	{
		GeeIterator* _preset_str_it = NULL;
		GeeTreeSet* _tmp12_;
		GeeIterator* _tmp13_;
#line 91 "../core/Settings.vala"
		_tmp12_ = presets_data;
#line 91 "../core/Settings.vala"
		_tmp13_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp12_);
#line 91 "../core/Settings.vala"
		_preset_str_it = _tmp13_;
#line 91 "../core/Settings.vala"
		while (TRUE) {
#line 981 "Settings.c"
			GeeIterator* _tmp14_;
			gchar* preset_str = NULL;
			GeeIterator* _tmp15_;
			gpointer _tmp16_;
			GeeTreeSet* _tmp17_;
			const gchar* _tmp18_;
			NoiseEqualizerPreset* _tmp19_;
			NoiseEqualizerPreset* _tmp20_;
#line 91 "../core/Settings.vala"
			_tmp14_ = _preset_str_it;
#line 91 "../core/Settings.vala"
			if (!gee_iterator_next (_tmp14_)) {
#line 91 "../core/Settings.vala"
				break;
#line 996 "Settings.c"
			}
#line 91 "../core/Settings.vala"
			_tmp15_ = _preset_str_it;
#line 91 "../core/Settings.vala"
			_tmp16_ = gee_iterator_get (_tmp15_);
#line 91 "../core/Settings.vala"
			preset_str = (gchar*) _tmp16_;
#line 92 "../core/Settings.vala"
			_tmp17_ = rv;
#line 92 "../core/Settings.vala"
			_tmp18_ = preset_str;
#line 92 "../core/Settings.vala"
			_tmp19_ = noise_equalizer_preset_new_from_string (_tmp18_);
#line 92 "../core/Settings.vala"
			_tmp20_ = _tmp19_;
#line 92 "../core/Settings.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp20_);
#line 92 "../core/Settings.vala"
			_g_object_unref0 (_tmp20_);
#line 91 "../core/Settings.vala"
			_g_free0 (preset_str);
#line 1018 "Settings.c"
		}
#line 91 "../core/Settings.vala"
		_g_object_unref0 (_preset_str_it);
#line 1022 "Settings.c"
	}
#line 95 "../core/Settings.vala"
	_tmp21_ = rv;
#line 95 "../core/Settings.vala"
	_tmp22_ = gee_abstract_bidir_sorted_set_get_read_only_view ((GeeAbstractBidirSortedSet*) _tmp21_);
#line 95 "../core/Settings.vala"
	_tmp23_ = _tmp22_;
#line 95 "../core/Settings.vala"
	result = (GeeCollection*) _tmp23_;
#line 95 "../core/Settings.vala"
	_g_object_unref0 (rv);
#line 95 "../core/Settings.vala"
	_g_object_unref0 (presets_data);
#line 95 "../core/Settings.vala"
	return result;
#line 1038 "Settings.c"
}

gboolean
noise_settings_equalizer_get_equalizer_enabled (NoiseSettingsEqualizer* self)
{
	gboolean result;
#line 63 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 63 "../core/Settings.vala"
	result = self->priv->_equalizer_enabled;
#line 63 "../core/Settings.vala"
	return result;
#line 1051 "Settings.c"
}

void
noise_settings_equalizer_set_equalizer_enabled (NoiseSettingsEqualizer* self,
                                                gboolean value)
{
#line 63 "../core/Settings.vala"
	g_return_if_fail (self != NULL);
#line 63 "../core/Settings.vala"
	if (noise_settings_equalizer_get_equalizer_enabled (self) != value) {
#line 63 "../core/Settings.vala"
		self->priv->_equalizer_enabled = value;
#line 63 "../core/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_settings_equalizer_properties[NOISE_SETTINGS_EQUALIZER_EQUALIZER_ENABLED_PROPERTY]);
#line 1066 "Settings.c"
	}
}

gboolean
noise_settings_equalizer_get_auto_switch_preset (NoiseSettingsEqualizer* self)
{
	gboolean result;
#line 64 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 64 "../core/Settings.vala"
	result = self->priv->_auto_switch_preset;
#line 64 "../core/Settings.vala"
	return result;
#line 1080 "Settings.c"
}

void
noise_settings_equalizer_set_auto_switch_preset (NoiseSettingsEqualizer* self,
                                                 gboolean value)
{
#line 64 "../core/Settings.vala"
	g_return_if_fail (self != NULL);
#line 64 "../core/Settings.vala"
	if (noise_settings_equalizer_get_auto_switch_preset (self) != value) {
#line 64 "../core/Settings.vala"
		self->priv->_auto_switch_preset = value;
#line 64 "../core/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_settings_equalizer_properties[NOISE_SETTINGS_EQUALIZER_AUTO_SWITCH_PRESET_PROPERTY]);
#line 1095 "Settings.c"
	}
}

const gchar*
noise_settings_equalizer_get_selected_preset (NoiseSettingsEqualizer* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 65 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "../core/Settings.vala"
	_tmp0_ = self->priv->_selected_preset;
#line 65 "../core/Settings.vala"
	result = _tmp0_;
#line 65 "../core/Settings.vala"
	return result;
#line 1112 "Settings.c"
}

void
noise_settings_equalizer_set_selected_preset (NoiseSettingsEqualizer* self,
                                              const gchar* value)
{
#line 65 "../core/Settings.vala"
	g_return_if_fail (self != NULL);
#line 65 "../core/Settings.vala"
	if (g_strcmp0 (value, noise_settings_equalizer_get_selected_preset (self)) != 0) {
#line 1123 "Settings.c"
		gchar* _tmp0_;
#line 65 "../core/Settings.vala"
		_tmp0_ = g_strdup (value);
#line 65 "../core/Settings.vala"
		_g_free0 (self->priv->_selected_preset);
#line 65 "../core/Settings.vala"
		self->priv->_selected_preset = _tmp0_;
#line 65 "../core/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_settings_equalizer_properties[NOISE_SETTINGS_EQUALIZER_SELECTED_PRESET_PROPERTY]);
#line 1133 "Settings.c"
	}
}

gchar**
noise_settings_equalizer_get_custom_presets (NoiseSettingsEqualizer* self,
                                             gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 66 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../core/Settings.vala"
	_tmp0_ = self->priv->_custom_presets;
#line 66 "../core/Settings.vala"
	_tmp0__length1 = self->priv->_custom_presets_length1;
#line 66 "../core/Settings.vala"
	_tmp1_ = _tmp0_;
#line 66 "../core/Settings.vala"
	_tmp1__length1 = _tmp0__length1;
#line 66 "../core/Settings.vala"
	if (result_length1) {
#line 66 "../core/Settings.vala"
		*result_length1 = _tmp1__length1;
#line 1160 "Settings.c"
	}
#line 66 "../core/Settings.vala"
	result = _tmp1_;
#line 66 "../core/Settings.vala"
	return result;
#line 1166 "Settings.c"
}

static gchar**
_vala_array_dup2 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
#line 66 "../core/Settings.vala"
	result = g_new0 (gchar*, length + 1);
#line 66 "../core/Settings.vala"
	for (i = 0; i < length; i++) {
#line 1179 "Settings.c"
		gchar* _tmp0_;
#line 66 "../core/Settings.vala"
		_tmp0_ = g_strdup (self[i]);
#line 66 "../core/Settings.vala"
		result[i] = _tmp0_;
#line 1185 "Settings.c"
	}
#line 66 "../core/Settings.vala"
	return result;
#line 1189 "Settings.c"
}

void
noise_settings_equalizer_set_custom_presets (NoiseSettingsEqualizer* self,
                                             gchar** value,
                                             gint value_length1)
{
	gint old_value_length;
#line 66 "../core/Settings.vala"
	g_return_if_fail (self != NULL);
#line 66 "../core/Settings.vala"
	if (noise_settings_equalizer_get_custom_presets (self, &old_value_length) != value) {
#line 1202 "Settings.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 66 "../core/Settings.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup2 (value, value_length1) : ((gpointer) value);
#line 66 "../core/Settings.vala"
		_tmp0__length1 = value_length1;
#line 66 "../core/Settings.vala"
		self->priv->_custom_presets = (_vala_array_free (self->priv->_custom_presets, self->priv->_custom_presets_length1, (GDestroyNotify) g_free), NULL);
#line 66 "../core/Settings.vala"
		self->priv->_custom_presets = _tmp0_;
#line 66 "../core/Settings.vala"
		self->priv->_custom_presets_length1 = _tmp0__length1;
#line 66 "../core/Settings.vala"
		self->priv->__custom_presets_size_ = self->priv->_custom_presets_length1;
#line 66 "../core/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_settings_equalizer_properties[NOISE_SETTINGS_EQUALIZER_CUSTOM_PRESETS_PROPERTY]);
#line 1219 "Settings.c"
	}
}

static void
noise_settings_equalizer_class_init (NoiseSettingsEqualizerClass * klass,
                                     gpointer klass_data)
{
#line 61 "../core/Settings.vala"
	noise_settings_equalizer_parent_class = g_type_class_peek_parent (klass);
#line 61 "../core/Settings.vala"
	g_type_class_adjust_private_offset (klass, &NoiseSettingsEqualizer_private_offset);
#line 61 "../core/Settings.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_settings_equalizer_get_property;
#line 61 "../core/Settings.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_settings_equalizer_set_property;
#line 61 "../core/Settings.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_settings_equalizer_finalize;
#line 61 "../core/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SETTINGS_EQUALIZER_EQUALIZER_ENABLED_PROPERTY, noise_settings_equalizer_properties[NOISE_SETTINGS_EQUALIZER_EQUALIZER_ENABLED_PROPERTY] = g_param_spec_boolean ("equalizer-enabled", "equalizer-enabled", "equalizer-enabled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 61 "../core/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SETTINGS_EQUALIZER_AUTO_SWITCH_PRESET_PROPERTY, noise_settings_equalizer_properties[NOISE_SETTINGS_EQUALIZER_AUTO_SWITCH_PRESET_PROPERTY] = g_param_spec_boolean ("auto-switch-preset", "auto-switch-preset", "auto-switch-preset", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 61 "../core/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SETTINGS_EQUALIZER_SELECTED_PRESET_PROPERTY, noise_settings_equalizer_properties[NOISE_SETTINGS_EQUALIZER_SELECTED_PRESET_PROPERTY] = g_param_spec_string ("selected-preset", "selected-preset", "selected-preset", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 61 "../core/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SETTINGS_EQUALIZER_CUSTOM_PRESETS_PROPERTY, noise_settings_equalizer_properties[NOISE_SETTINGS_EQUALIZER_CUSTOM_PRESETS_PROPERTY] = g_param_spec_boxed ("custom-presets", "custom-presets", "custom-presets", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1245 "Settings.c"
}

static void
noise_settings_equalizer_instance_init (NoiseSettingsEqualizer * self,
                                        gpointer klass)
{
#line 61 "../core/Settings.vala"
	self->priv = noise_settings_equalizer_get_instance_private (self);
#line 1254 "Settings.c"
}

static void
noise_settings_equalizer_finalize (GObject * obj)
{
	NoiseSettingsEqualizer * self;
#line 61 "../core/Settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_SETTINGS_TYPE_EQUALIZER, NoiseSettingsEqualizer);
#line 65 "../core/Settings.vala"
	_g_free0 (self->priv->_selected_preset);
#line 66 "../core/Settings.vala"
	self->priv->_custom_presets = (_vala_array_free (self->priv->_custom_presets, self->priv->_custom_presets_length1, (GDestroyNotify) g_free), NULL);
#line 61 "../core/Settings.vala"
	G_OBJECT_CLASS (noise_settings_equalizer_parent_class)->finalize (obj);
#line 1269 "Settings.c"
}

GType
noise_settings_equalizer_get_type (void)
{
	static volatile gsize noise_settings_equalizer_type_id__volatile = 0;
	if (g_once_init_enter (&noise_settings_equalizer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSettingsEqualizerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_settings_equalizer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSettingsEqualizer), 0, (GInstanceInitFunc) noise_settings_equalizer_instance_init, NULL };
		GType noise_settings_equalizer_type_id;
		noise_settings_equalizer_type_id = g_type_register_static (GRANITE_SERVICES_TYPE_SETTINGS, "NoiseSettingsEqualizer", &g_define_type_info, 0);
		NoiseSettingsEqualizer_private_offset = g_type_add_instance_private (noise_settings_equalizer_type_id, sizeof (NoiseSettingsEqualizerPrivate));
		g_once_init_leave (&noise_settings_equalizer_type_id__volatile, noise_settings_equalizer_type_id);
	}
	return noise_settings_equalizer_type_id__volatile;
}

static void
_vala_noise_settings_equalizer_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	NoiseSettingsEqualizer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_SETTINGS_TYPE_EQUALIZER, NoiseSettingsEqualizer);
#line 61 "../core/Settings.vala"
	switch (property_id) {
#line 61 "../core/Settings.vala"
		case NOISE_SETTINGS_EQUALIZER_EQUALIZER_ENABLED_PROPERTY:
#line 61 "../core/Settings.vala"
		g_value_set_boolean (value, noise_settings_equalizer_get_equalizer_enabled (self));
#line 61 "../core/Settings.vala"
		break;
#line 61 "../core/Settings.vala"
		case NOISE_SETTINGS_EQUALIZER_AUTO_SWITCH_PRESET_PROPERTY:
#line 61 "../core/Settings.vala"
		g_value_set_boolean (value, noise_settings_equalizer_get_auto_switch_preset (self));
#line 61 "../core/Settings.vala"
		break;
#line 61 "../core/Settings.vala"
		case NOISE_SETTINGS_EQUALIZER_SELECTED_PRESET_PROPERTY:
#line 61 "../core/Settings.vala"
		g_value_set_string (value, noise_settings_equalizer_get_selected_preset (self));
#line 61 "../core/Settings.vala"
		break;
#line 61 "../core/Settings.vala"
		case NOISE_SETTINGS_EQUALIZER_CUSTOM_PRESETS_PROPERTY:
#line 1316 "Settings.c"
		{
			int length;
#line 61 "../core/Settings.vala"
			g_value_set_boxed (value, noise_settings_equalizer_get_custom_presets (self, &length));
#line 1321 "Settings.c"
		}
#line 61 "../core/Settings.vala"
		break;
#line 1325 "Settings.c"
		default:
#line 61 "../core/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 61 "../core/Settings.vala"
		break;
#line 1331 "Settings.c"
	}
}

static void
_vala_noise_settings_equalizer_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	NoiseSettingsEqualizer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_SETTINGS_TYPE_EQUALIZER, NoiseSettingsEqualizer);
#line 61 "../core/Settings.vala"
	switch (property_id) {
#line 61 "../core/Settings.vala"
		case NOISE_SETTINGS_EQUALIZER_EQUALIZER_ENABLED_PROPERTY:
#line 61 "../core/Settings.vala"
		noise_settings_equalizer_set_equalizer_enabled (self, g_value_get_boolean (value));
#line 61 "../core/Settings.vala"
		break;
#line 61 "../core/Settings.vala"
		case NOISE_SETTINGS_EQUALIZER_AUTO_SWITCH_PRESET_PROPERTY:
#line 61 "../core/Settings.vala"
		noise_settings_equalizer_set_auto_switch_preset (self, g_value_get_boolean (value));
#line 61 "../core/Settings.vala"
		break;
#line 61 "../core/Settings.vala"
		case NOISE_SETTINGS_EQUALIZER_SELECTED_PRESET_PROPERTY:
#line 61 "../core/Settings.vala"
		noise_settings_equalizer_set_selected_preset (self, g_value_get_string (value));
#line 61 "../core/Settings.vala"
		break;
#line 61 "../core/Settings.vala"
		case NOISE_SETTINGS_EQUALIZER_CUSTOM_PRESETS_PROPERTY:
#line 1365 "Settings.c"
		{
			gpointer boxed;
#line 61 "../core/Settings.vala"
			boxed = g_value_get_boxed (value);
#line 61 "../core/Settings.vala"
			noise_settings_equalizer_set_custom_presets (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 1372 "Settings.c"
		}
#line 61 "../core/Settings.vala"
		break;
#line 1376 "Settings.c"
		default:
#line 61 "../core/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 61 "../core/Settings.vala"
		break;
#line 1382 "Settings.c"
	}
}

GType
noise_settings_shuffle_get_type (void)
{
	static volatile gsize noise_settings_shuffle_type_id__volatile = 0;
	if (g_once_init_enter (&noise_settings_shuffle_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_SETTINGS_SHUFFLE_OFF, "NOISE_SETTINGS_SHUFFLE_OFF", "off"}, {NOISE_SETTINGS_SHUFFLE_ALL, "NOISE_SETTINGS_SHUFFLE_ALL", "all"}, {0, NULL, NULL}};
		GType noise_settings_shuffle_type_id;
		noise_settings_shuffle_type_id = g_enum_register_static ("NoiseSettingsShuffle", values);
		g_once_init_leave (&noise_settings_shuffle_type_id__volatile, noise_settings_shuffle_type_id);
	}
	return noise_settings_shuffle_type_id__volatile;
}

GType
noise_settings_repeat_get_type (void)
{
	static volatile gsize noise_settings_repeat_type_id__volatile = 0;
	if (g_once_init_enter (&noise_settings_repeat_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_SETTINGS_REPEAT_OFF, "NOISE_SETTINGS_REPEAT_OFF", "off"}, {NOISE_SETTINGS_REPEAT_MEDIA, "NOISE_SETTINGS_REPEAT_MEDIA", "media"}, {NOISE_SETTINGS_REPEAT_ALL, "NOISE_SETTINGS_REPEAT_ALL", "all"}, {NOISE_SETTINGS_REPEAT_ALBUM, "NOISE_SETTINGS_REPEAT_ALBUM", "album"}, {NOISE_SETTINGS_REPEAT_ARTIST, "NOISE_SETTINGS_REPEAT_ARTIST", "artist"}, {0, NULL, NULL}};
		GType noise_settings_repeat_type_id;
		noise_settings_repeat_type_id = g_enum_register_static ("NoiseSettingsRepeat", values);
		g_once_init_leave (&noise_settings_repeat_type_id__volatile, noise_settings_repeat_type_id);
	}
	return noise_settings_repeat_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

