/* LocalSmartPlaylist.c generated by valac 0.45.3, the Vala compiler
 * generated from LocalSmartPlaylist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <glib-object.h>
#include <libgda/libgda.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib/gi18n-lib.h>

#define NOISE_TYPE_LOCAL_SMART_PLAYLIST (noise_local_smart_playlist_get_type ())
#define NOISE_LOCAL_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylist))
#define NOISE_LOCAL_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylistClass))
#define NOISE_IS_LOCAL_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LOCAL_SMART_PLAYLIST))
#define NOISE_IS_LOCAL_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LOCAL_SMART_PLAYLIST))
#define NOISE_LOCAL_SMART_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylistClass))

typedef struct _NoiseLocalSmartPlaylist NoiseLocalSmartPlaylist;
typedef struct _NoiseLocalSmartPlaylistClass NoiseLocalSmartPlaylistClass;
typedef struct _NoiseLocalSmartPlaylistPrivate NoiseLocalSmartPlaylistPrivate;
enum  {
	NOISE_LOCAL_SMART_PLAYLIST_0_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _NoiseLocalSmartPlaylist {
	NoiseSmartPlaylist parent_instance;
	NoiseLocalSmartPlaylistPrivate * priv;
};

struct _NoiseLocalSmartPlaylistClass {
	NoiseSmartPlaylistClass parent_class;
};

struct _NoiseLocalSmartPlaylistPrivate {
	GdaConnection* connection;
	gchar* _name;
};

static gint NoiseLocalSmartPlaylist_private_offset;
static gpointer noise_local_smart_playlist_parent_class = NULL;

GType noise_local_smart_playlist_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NoiseLocalSmartPlaylist, g_object_unref)
#define NOISE_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR "<query_sep>"
#define NOISE_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR "<val_sep>"
NoiseLocalSmartPlaylist* noise_local_smart_playlist_new (gint64 rowid,
                                                         GdaConnection* connection);
NoiseLocalSmartPlaylist* noise_local_smart_playlist_construct (GType object_type,
                                                               gint64 rowid,
                                                               GdaConnection* connection);
GValue* noise_database_query_field (gint64 rowid,
                                    GdaConnection* connection,
                                    const gchar* table,
                                    const gchar* field);
#define NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME "smart_playlists"
static void _vala_GValue_free (GValue* self);
void noise_local_smart_playlist_queries_from_string (NoiseLocalSmartPlaylist* self,
                                                     const gchar* q);
static void noise_local_smart_playlist_real_analyse_all (NoiseSmartPlaylist* base);
static gint64* _int64_dup (gint64* self);
#define NOISE_DATABASE_MEDIA_TABLE_NAME "media"
GdaSqlBuilderId noise_database_process_smart_query (GdaSqlBuilder* builder,
                                                    NoiseSmartQuery* sq);
static void _vala_array_add2 (GdaSqlBuilderId* * array,
                       int* length,
                       int* size,
                       GdaSqlBuilderId value);
static void noise_local_smart_playlist_real_clear_queries (NoiseSmartPlaylist* base);
void noise_database_set_field (gint64 rowid,
                               GdaConnection* connection,
                               const gchar* table,
                               const gchar* field,
                               GValue* value);
static void noise_local_smart_playlist_real_add_query (NoiseSmartPlaylist* base,
                                                NoiseSmartQuery* s);
static gchar* noise_local_smart_playlist_queries_to_string (NoiseLocalSmartPlaylist* self);
static void noise_local_smart_playlist_real_add_queries (NoiseSmartPlaylist* base,
                                                  GeeCollection* queries);
void noise_local_smart_playlist_add_defaults (GdaConnection* connection);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void noise_local_smart_playlist_finalize (GObject * obj);
static void _vala_noise_local_smart_playlist_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_noise_local_smart_playlist_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
noise_local_smart_playlist_get_instance_private (NoiseLocalSmartPlaylist* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseLocalSmartPlaylist_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 84 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return self ? g_object_ref (self) : NULL;
#line 154 "LocalSmartPlaylist.c"
}

static void
_vala_GValue_free (GValue* self)
{
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_unset (self);
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_free (self);
#line 164 "LocalSmartPlaylist.c"
}

NoiseLocalSmartPlaylist*
noise_local_smart_playlist_construct (GType object_type,
                                      gint64 rowid,
                                      GdaConnection* connection)
{
	NoiseLocalSmartPlaylist * self = NULL;
	NoiseLibrariesManager* _tmp0_;
	NoiseLibrary* _tmp1_;
	GdaConnection* _tmp2_;
	gchar* queries_str = NULL;
	GValue* _tmp3_;
	GValue* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 82 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 83 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_libraries_manager;
#line 83 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_->local_library;
#line 83 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) noise_smart_playlist_construct (object_type, _tmp1_);
#line 84 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = _g_object_ref0 (connection);
#line 84 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_object_unref0 (self->priv->connection);
#line 84 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv->connection = _tmp2_;
#line 85 "../src/LocalBackend/LocalSmartPlaylist.vala"
	noise_playlist_set_rowid ((NoisePlaylist*) self, rowid);
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = noise_database_query_field (rowid, connection, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries");
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = _tmp3_;
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp5_ = g_value_get_string (_tmp4_);
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp7_ = _tmp6_;
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (_tmp4_);
#line 86 "../src/LocalBackend/LocalSmartPlaylist.vala"
	queries_str = _tmp7_;
#line 87 "../src/LocalBackend/LocalSmartPlaylist.vala"
	noise_local_smart_playlist_queries_from_string (self, queries_str);
#line 82 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_free0 (queries_str);
#line 82 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return self;
#line 218 "LocalSmartPlaylist.c"
}

NoiseLocalSmartPlaylist*
noise_local_smart_playlist_new (gint64 rowid,
                                GdaConnection* connection)
{
#line 82 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return noise_local_smart_playlist_construct (NOISE_TYPE_LOCAL_SMART_PLAYLIST, rowid, connection);
#line 227 "LocalSmartPlaylist.c"
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 98 "../src/LocalBackend/LocalSmartPlaylist.vala"
	dup = g_new0 (gint64, 1);
#line 98 "../src/LocalBackend/LocalSmartPlaylist.vala"
	memcpy (dup, self, sizeof (gint64));
#line 98 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return dup;
#line 240 "LocalSmartPlaylist.c"
}

static void
_vala_array_add2 (GdaSqlBuilderId* * array,
                  int* length,
                  int* size,
                  GdaSqlBuilderId value)
{
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
	if ((*length) == (*size)) {
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
		*array = g_renew (GdaSqlBuilderId, *array, *size);
#line 255 "LocalSmartPlaylist.c"
	}
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
	(*array)[(*length)++] = value;
#line 259 "LocalSmartPlaylist.c"
}

static void
noise_local_smart_playlist_real_analyse_all (NoiseSmartPlaylist* base)
{
	NoiseLocalSmartPlaylist * self;
	GeeTreeSet* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeTreeSet* rowids = NULL;
	GeeTreeSet* _tmp10_;
	GError* _inner_error0_ = NULL;
#line 90 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 91 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = ((NoiseSmartPlaylist*) self)->queries;
#line 91 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = gee_collection_get_is_empty ((GeeCollection*) _tmp0_);
#line 91 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = _tmp1_;
#line 91 "../src/LocalBackend/LocalSmartPlaylist.vala"
	if (_tmp2_) {
#line 282 "LocalSmartPlaylist.c"
		GeeCollection* meds = NULL;
		NoiseLibrary* _tmp3_;
		NoiseLibrary* _tmp4_;
		GeeCollection* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
#line 92 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp3_ = noise_smart_playlist_get_library ((NoiseSmartPlaylist*) self);
#line 92 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp4_ = _tmp3_;
#line 92 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp5_ = noise_library_get_medias (_tmp4_);
#line 92 "../src/LocalBackend/LocalSmartPlaylist.vala"
		meds = _tmp5_;
#line 93 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp6_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 93 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp7_ = _tmp6_;
#line 93 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp8_ = meds;
#line 93 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gee_array_list_add_all (_tmp7_, _tmp8_);
#line 94 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp9_ = meds;
#line 94 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_signal_emit_by_name ((NoisePlaylist*) self, "media-added", _tmp9_);
#line 95 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (meds);
#line 95 "../src/LocalBackend/LocalSmartPlaylist.vala"
		return;
#line 315 "LocalSmartPlaylist.c"
	}
#line 98 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp10_ = gee_tree_set_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 98 "../src/LocalBackend/LocalSmartPlaylist.vala"
	rowids = _tmp10_;
#line 321 "LocalSmartPlaylist.c"
	{
		GdaSqlBuilder* sql = NULL;
		GdaSqlBuilder* _tmp11_;
		GdaSqlBuilder* _tmp12_;
		GdaSqlBuilder* _tmp13_;
		GdaSqlBuilderId* ids = NULL;
		gint ids_length1;
		gint _ids_size_;
		GdaSqlOperatorType sql_operator_type = 0;
		NoiseSmartPlaylistConditionalType _tmp22_;
		NoiseSmartPlaylistConditionalType _tmp23_;
		GdaSqlBuilderId id_cond = 0U;
		GdaSqlBuilder* _tmp24_;
		GdaSqlOperatorType _tmp25_;
		GdaSqlBuilderId* _tmp26_;
		gint _tmp26__length1;
		GdaSqlBuilder* _tmp27_;
		GdaStatement* statm = NULL;
		GdaSqlBuilder* _tmp28_;
		GdaStatement* _tmp29_;
		GdaDataModel* data_model = NULL;
		GdaConnection* _tmp30_;
		GdaStatement* _tmp31_;
		GdaDataModel* _tmp32_;
		GdaDataModelIter* data_model_iter = NULL;
		GdaDataModel* _tmp33_;
		GdaDataModelIter* _tmp34_;
		GdaDataModelIter* _tmp35_;
		GeeCollection* meds = NULL;
		NoiseLibrary* _tmp41_;
		NoiseLibrary* _tmp42_;
		GeeTreeSet* _tmp43_;
		GeeCollection* _tmp44_;
		GeeArrayList* _tmp45_;
		GeeArrayList* _tmp46_;
		GeeCollection* _tmp47_;
		GeeCollection* _tmp48_;
#line 100 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp11_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
#line 100 "../src/LocalBackend/LocalSmartPlaylist.vala"
		sql = _tmp11_;
#line 101 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp12_ = sql;
#line 101 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_sql_builder_select_add_target (_tmp12_, NOISE_DATABASE_MEDIA_TABLE_NAME, NULL);
#line 102 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp13_ = sql;
#line 102 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_sql_builder_select_add_field (_tmp13_, "rowid", NULL, NULL);
#line 103 "../src/LocalBackend/LocalSmartPlaylist.vala"
		ids = NULL;
#line 103 "../src/LocalBackend/LocalSmartPlaylist.vala"
		ids_length1 = 0;
#line 103 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_ids_size_ = ids_length1;
#line 377 "LocalSmartPlaylist.c"
		{
			GeeIterator* _q_it = NULL;
			GeeTreeSet* _tmp14_;
			GeeIterator* _tmp15_;
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp14_ = ((NoiseSmartPlaylist*) self)->queries;
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_q_it = _tmp15_;
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
			while (TRUE) {
#line 390 "LocalSmartPlaylist.c"
				GeeIterator* _tmp16_;
				NoiseSmartQuery* q = NULL;
				GeeIterator* _tmp17_;
				gpointer _tmp18_;
				GdaSqlBuilderId* _tmp19_;
				gint _tmp19__length1;
				GdaSqlBuilder* _tmp20_;
				NoiseSmartQuery* _tmp21_;
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp16_ = _q_it;
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
				if (!gee_iterator_next (_tmp16_)) {
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
					break;
#line 405 "LocalSmartPlaylist.c"
				}
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp17_ = _q_it;
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp18_ = gee_iterator_get (_tmp17_);
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
				q = (NoiseSmartQuery*) _tmp18_;
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp19_ = ids;
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp19__length1 = ids_length1;
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp20_ = sql;
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp21_ = q;
#line 105 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_vala_array_add2 (&ids, &ids_length1, &_ids_size_, noise_database_process_smart_query (_tmp20_, _tmp21_));
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_g_object_unref0 (q);
#line 425 "LocalSmartPlaylist.c"
			}
#line 104 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (_q_it);
#line 429 "LocalSmartPlaylist.c"
		}
#line 108 "../src/LocalBackend/LocalSmartPlaylist.vala"
		sql_operator_type = GDA_SQL_OPERATOR_TYPE_AND;
#line 109 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp22_ = noise_smart_playlist_get_conditional ((NoiseSmartPlaylist*) self);
#line 109 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp23_ = _tmp22_;
#line 109 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (_tmp23_ == NOISE_SMART_PLAYLIST_CONDITIONAL_TYPE_ANY) {
#line 110 "../src/LocalBackend/LocalSmartPlaylist.vala"
			sql_operator_type = GDA_SQL_OPERATOR_TYPE_OR;
#line 441 "LocalSmartPlaylist.c"
		}
#line 113 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp24_ = sql;
#line 113 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp25_ = sql_operator_type;
#line 113 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp26_ = ids;
#line 113 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp26__length1 = ids_length1;
#line 113 "../src/LocalBackend/LocalSmartPlaylist.vala"
		id_cond = gda_sql_builder_add_cond_v (_tmp24_, _tmp25_, _tmp26_, (gint) _tmp26__length1);
#line 114 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp27_ = sql;
#line 114 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_sql_builder_set_where (_tmp27_, id_cond);
#line 116 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp28_ = sql;
#line 116 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp29_ = gda_sql_builder_get_statement (_tmp28_, &_inner_error0_);
#line 116 "../src/LocalBackend/LocalSmartPlaylist.vala"
		statm = _tmp29_;
#line 116 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../src/LocalBackend/LocalSmartPlaylist.vala"
			ids = (g_free (ids), NULL);
#line 116 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (sql);
#line 469 "LocalSmartPlaylist.c"
			goto __catch67_g_error;
		}
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp30_ = self->priv->connection;
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp31_ = statm;
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp32_ = gda_connection_statement_execute_select (_tmp30_, _tmp31_, NULL, &_inner_error0_);
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
		data_model = _tmp32_;
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (statm);
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
			ids = (g_free (ids), NULL);
#line 117 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (sql);
#line 488 "LocalSmartPlaylist.c"
			goto __catch67_g_error;
		}
#line 118 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp33_ = data_model;
#line 118 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp34_ = gda_data_model_create_iter (_tmp33_);
#line 118 "../src/LocalBackend/LocalSmartPlaylist.vala"
		data_model_iter = _tmp34_;
#line 119 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp35_ = data_model_iter;
#line 119 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_data_model_iter_move_to_row (_tmp35_, -1);
#line 120 "../src/LocalBackend/LocalSmartPlaylist.vala"
		while (TRUE) {
#line 503 "LocalSmartPlaylist.c"
			GdaDataModelIter* _tmp36_;
			GValue* val = NULL;
			GdaDataModelIter* _tmp37_;
			GeeTreeSet* _tmp38_;
			GValue* _tmp39_;
			gint64 _tmp40_;
#line 120 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp36_ = data_model_iter;
#line 120 "../src/LocalBackend/LocalSmartPlaylist.vala"
			if (!gda_data_model_iter_move_next (_tmp36_)) {
#line 120 "../src/LocalBackend/LocalSmartPlaylist.vala"
				break;
#line 516 "LocalSmartPlaylist.c"
			}
#line 121 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp37_ = data_model_iter;
#line 121 "../src/LocalBackend/LocalSmartPlaylist.vala"
			val = gda_data_model_iter_get_value_at (_tmp37_, 0);
#line 122 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp38_ = rowids;
#line 122 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp39_ = val;
#line 122 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp40_ = g_value_get_int64 (_tmp39_);
#line 122 "../src/LocalBackend/LocalSmartPlaylist.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, &_tmp40_);
#line 530 "LocalSmartPlaylist.c"
		}
#line 125 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp41_ = noise_smart_playlist_get_library ((NoiseSmartPlaylist*) self);
#line 125 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp42_ = _tmp41_;
#line 125 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp43_ = rowids;
#line 125 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp44_ = noise_library_medias_from_ids (_tmp42_, (GeeCollection*) _tmp43_);
#line 125 "../src/LocalBackend/LocalSmartPlaylist.vala"
		meds = _tmp44_;
#line 126 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp45_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 126 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp46_ = _tmp45_;
#line 126 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp47_ = meds;
#line 126 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gee_array_list_add_all (_tmp46_, _tmp47_);
#line 127 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp48_ = meds;
#line 127 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_signal_emit_by_name ((NoisePlaylist*) self, "media-added", _tmp48_);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (meds);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (data_model_iter);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (data_model);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (statm);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		ids = (g_free (ids), NULL);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (sql);
#line 566 "LocalSmartPlaylist.c"
	}
	goto __finally67;
	__catch67_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp49_;
		const gchar* _tmp50_;
		GError* _tmp51_;
		const gchar* _tmp52_;
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		e = _inner_error0_;
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_inner_error0_ = NULL;
#line 129 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp49_ = noise_playlist_get_name ((NoisePlaylist*) self);
#line 129 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp50_ = _tmp49_;
#line 129 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp51_ = e;
#line 129 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp52_ = _tmp51_->message;
#line 129 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_critical ("LocalSmartPlaylist.vala:129: Could not query media for smart playlist " \
"%s: %s", _tmp50_, _tmp52_);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_error_free0 (e);
#line 592 "LocalSmartPlaylist.c"
	}
	__finally67:
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (rowids);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_clear_error (&_inner_error0_);
#line 99 "../src/LocalBackend/LocalSmartPlaylist.vala"
		return;
#line 605 "LocalSmartPlaylist.c"
	}
#line 90 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_object_unref0 (rowids);
#line 609 "LocalSmartPlaylist.c"
}

static void
noise_local_smart_playlist_real_clear_queries (NoiseSmartPlaylist* base)
{
	NoiseLocalSmartPlaylist * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
#line 133 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 134 "../src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (noise_local_smart_playlist_parent_class)->clear_queries (G_TYPE_CHECK_INSTANCE_CAST (self, NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylist));
#line 135 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 135 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 135 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 135 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp3_, G_TYPE_STRING);
#line 135 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_string (&_tmp3_, "");
#line 135 "../src/LocalBackend/LocalSmartPlaylist.vala"
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp3_);
#line 135 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
#line 638 "LocalSmartPlaylist.c"
}

static void
noise_local_smart_playlist_real_add_query (NoiseSmartPlaylist* base,
                                           NoiseSmartQuery* s)
{
	NoiseLocalSmartPlaylist * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	gchar* _tmp3_;
	GValue _tmp4_ = {0};
#line 138 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 138 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (s != NULL);
#line 139 "../src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (noise_local_smart_playlist_parent_class)->add_query (G_TYPE_CHECK_INSTANCE_CAST (self, NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylist), s);
#line 140 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 140 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 140 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 140 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = noise_local_smart_playlist_queries_to_string (self);
#line 140 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp4_, G_TYPE_STRING);
#line 140 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_take_string (&_tmp4_, _tmp3_);
#line 140 "../src/LocalBackend/LocalSmartPlaylist.vala"
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp4_);
#line 140 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 673 "LocalSmartPlaylist.c"
}

static void
noise_local_smart_playlist_real_add_queries (NoiseSmartPlaylist* base,
                                             GeeCollection* queries)
{
	NoiseLocalSmartPlaylist * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	gchar* _tmp3_;
	GValue _tmp4_ = {0};
#line 143 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 143 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (queries != NULL);
#line 144 "../src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (noise_local_smart_playlist_parent_class)->add_queries (G_TYPE_CHECK_INSTANCE_CAST (self, NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylist), queries);
#line 145 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 145 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 145 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 145 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = noise_local_smart_playlist_queries_to_string (self);
#line 145 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp4_, G_TYPE_STRING);
#line 145 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_take_string (&_tmp4_, _tmp3_);
#line 145 "../src/LocalBackend/LocalSmartPlaylist.vala"
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp4_);
#line 145 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 708 "LocalSmartPlaylist.c"
}

static gchar*
noise_local_smart_playlist_queries_to_string (NoiseLocalSmartPlaylist* self)
{
	gchar* result = NULL;
	GString* sb = NULL;
	GString* _tmp0_;
	GString* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
#line 148 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 149 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = g_string_new ("");
#line 149 "../src/LocalBackend/LocalSmartPlaylist.vala"
	sb = _tmp0_;
#line 726 "LocalSmartPlaylist.c"
	{
		GeeIterator* _q_it = NULL;
		GeeTreeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 150 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp1_ = ((NoiseSmartPlaylist*) self)->queries;
#line 150 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
#line 150 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_q_it = _tmp2_;
#line 150 "../src/LocalBackend/LocalSmartPlaylist.vala"
		while (TRUE) {
#line 739 "LocalSmartPlaylist.c"
			GeeIterator* _tmp3_;
			NoiseSmartQuery* q = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GString* _tmp6_;
			GString* _tmp8_;
			NoiseSmartQuery* _tmp9_;
			NoiseSmartQueryFieldType _tmp10_;
			NoiseSmartQueryFieldType _tmp11_;
			GString* _tmp12_;
			GString* _tmp13_;
			NoiseSmartQuery* _tmp14_;
			NoiseSmartQueryComparatorType _tmp15_;
			NoiseSmartQueryComparatorType _tmp16_;
			GString* _tmp17_;
			NoiseSmartQuery* _tmp18_;
			GValue _tmp19_ = {0};
			GValue _tmp20_;
#line 150 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp3_ = _q_it;
#line 150 "../src/LocalBackend/LocalSmartPlaylist.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 150 "../src/LocalBackend/LocalSmartPlaylist.vala"
				break;
#line 764 "LocalSmartPlaylist.c"
			}
#line 150 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp4_ = _q_it;
#line 150 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 150 "../src/LocalBackend/LocalSmartPlaylist.vala"
			q = (NoiseSmartQuery*) _tmp5_;
#line 151 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp6_ = sb;
#line 151 "../src/LocalBackend/LocalSmartPlaylist.vala"
			if (_tmp6_->len != ((gssize) 0)) {
#line 776 "LocalSmartPlaylist.c"
				GString* _tmp7_;
#line 152 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp7_ = sb;
#line 152 "../src/LocalBackend/LocalSmartPlaylist.vala"
				g_string_append (_tmp7_, NOISE_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR);
#line 782 "LocalSmartPlaylist.c"
			}
#line 155 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp8_ = sb;
#line 155 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp9_ = q;
#line 155 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp10_ = noise_smart_query_get_field (_tmp9_);
#line 155 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp11_ = _tmp10_;
#line 155 "../src/LocalBackend/LocalSmartPlaylist.vala"
			g_string_append_printf (_tmp8_, "%d", (gint) _tmp11_);
#line 156 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp12_ = sb;
#line 156 "../src/LocalBackend/LocalSmartPlaylist.vala"
			g_string_append (_tmp12_, NOISE_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR);
#line 157 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp13_ = sb;
#line 157 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp14_ = q;
#line 157 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp15_ = noise_smart_query_get_comparator (_tmp14_);
#line 157 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp16_ = _tmp15_;
#line 157 "../src/LocalBackend/LocalSmartPlaylist.vala"
			g_string_append_printf (_tmp13_, "%d", (gint) _tmp16_);
#line 158 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp17_ = sb;
#line 158 "../src/LocalBackend/LocalSmartPlaylist.vala"
			g_string_append (_tmp17_, NOISE_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR);
#line 159 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp18_ = q;
#line 159 "../src/LocalBackend/LocalSmartPlaylist.vala"
			noise_smart_query_get_value (_tmp18_, &_tmp19_);
#line 159 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp20_ = _tmp19_;
#line 159 "../src/LocalBackend/LocalSmartPlaylist.vala"
			if (G_VALUE_TYPE (&_tmp20_) == G_TYPE_STRING) {
#line 820 "LocalSmartPlaylist.c"
				GString* _tmp21_;
				NoiseSmartQuery* _tmp22_;
				GValue _tmp23_ = {0};
				GValue _tmp24_;
				const gchar* _tmp25_;
#line 160 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp21_ = sb;
#line 160 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp22_ = q;
#line 160 "../src/LocalBackend/LocalSmartPlaylist.vala"
				noise_smart_query_get_value (_tmp22_, &_tmp23_);
#line 160 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp24_ = _tmp23_;
#line 160 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp25_ = g_value_get_string (&_tmp24_);
#line 160 "../src/LocalBackend/LocalSmartPlaylist.vala"
				g_string_append (_tmp21_, _tmp25_);
#line 838 "LocalSmartPlaylist.c"
			} else {
				GString* _tmp26_;
				NoiseSmartQuery* _tmp27_;
				GValue _tmp28_ = {0};
				GValue _tmp29_;
#line 162 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp26_ = sb;
#line 162 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp27_ = q;
#line 162 "../src/LocalBackend/LocalSmartPlaylist.vala"
				noise_smart_query_get_value (_tmp27_, &_tmp28_);
#line 162 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp29_ = _tmp28_;
#line 162 "../src/LocalBackend/LocalSmartPlaylist.vala"
				g_string_append_printf (_tmp26_, "%d", g_value_get_int (&_tmp29_));
#line 854 "LocalSmartPlaylist.c"
			}
#line 150 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (q);
#line 858 "LocalSmartPlaylist.c"
		}
#line 150 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (_q_it);
#line 862 "LocalSmartPlaylist.c"
	}
#line 166 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp30_ = sb;
#line 166 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp31_ = _tmp30_->str;
#line 166 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp32_ = g_strdup (_tmp31_);
#line 166 "../src/LocalBackend/LocalSmartPlaylist.vala"
	result = _tmp32_;
#line 166 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_string_free0 (sb);
#line 166 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 876 "LocalSmartPlaylist.c"
}

void
noise_local_smart_playlist_queries_from_string (NoiseLocalSmartPlaylist* self,
                                                const gchar* q)
{
	gchar** queries_in_string = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint queries_in_string_length1;
	gint _queries_in_string_size_;
	GeeTreeSet* new_queries = NULL;
	GeeTreeSet* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GeeTreeSet* _tmp32_;
#line 169 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (q != NULL);
#line 170 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_ = g_strsplit (q, NOISE_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR, 0);
#line 170 "../src/LocalBackend/LocalSmartPlaylist.vala"
	queries_in_string = _tmp1_;
#line 170 "../src/LocalBackend/LocalSmartPlaylist.vala"
	queries_in_string_length1 = _vala_array_length (_tmp0_);
#line 170 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_queries_in_string_size_ = queries_in_string_length1;
#line 171 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = gee_tree_set_new (NOISE_TYPE_SMART_QUERY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 171 "../src/LocalBackend/LocalSmartPlaylist.vala"
	new_queries = _tmp2_;
#line 172 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = queries_in_string;
#line 172 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3__length1 = queries_in_string_length1;
#line 913 "LocalSmartPlaylist.c"
	{
		gchar** query_string_collection = NULL;
		gint query_string_collection_length1 = 0;
		gint _query_string_collection_size_ = 0;
		gint query_string_it = 0;
#line 172 "../src/LocalBackend/LocalSmartPlaylist.vala"
		query_string_collection = _tmp3_;
#line 172 "../src/LocalBackend/LocalSmartPlaylist.vala"
		query_string_collection_length1 = _tmp3__length1;
#line 172 "../src/LocalBackend/LocalSmartPlaylist.vala"
		for (query_string_it = 0; query_string_it < query_string_collection_length1; query_string_it = query_string_it + 1) {
#line 925 "LocalSmartPlaylist.c"
			gchar* _tmp4_;
			gchar* query_string = NULL;
#line 172 "../src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp4_ = g_strdup (query_string_collection[query_string_it]);
#line 172 "../src/LocalBackend/LocalSmartPlaylist.vala"
			query_string = _tmp4_;
#line 932 "LocalSmartPlaylist.c"
			{
				const gchar* _tmp5_;
				gchar** pieces_of_query = NULL;
				const gchar* _tmp6_;
				gchar** _tmp7_;
				gchar** _tmp8_;
				gint pieces_of_query_length1;
				gint _pieces_of_query_size_;
				gint _tmp9_;
				NoiseSmartQuery* sq = NULL;
				NoiseSmartQuery* _tmp10_;
				NoiseSmartQuery* _tmp11_;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				NoiseSmartQuery* _tmp14_;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
				NoiseSmartQuery* _tmp17_;
				NoiseSmartQueryFieldType _tmp18_;
				NoiseSmartQueryFieldType _tmp19_;
				GeeTreeSet* _tmp30_;
				NoiseSmartQuery* _tmp31_;
#line 173 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp5_ = query_string;
#line 173 "../src/LocalBackend/LocalSmartPlaylist.vala"
				if (g_strcmp0 (_tmp5_, "") == 0) {
#line 174 "../src/LocalBackend/LocalSmartPlaylist.vala"
					_g_free0 (query_string);
#line 174 "../src/LocalBackend/LocalSmartPlaylist.vala"
					continue;
#line 965 "LocalSmartPlaylist.c"
				}
#line 176 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp6_ = query_string;
#line 176 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, NOISE_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR, 3);
#line 176 "../src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query = _tmp8_;
#line 176 "../src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query_length1 = _vala_array_length (_tmp7_);
#line 176 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_pieces_of_query_size_ = pieces_of_query_length1;
#line 177 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp9_ = 3;
#line 177 "../src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query = g_renew (gchar*, pieces_of_query, 3);
#line 177 "../src/LocalBackend/LocalSmartPlaylist.vala"
				(_tmp9_ > pieces_of_query_length1) ? memset (pieces_of_query + pieces_of_query_length1, 0, sizeof (gchar*) * (_tmp9_ - pieces_of_query_length1)) : NULL;
#line 177 "../src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query_length1 = _tmp9_;
#line 177 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_pieces_of_query_size_ = _tmp9_;
#line 179 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp10_ = noise_smart_query_new ();
#line 179 "../src/LocalBackend/LocalSmartPlaylist.vala"
				sq = _tmp10_;
#line 180 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp11_ = sq;
#line 180 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp12_ = pieces_of_query;
#line 180 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp12__length1 = pieces_of_query_length1;
#line 180 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp13_ = _tmp12_[0];
#line 180 "../src/LocalBackend/LocalSmartPlaylist.vala"
				noise_smart_query_set_field (_tmp11_, (NoiseSmartQueryFieldType) atoi (_tmp13_));
#line 181 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp14_ = sq;
#line 181 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp15_ = pieces_of_query;
#line 181 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp15__length1 = pieces_of_query_length1;
#line 181 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp16_ = _tmp15_[1];
#line 181 "../src/LocalBackend/LocalSmartPlaylist.vala"
				noise_smart_query_set_comparator (_tmp14_, (NoiseSmartQueryComparatorType) atoi (_tmp16_));
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp17_ = sq;
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp18_ = noise_smart_query_get_field (_tmp17_);
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp19_ = _tmp18_;
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
				switch (_tmp19_) {
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_ALBUM:
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_ARTIST:
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_COMPOSER:
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_COMMENT:
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_GENRE:
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_GROUPING:
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_TITLE:
#line 182 "../src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_URI:
#line 1035 "LocalSmartPlaylist.c"
					{
						GValue val = {0};
						GValue _tmp20_ = {0};
						gchar** _tmp21_;
						gint _tmp21__length1;
						const gchar* _tmp22_;
						NoiseSmartQuery* _tmp23_;
						GValue _tmp24_;
#line 191 "../src/LocalBackend/LocalSmartPlaylist.vala"
						g_value_init (&_tmp20_, G_TYPE_STRING);
#line 191 "../src/LocalBackend/LocalSmartPlaylist.vala"
						val = _tmp20_;
#line 192 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp21_ = pieces_of_query;
#line 192 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp21__length1 = pieces_of_query_length1;
#line 192 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp22_ = _tmp21_[2];
#line 192 "../src/LocalBackend/LocalSmartPlaylist.vala"
						g_value_set_string (&val, _tmp22_);
#line 193 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp23_ = sq;
#line 193 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp24_ = val;
#line 193 "../src/LocalBackend/LocalSmartPlaylist.vala"
						noise_smart_query_set_value (_tmp23_, &_tmp24_);
#line 194 "../src/LocalBackend/LocalSmartPlaylist.vala"
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 194 "../src/LocalBackend/LocalSmartPlaylist.vala"
						break;
#line 1066 "LocalSmartPlaylist.c"
					}
					default:
					{
						GValue val = {0};
						GValue _tmp25_ = {0};
						gchar** _tmp26_;
						gint _tmp26__length1;
						const gchar* _tmp27_;
						NoiseSmartQuery* _tmp28_;
						GValue _tmp29_;
#line 196 "../src/LocalBackend/LocalSmartPlaylist.vala"
						g_value_init (&_tmp25_, G_TYPE_INT);
#line 196 "../src/LocalBackend/LocalSmartPlaylist.vala"
						val = _tmp25_;
#line 197 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp26_ = pieces_of_query;
#line 197 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp26__length1 = pieces_of_query_length1;
#line 197 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp27_ = _tmp26_[2];
#line 197 "../src/LocalBackend/LocalSmartPlaylist.vala"
						g_value_set_int (&val, atoi (_tmp27_));
#line 198 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp28_ = sq;
#line 198 "../src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp29_ = val;
#line 198 "../src/LocalBackend/LocalSmartPlaylist.vala"
						noise_smart_query_set_value (_tmp28_, &_tmp29_);
#line 199 "../src/LocalBackend/LocalSmartPlaylist.vala"
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 199 "../src/LocalBackend/LocalSmartPlaylist.vala"
						break;
#line 1099 "LocalSmartPlaylist.c"
					}
				}
#line 202 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp30_ = new_queries;
#line 202 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp31_ = sq;
#line 202 "../src/LocalBackend/LocalSmartPlaylist.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
#line 172 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_g_object_unref0 (sq);
#line 172 "../src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query = (_vala_array_free (pieces_of_query, pieces_of_query_length1, (GDestroyNotify) g_free), NULL);
#line 172 "../src/LocalBackend/LocalSmartPlaylist.vala"
				_g_free0 (query_string);
#line 1114 "LocalSmartPlaylist.c"
			}
		}
	}
#line 204 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp32_ = new_queries;
#line 204 "../src/LocalBackend/LocalSmartPlaylist.vala"
	noise_smart_playlist_add_queries ((NoiseSmartPlaylist*) self, (GeeCollection*) _tmp32_);
#line 169 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_object_unref0 (new_queries);
#line 169 "../src/LocalBackend/LocalSmartPlaylist.vala"
	queries_in_string = (_vala_array_free (queries_in_string, queries_in_string_length1, (GDestroyNotify) g_free), NULL);
#line 1126 "LocalSmartPlaylist.c"
}

static void
__vala_GValue_free0_ (gpointer var)
{
#line 222 "../src/LocalBackend/LocalSmartPlaylist.vala"
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
#line 1134 "LocalSmartPlaylist.c"
}

static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
#line 222 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
#line 1142 "LocalSmartPlaylist.c"
}

static void
_g_free0_ (gpointer var)
{
#line 222 "../src/LocalBackend/LocalSmartPlaylist.vala"
	var = (g_free (var), NULL);
#line 1150 "LocalSmartPlaylist.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 222 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 1158 "LocalSmartPlaylist.c"
}

void
noise_local_smart_playlist_add_defaults (GdaConnection* connection)
{
	GError* _inner_error0_ = NULL;
#line 207 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (connection != NULL);
#line 1167 "LocalSmartPlaylist.c"
	{
		GSList* col_names = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GSList* values = NULL;
		GValue* _tmp5_ = NULL;
		GValue* _tmp6_ = NULL;
		GValue* _tmp7_ = NULL;
		GValue* _tmp8_ = NULL;
		GValue* _tmp9_ = NULL;
		GSList* _tmp10_;
		GSList* _tmp11_;
		GValue* _tmp12_ = NULL;
		GValue* _tmp13_ = NULL;
		GValue* _tmp14_ = NULL;
		GValue* _tmp15_ = NULL;
		GValue* _tmp16_ = NULL;
		GSList* _tmp17_;
		GSList* _tmp18_;
		GValue* _tmp19_ = NULL;
		GValue* _tmp20_ = NULL;
		GValue* _tmp21_ = NULL;
		GValue* _tmp22_ = NULL;
		GValue* _tmp23_ = NULL;
		GSList* _tmp24_;
		GSList* _tmp25_;
		GValue* _tmp26_ = NULL;
		GValue* _tmp27_ = NULL;
		GValue* _tmp28_ = NULL;
		GValue* _tmp29_ = NULL;
		GValue* _tmp30_ = NULL;
		GSList* _tmp31_;
		GSList* _tmp32_;
		GValue* _tmp33_ = NULL;
		GValue* _tmp34_ = NULL;
		GValue* _tmp35_ = NULL;
		GValue* _tmp36_ = NULL;
		GValue* _tmp37_ = NULL;
		GSList* _tmp38_;
		GSList* _tmp39_;
		GValue* _tmp40_ = NULL;
		GValue* _tmp41_ = NULL;
		GValue* _tmp42_ = NULL;
		GValue* _tmp43_ = NULL;
		GValue* _tmp44_ = NULL;
		GSList* _tmp45_;
		GSList* _tmp46_;
#line 209 "../src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = NULL;
#line 210 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp0_ = g_strdup ("name");
#line 210 "../src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp0_);
#line 211 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp1_ = g_strdup ("queries");
#line 211 "../src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp1_);
#line 212 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp2_ = g_strdup ("and_or");
#line 212 "../src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp2_);
#line 213 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp3_ = g_strdup ("limited");
#line 213 "../src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp3_);
#line 214 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp4_ = g_strdup ("limit_amount");
#line 214 "../src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp4_);
#line 216 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 217 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp5_ = g_new0 (GValue, 1);
#line 217 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp5_, G_TYPE_STRING);
#line 217 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp5_, _ ("Favorite Songs"));
#line 217 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp5_);
#line 218 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp6_ = g_new0 (GValue, 1);
#line 218 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp6_, G_TYPE_STRING);
#line 218 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp6_, "10<val_sep>2<val_sep>4<query_sep>12<val_sep>0<val_sep>0<query_sep>11<v" \
"al_sep>6<val_sep>3");
#line 218 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp6_);
#line 219 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp7_ = g_new0 (GValue, 1);
#line 219 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp7_, G_TYPE_INT);
#line 219 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp7_, 1);
#line 219 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp7_);
#line 220 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp8_ = g_new0 (GValue, 1);
#line 220 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp8_, G_TYPE_INT);
#line 220 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp8_, 1);
#line 220 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp8_);
#line 221 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp9_ = g_new0 (GValue, 1);
#line 221 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp9_, G_TYPE_INT);
#line 221 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp9_, 50);
#line 221 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp9_);
#line 222 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp10_ = col_names;
#line 222 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp11_ = values;
#line 222 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (connection, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp10_, _tmp11_, &_inner_error0_);
#line 222 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 222 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1294 "LocalSmartPlaylist.c"
			goto __catch68_g_error;
		}
#line 224 "../src/LocalBackend/LocalSmartPlaylist.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 224 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 225 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp12_ = g_new0 (GValue, 1);
#line 225 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp12_, G_TYPE_STRING);
#line 225 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp12_, _ ("Recently Added"));
#line 225 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp12_);
#line 226 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp13_ = g_new0 (GValue, 1);
#line 226 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp13_, G_TYPE_STRING);
#line 226 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp13_, "5<val_sep>7<val_sep>7");
#line 226 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp13_);
#line 227 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp14_ = g_new0 (GValue, 1);
#line 227 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp14_, G_TYPE_INT);
#line 227 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp14_, 1);
#line 227 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp14_);
#line 228 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp15_ = g_new0 (GValue, 1);
#line 228 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp15_, G_TYPE_INT);
#line 228 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp15_, 1);
#line 228 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp15_);
#line 229 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp16_ = g_new0 (GValue, 1);
#line 229 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp16_, G_TYPE_INT);
#line 229 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp16_, 50);
#line 229 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp16_);
#line 230 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp17_ = col_names;
#line 230 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp18_ = values;
#line 230 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (connection, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp17_, _tmp18_, &_inner_error0_);
#line 230 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 230 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 230 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1353 "LocalSmartPlaylist.c"
			goto __catch68_g_error;
		}
#line 232 "../src/LocalBackend/LocalSmartPlaylist.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 232 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 233 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp19_ = g_new0 (GValue, 1);
#line 233 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp19_, G_TYPE_STRING);
#line 233 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp19_, _ ("Recent Favorites"));
#line 233 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp19_);
#line 234 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp20_ = g_new0 (GValue, 1);
#line 234 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp20_, G_TYPE_STRING);
#line 234 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp20_, "10<val_sep>2<val_sep>4<query_sep>12<val_sep>0<val_sep>0<query_sep>8<va" \
"l_sep>7<val_sep>7");
#line 234 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp20_);
#line 235 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp21_ = g_new0 (GValue, 1);
#line 235 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp21_, G_TYPE_INT);
#line 235 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp21_, 1);
#line 235 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp21_);
#line 236 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp22_ = g_new0 (GValue, 1);
#line 236 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp22_, G_TYPE_INT);
#line 236 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp22_, 1);
#line 236 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp22_);
#line 237 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp23_ = g_new0 (GValue, 1);
#line 237 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp23_, G_TYPE_INT);
#line 237 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp23_, 50);
#line 237 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp23_);
#line 238 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp24_ = col_names;
#line 238 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp25_ = values;
#line 238 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (connection, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp24_, _tmp25_, &_inner_error0_);
#line 238 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 238 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 238 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1412 "LocalSmartPlaylist.c"
			goto __catch68_g_error;
		}
#line 240 "../src/LocalBackend/LocalSmartPlaylist.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 240 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 241 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp26_ = g_new0 (GValue, 1);
#line 241 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp26_, G_TYPE_STRING);
#line 241 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp26_, _ ("Never Played"));
#line 241 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp26_);
#line 242 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp27_ = g_new0 (GValue, 1);
#line 242 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp27_, G_TYPE_STRING);
#line 242 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp27_, "10<val_sep>0<val_sep>0");
#line 242 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp27_);
#line 243 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp28_ = g_new0 (GValue, 1);
#line 243 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp28_, G_TYPE_INT);
#line 243 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp28_, 0);
#line 243 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp28_);
#line 244 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp29_ = g_new0 (GValue, 1);
#line 244 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp29_, G_TYPE_INT);
#line 244 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp29_, 1);
#line 244 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp29_);
#line 245 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp30_ = g_new0 (GValue, 1);
#line 245 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp30_, G_TYPE_INT);
#line 245 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp30_, 50);
#line 245 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp30_);
#line 246 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp31_ = col_names;
#line 246 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp32_ = values;
#line 246 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (connection, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp31_, _tmp32_, &_inner_error0_);
#line 246 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 246 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 246 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1471 "LocalSmartPlaylist.c"
			goto __catch68_g_error;
		}
#line 248 "../src/LocalBackend/LocalSmartPlaylist.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 248 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 249 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp33_ = g_new0 (GValue, 1);
#line 249 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp33_, G_TYPE_STRING);
#line 249 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp33_, _ ("Over Played"));
#line 249 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp33_);
#line 250 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp34_ = g_new0 (GValue, 1);
#line 250 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp34_, G_TYPE_STRING);
#line 250 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp34_, "10<val_sep>6<val_sep>10");
#line 250 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp34_);
#line 251 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp35_ = g_new0 (GValue, 1);
#line 251 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp35_, G_TYPE_INT);
#line 251 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp35_, 1);
#line 251 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp35_);
#line 252 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp36_ = g_new0 (GValue, 1);
#line 252 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp36_, G_TYPE_INT);
#line 252 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp36_, 1);
#line 252 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp36_);
#line 253 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp37_ = g_new0 (GValue, 1);
#line 253 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp37_, G_TYPE_INT);
#line 253 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp37_, 50);
#line 253 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp37_);
#line 254 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp38_ = col_names;
#line 254 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp39_ = values;
#line 254 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (connection, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp38_, _tmp39_, &_inner_error0_);
#line 254 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 254 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 254 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1530 "LocalSmartPlaylist.c"
			goto __catch68_g_error;
		}
#line 256 "../src/LocalBackend/LocalSmartPlaylist.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 256 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 257 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp40_ = g_new0 (GValue, 1);
#line 257 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp40_, G_TYPE_STRING);
#line 257 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp40_, _ ("Not Recently Played"));
#line 257 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp40_);
#line 258 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp41_ = g_new0 (GValue, 1);
#line 258 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp41_, G_TYPE_STRING);
#line 258 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp41_, "8<val_sep>8<val_sep>7");
#line 258 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp41_);
#line 259 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp42_ = g_new0 (GValue, 1);
#line 259 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp42_, G_TYPE_INT);
#line 259 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp42_, 1);
#line 259 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp42_);
#line 260 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp43_ = g_new0 (GValue, 1);
#line 260 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp43_, G_TYPE_INT);
#line 260 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp43_, 1);
#line 260 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp43_);
#line 261 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp44_ = g_new0 (GValue, 1);
#line 261 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp44_, G_TYPE_INT);
#line 261 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp44_, 50);
#line 261 "../src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp44_);
#line 262 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp45_ = col_names;
#line 262 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp46_ = values;
#line 262 "../src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (connection, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp45_, _tmp46_, &_inner_error0_);
#line 262 "../src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 262 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 262 "../src/LocalBackend/LocalSmartPlaylist.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1589 "LocalSmartPlaylist.c"
			goto __catch68_g_error;
		}
#line 208 "../src/LocalBackend/LocalSmartPlaylist.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 208 "../src/LocalBackend/LocalSmartPlaylist.vala"
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1596 "LocalSmartPlaylist.c"
	}
	goto __finally68;
	__catch68_g_error:
	{
		GError* e = NULL;
		GError* _tmp47_;
		const gchar* _tmp48_;
#line 208 "../src/LocalBackend/LocalSmartPlaylist.vala"
		e = _inner_error0_;
#line 208 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_inner_error0_ = NULL;
#line 264 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp47_ = e;
#line 264 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp48_ = _tmp47_->message;
#line 264 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_critical ("LocalSmartPlaylist.vala:264: Could not initialize smart playlists: %s", _tmp48_);
#line 208 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_g_error_free0 (e);
#line 1616 "LocalSmartPlaylist.c"
	}
	__finally68:
#line 208 "../src/LocalBackend/LocalSmartPlaylist.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 208 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 208 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_clear_error (&_inner_error0_);
#line 208 "../src/LocalBackend/LocalSmartPlaylist.vala"
		return;
#line 1627 "LocalSmartPlaylist.c"
	}
}

static const gchar*
noise_local_smart_playlist_real_get_name (NoisePlaylist* base)
{
	const gchar* result;
	NoiseLocalSmartPlaylist* self;
	const gchar* _tmp0_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue* _tmp5_;
	GValue* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
#line 39 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 40 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = self->priv->_name;
#line 40 "../src/LocalBackend/LocalSmartPlaylist.vala"
	if (_tmp0_ != NULL) {
#line 1650 "LocalSmartPlaylist.c"
		const gchar* _tmp1_;
#line 41 "../src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp1_ = self->priv->_name;
#line 41 "../src/LocalBackend/LocalSmartPlaylist.vala"
		result = _tmp1_;
#line 41 "../src/LocalBackend/LocalSmartPlaylist.vala"
		return result;
#line 1658 "LocalSmartPlaylist.c"
	}
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = _tmp2_;
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = self->priv->connection;
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp5_ = noise_database_query_field (_tmp3_, _tmp4_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "name");
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp6_ = _tmp5_;
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp7_ = g_value_dup_string (_tmp6_);
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_free0 (self->priv->_name);
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv->_name = _tmp7_;
#line 43 "../src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (_tmp6_);
#line 44 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp8_ = self->priv->_name;
#line 44 "../src/LocalBackend/LocalSmartPlaylist.vala"
	result = _tmp8_;
#line 44 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 1684 "LocalSmartPlaylist.c"
}

static void
noise_local_smart_playlist_real_set_name (NoisePlaylist* base,
                                          const gchar* value)
{
	NoiseLocalSmartPlaylist* self;
	gchar* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	GdaConnection* _tmp3_;
	GValue _tmp4_ = {0};
#line 47 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 48 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = g_strdup (value);
#line 48 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_free0 (self->priv->_name);
#line 48 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv->_name = _tmp0_;
#line 49 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 49 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = _tmp1_;
#line 49 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = self->priv->connection;
#line 49 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp4_, G_TYPE_STRING);
#line 49 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_string (&_tmp4_, value);
#line 49 "../src/LocalBackend/LocalSmartPlaylist.vala"
	noise_database_set_field (_tmp2_, _tmp3_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "name", &_tmp4_);
#line 49 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 47 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY]);
#line 1721 "LocalSmartPlaylist.c"
}

static NoiseSmartPlaylistConditionalType
noise_local_smart_playlist_real_get_conditional (NoiseSmartPlaylist* base)
{
	NoiseSmartPlaylistConditionalType result;
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
	NoiseSmartPlaylistConditionalType _tmp5_;
#line 55 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = noise_database_query_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "and_or");
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = _tmp3_;
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp5_ = (NoiseSmartPlaylistConditionalType) g_value_get_int (_tmp4_);
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (_tmp4_);
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	result = _tmp5_;
#line 56 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 1755 "LocalSmartPlaylist.c"
}

static void
noise_local_smart_playlist_real_set_conditional (NoiseSmartPlaylist* base,
                                                 NoiseSmartPlaylistConditionalType value)
{
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
#line 58 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 59 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 59 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 59 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 59 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp3_, NOISE_SMART_PLAYLIST_TYPE_CONDITIONAL_TYPE);
#line 59 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_enum (&_tmp3_, value);
#line 59 "../src/LocalBackend/LocalSmartPlaylist.vala"
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "and_or", &_tmp3_);
#line 59 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
#line 58 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY]);
#line 1785 "LocalSmartPlaylist.c"
}

static guint
noise_local_smart_playlist_real_get_limit_amount (NoiseSmartPlaylist* base)
{
	guint result;
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
	guint _tmp5_;
#line 64 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = noise_database_query_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limit_amount");
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = _tmp3_;
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp5_ = (guint) g_value_get_int (_tmp4_);
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (_tmp4_);
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	result = _tmp5_;
#line 65 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 1819 "LocalSmartPlaylist.c"
}

static void
noise_local_smart_playlist_real_set_limit_amount (NoiseSmartPlaylist* base,
                                                  guint value)
{
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
#line 67 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 68 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 68 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 68 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 68 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp3_, G_TYPE_UINT);
#line 68 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_uint (&_tmp3_, value);
#line 68 "../src/LocalBackend/LocalSmartPlaylist.vala"
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limit_amount", &_tmp3_);
#line 68 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
#line 67 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY]);
#line 1849 "LocalSmartPlaylist.c"
}

static gboolean
noise_local_smart_playlist_real_get_limit (NoiseSmartPlaylist* base)
{
	gboolean result;
	NoiseLocalSmartPlaylist* self;
	GValue* val = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
#line 73 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 74 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 74 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 74 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 74 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = noise_database_query_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limited");
#line 74 "../src/LocalBackend/LocalSmartPlaylist.vala"
	val = _tmp3_;
#line 75 "../src/LocalBackend/LocalSmartPlaylist.vala"
	result = (gboolean) g_value_get_int (val);
#line 75 "../src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (val);
#line 75 "../src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 1880 "LocalSmartPlaylist.c"
}

static void
noise_local_smart_playlist_real_set_limit (NoiseSmartPlaylist* base,
                                           gboolean value)
{
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
#line 77 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 78 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 78 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 78 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 78 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp3_, G_TYPE_BOOLEAN);
#line 78 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_boolean (&_tmp3_, value);
#line 78 "../src/LocalBackend/LocalSmartPlaylist.vala"
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limited", &_tmp3_);
#line 78 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
#line 77 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY]);
#line 1910 "LocalSmartPlaylist.c"
}

static void
noise_local_smart_playlist_class_init (NoiseLocalSmartPlaylistClass * klass,
                                       gpointer klass_data)
{
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	noise_local_smart_playlist_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_type_class_adjust_private_offset (klass, &NoiseLocalSmartPlaylist_private_offset);
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	((NoiseSmartPlaylistClass *) klass)->analyse_all = (void (*) (NoiseSmartPlaylist*)) noise_local_smart_playlist_real_analyse_all;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	((NoiseSmartPlaylistClass *) klass)->clear_queries = (void (*) (NoiseSmartPlaylist*)) noise_local_smart_playlist_real_clear_queries;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	((NoiseSmartPlaylistClass *) klass)->add_query = (void (*) (NoiseSmartPlaylist*, NoiseSmartQuery*)) noise_local_smart_playlist_real_add_query;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	((NoiseSmartPlaylistClass *) klass)->add_queries = (void (*) (NoiseSmartPlaylist*, GeeCollection*)) noise_local_smart_playlist_real_add_queries;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_PLAYLIST_CLASS (klass)->get_name = noise_local_smart_playlist_real_get_name;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_PLAYLIST_CLASS (klass)->set_name = noise_local_smart_playlist_real_set_name;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (klass)->get_conditional = noise_local_smart_playlist_real_get_conditional;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (klass)->set_conditional = noise_local_smart_playlist_real_set_conditional;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (klass)->get_limit_amount = noise_local_smart_playlist_real_get_limit_amount;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (klass)->set_limit_amount = noise_local_smart_playlist_real_set_limit_amount;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (klass)->get_limit = noise_local_smart_playlist_real_get_limit;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (klass)->set_limit = noise_local_smart_playlist_real_set_limit;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_local_smart_playlist_get_property;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_local_smart_playlist_set_property;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_local_smart_playlist_finalize;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY] = g_param_spec_enum ("conditional", "conditional", "conditional", NOISE_SMART_PLAYLIST_TYPE_CONDITIONAL_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY] = g_param_spec_uint ("limit-amount", "limit-amount", "limit-amount", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY] = g_param_spec_boolean ("limit", "limit", "limit", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1959 "LocalSmartPlaylist.c"
}

static void
noise_local_smart_playlist_instance_init (NoiseLocalSmartPlaylist * self,
                                          gpointer klass)
{
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv = noise_local_smart_playlist_get_instance_private (self);
#line 37 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv->_name = NULL;
#line 1970 "LocalSmartPlaylist.c"
}

static void
noise_local_smart_playlist_finalize (GObject * obj)
{
	NoiseLocalSmartPlaylist * self;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylist);
#line 32 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_object_unref0 (self->priv->connection);
#line 37 "../src/LocalBackend/LocalSmartPlaylist.vala"
	_g_free0 (self->priv->_name);
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	G_OBJECT_CLASS (noise_local_smart_playlist_parent_class)->finalize (obj);
#line 1985 "LocalSmartPlaylist.c"
}

GType
noise_local_smart_playlist_get_type (void)
{
	static volatile gsize noise_local_smart_playlist_type_id__volatile = 0;
	if (g_once_init_enter (&noise_local_smart_playlist_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseLocalSmartPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_local_smart_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseLocalSmartPlaylist), 0, (GInstanceInitFunc) noise_local_smart_playlist_instance_init, NULL };
		GType noise_local_smart_playlist_type_id;
		noise_local_smart_playlist_type_id = g_type_register_static (NOISE_TYPE_SMART_PLAYLIST, "NoiseLocalSmartPlaylist", &g_define_type_info, 0);
		NoiseLocalSmartPlaylist_private_offset = g_type_add_instance_private (noise_local_smart_playlist_type_id, sizeof (NoiseLocalSmartPlaylistPrivate));
		g_once_init_leave (&noise_local_smart_playlist_type_id__volatile, noise_local_smart_playlist_type_id);
	}
	return noise_local_smart_playlist_type_id__volatile;
}

static void
_vala_noise_local_smart_playlist_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	NoiseLocalSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylist);
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	switch (property_id) {
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (value, noise_playlist_get_name ((NoisePlaylist*) self));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_enum (value, noise_smart_playlist_get_conditional ((NoiseSmartPlaylist*) self));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_uint (value, noise_smart_playlist_get_limit_amount ((NoiseSmartPlaylist*) self));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_boolean (value, noise_smart_playlist_get_limit ((NoiseSmartPlaylist*) self));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 2036 "LocalSmartPlaylist.c"
		default:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 2042 "LocalSmartPlaylist.c"
	}
}

static void
_vala_noise_local_smart_playlist_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	NoiseLocalSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylist);
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
	switch (property_id) {
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		noise_playlist_set_name ((NoisePlaylist*) self, g_value_get_string (value));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		noise_smart_playlist_set_conditional ((NoiseSmartPlaylist*) self, g_value_get_enum (value));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		noise_smart_playlist_set_limit_amount ((NoiseSmartPlaylist*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		noise_smart_playlist_set_limit ((NoiseSmartPlaylist*) self, g_value_get_boolean (value));
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 2080 "LocalSmartPlaylist.c"
		default:
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 2086 "LocalSmartPlaylist.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

