/* Core.c generated by valac 0.45.3, the Vala compiler
 * generated from Core.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>,
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */
/* Merely a place holder for multiple pieces of information regarding
 * the current media playing. Mostly here because of dependence. */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "music-lib.h"
#include "io.elementary.music-core.h"
#include <gee.h>
#include <libsoup/soup.h>
#include <time.h>
#include <json-glib/json-glib.h>

#define LAST_FM_TYPE_CORE (last_fm_core_get_type ())
#define LAST_FM_CORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LAST_FM_TYPE_CORE, LastFMCore))
#define LAST_FM_CORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LAST_FM_TYPE_CORE, LastFMCoreClass))
#define LAST_FM_IS_CORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LAST_FM_TYPE_CORE))
#define LAST_FM_IS_CORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LAST_FM_TYPE_CORE))
#define LAST_FM_CORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LAST_FM_TYPE_CORE, LastFMCoreClass))

typedef struct _LastFMCore LastFMCore;
typedef struct _LastFMCoreClass LastFMCoreClass;
typedef struct _LastFMCorePrivate LastFMCorePrivate;

#define LAST_FM_TYPE_SIMILAR_MEDIAS (last_fm_similar_medias_get_type ())
#define LAST_FM_SIMILAR_MEDIAS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LAST_FM_TYPE_SIMILAR_MEDIAS, LastFMSimilarMedias))
#define LAST_FM_SIMILAR_MEDIAS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LAST_FM_TYPE_SIMILAR_MEDIAS, LastFMSimilarMediasClass))
#define LAST_FM_IS_SIMILAR_MEDIAS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LAST_FM_TYPE_SIMILAR_MEDIAS))
#define LAST_FM_IS_SIMILAR_MEDIAS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LAST_FM_TYPE_SIMILAR_MEDIAS))
#define LAST_FM_SIMILAR_MEDIAS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LAST_FM_TYPE_SIMILAR_MEDIAS, LastFMSimilarMediasClass))

typedef struct _LastFMSimilarMedias LastFMSimilarMedias;
typedef struct _LastFMSimilarMediasClass LastFMSimilarMediasClass;
enum  {
	LAST_FM_CORE_0_PROPERTY,
	LAST_FM_CORE_NUM_PROPERTIES
};
static GParamSpec* last_fm_core_properties[LAST_FM_CORE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _LastFMSimilarMediasPrivate LastFMSimilarMediasPrivate;
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))
typedef struct _LastFmCoreFetchAlbumsSlowlyData LastFmCoreFetchAlbumsSlowlyData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _LastFmCoreGetSimilarTracksData LastFmCoreGetSimilarTracksData;
typedef struct _LastFmCoreGetAlbumInfosData LastFmCoreGetAlbumInfosData;
enum  {
	LAST_FM_CORE_SIMILAR_RETRIEVED_SIGNAL,
	LAST_FM_CORE_LOVED_SIGNAL,
	LAST_FM_CORE_BANED_SIGNAL,
	LAST_FM_CORE_NUM_SIGNALS
};
static guint last_fm_core_signals[LAST_FM_CORE_NUM_SIGNALS] = {0};

struct _LastFMCore {
	GObject parent_instance;
	LastFMCorePrivate * priv;
	gboolean is_initialized;
	gchar* api_key;
	gchar* api_secret;
	gchar* session_key;
};

struct _LastFMCoreClass {
	GObjectClass parent_class;
};

struct _LastFMCorePrivate {
	LastFMSimilarMedias* similarMedias;
	GCancellable* fetch_cancellable;
};

struct _LastFMSimilarMedias {
	GObject parent_instance;
	LastFMSimilarMediasPrivate * priv;
	NoiseStaticPlaylist* similar_playlist;
};

struct _LastFMSimilarMediasClass {
	GObjectClass parent_class;
	void (*query_for_similar) (LastFMSimilarMedias* self, NoiseMedia* s);
};

struct _LastFmCoreFetchAlbumsSlowlyData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	LastFMCore* self;
	GeeCollection* new_medias;
	GeeTreeSet* albums;
	GeeTreeSet* _tmp0_;
	GeeIterator* _media_it;
	GeeIterator* _tmp1_;
	GeeIterator* _tmp2_;
	NoiseMedia* media;
	GeeIterator* _tmp3_;
	gpointer _tmp4_;
	GeeTreeSet* _tmp5_;
	NoiseMedia* _tmp6_;
	NoiseAlbum* _tmp7_;
	NoiseAlbum* _tmp8_;
	GeeTreeSet* _tmp9_;
	NoiseMedia* _tmp10_;
	NoiseAlbum* _tmp11_;
	NoiseAlbum* _tmp12_;
	NoiseMedia* _tmp13_;
	NoiseAlbum* _tmp14_;
	NoiseAlbum* _tmp15_;
	GCancellable* _tmp16_;
};

struct _LastFmCoreGetSimilarTracksData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	LastFMCore* self;
	gchar* title;
	gchar* artist;
	GCancellable* cancellable;
	GeeTreeSet* result;
	GeeTreeSet* returned_medias;
	GeeTreeSet* _tmp0_;
	SoupURI* uri;
	SoupURI* _tmp1_;
	SoupURI* _tmp2_;
	const gchar* _tmp3_;
	SoupSession* session;
	SoupSession* _tmp4_;
	SoupRequest* uri_request;
	SoupSession* _tmp5_;
	SoupURI* _tmp6_;
	SoupRequest* _tmp7_;
	GInputStream* stream;
	SoupRequest* _tmp8_;
	GInputStream* _tmp9_;
	JsonParser* parser;
	JsonParser* _tmp10_;
	JsonParser* _tmp11_;
	GInputStream* _tmp12_;
	JsonObject* parser_object;
	JsonParser* _tmp13_;
	JsonNode* _tmp14_;
	JsonObject* _tmp15_;
	gboolean _tmp16_;
	JsonObject* _tmp17_;
	JsonObject* _tmp18_;
	JsonObject* similartracks;
	JsonObject* _tmp19_;
	JsonObject* _tmp20_;
	gboolean _tmp21_;
	JsonObject* _tmp22_;
	JsonObject* _tmp23_;
	JsonNode* _tmp24_;
	GList* similar_tracks_values;
	JsonObject* _tmp25_;
	JsonArray* _tmp26_;
	GList* _tmp27_;
	GList* _tmp28_;
	GList* element_collection;
	GList* element_it;
	JsonNode* element;
	JsonObject* track_object;
	JsonNode* _tmp29_;
	JsonObject* _tmp30_;
	NoiseMedia* similar_to_add;
	NoiseMedia* _tmp31_;
	GeeTreeSet* _tmp32_;
	NoiseMedia* _tmp33_;
	NoiseMedia* _tmp34_;
	JsonObject* _tmp35_;
	const gchar* _tmp36_;
	JsonObject* _tmp37_;
	NoiseMedia* _tmp38_;
	JsonObject* _tmp39_;
	const gchar* _tmp40_;
	JsonObject* _tmp41_;
	JsonObject* artist_object;
	JsonObject* _tmp42_;
	JsonObject* _tmp43_;
	JsonObject* _tmp44_;
	NoiseMedia* _tmp45_;
	JsonObject* _tmp46_;
	const gchar* _tmp47_;
	GError* e;
	GError* _tmp48_;
	const gchar* _tmp49_;
	GError* _inner_error0_;
};

struct _LastFmCoreGetAlbumInfosData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	LastFMCore* self;
	NoiseAlbum* album;
	GCancellable* cancellable;
	SoupURI* uri;
	SoupURI* _tmp0_;
	SoupURI* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	SoupSession* session;
	SoupSession* _tmp7_;
	SoupRequest* uri_request;
	SoupSession* _tmp8_;
	SoupURI* _tmp9_;
	SoupRequest* _tmp10_;
	GInputStream* stream;
	SoupRequest* _tmp11_;
	GInputStream* _tmp12_;
	JsonParser* parser;
	JsonParser* _tmp13_;
	JsonParser* _tmp14_;
	GInputStream* _tmp15_;
	JsonObject* parser_object;
	JsonParser* _tmp16_;
	JsonNode* _tmp17_;
	JsonObject* _tmp18_;
	gboolean _tmp19_;
	JsonObject* _tmp20_;
	JsonObject* _tmp21_;
	JsonObject* album_object;
	JsonObject* _tmp22_;
	JsonNode* _tmp23_;
	JsonObject* _tmp24_;
	gboolean _tmp25_;
	JsonObject* _tmp26_;
	JsonObject* _tmp27_;
	JsonNode* _tmp28_;
	GList* image_values;
	JsonObject* _tmp29_;
	JsonArray* _tmp30_;
	GList* _tmp31_;
	gchar* image_url;
	gchar* _tmp32_;
	gchar* image_size;
	gchar* _tmp33_;
	GList* _tmp34_;
	GList* element_collection;
	GList* element_it;
	JsonNode* element;
	JsonObject* image_object;
	JsonNode* _tmp35_;
	JsonObject* _tmp36_;
	const gchar* new_size;
	JsonObject* _tmp37_;
	const gchar* _tmp38_;
	gboolean _tmp39_;
	gboolean _tmp40_;
	const gchar* _tmp41_;
	gboolean _tmp42_;
	const gchar* _tmp43_;
	const gchar* _tmp44_;
	gboolean _tmp45_;
	gboolean _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	JsonObject* _tmp50_;
	const gchar* _tmp51_;
	gchar* _tmp52_;
	const gchar* _tmp53_;
	gchar* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	GFile* _tmp58_;
	GFile* _tmp59_;
	gboolean _tmp60_;
	JsonObject* _tmp61_;
	guint _tmp62_;
	guint _tmp63_;
	gchar* releasedate;
	JsonObject* _tmp64_;
	const gchar* _tmp65_;
	gchar* _tmp66_;
	GDate date;
	const gchar* _tmp67_;
	GError* e;
	GError* _tmp68_;
	const gchar* _tmp69_;
	GError* _inner_error0_;
};

static gint LastFMCore_private_offset;
static gpointer last_fm_core_parent_class = NULL;
static LastFMCore* last_fm_core_core;
static LastFMCore* last_fm_core_core = NULL;
static GType last_fm_core_type_id = 0;

GType last_fm_core_register_type (GTypeModule * module);
GType last_fm_core_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LastFMCore, g_object_unref)
GType last_fm_similar_medias_register_type (GTypeModule * module);
GType last_fm_similar_medias_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LastFMSimilarMedias, g_object_unref)
#define LAST_FM_CORE_API_URL "http://ws.audioscrobbler.com/2.0/"
LastFMCore* last_fm_core_get_default (void);
static LastFMCore* last_fm_core_new (void);
static LastFMCore* last_fm_core_construct (GType object_type);
LastFMSimilarMedias* last_fm_similar_medias_new (void);
LastFMSimilarMedias* last_fm_similar_medias_construct (GType object_type);
static void __lambda5_ (LastFMCore* self,
                 NoiseMedia* media);
void last_fm_core_postNowPlaying (LastFMCore* self,
                                  NoiseMedia* m);
static void ___lambda5__noise_library_window_interface_update_media_info (NoiseLibraryWindowInterface* _sender,
                                                                   NoiseMedia* m,
                                                                   gpointer self);
static void __lambda6_ (LastFMCore* self,
                 NoiseMedia* media);
void last_fm_core_postScrobbleTrack (LastFMCore* self,
                                     NoiseMedia* m);
static void ___lambda6__noise_library_window_interface_media_half_played (NoiseLibraryWindowInterface* _sender,
                                                                   NoiseMedia* m,
                                                                   gpointer self);
static void __lambda7_ (LastFMCore* self,
                 GeeCollection* medias);
void last_fm_core_fetch_albums_slowly (LastFMCore* self,
                                       GeeCollection* new_medias,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
void last_fm_core_fetch_albums_slowly_finish (LastFMCore* self,
                                              GAsyncResult* _res_);
static void ___lambda7__noise_library_media_added (NoiseLibrary* _sender,
                                            GeeCollection* medias,
                                            gpointer self);
static void last_fm_core_similar_retrieved_signal (LastFMCore* self,
                                            GeeLinkedList* similarIDs,
                                            GeeLinkedList* similarDont);
static void _last_fm_core_similar_retrieved_signal_last_fm_similar_medias_similar_retrieved (LastFMSimilarMedias* _sender,
                                                                                      GeeLinkedList* similarIDs,
                                                                                      GeeLinkedList* similarDont,
                                                                                      gpointer self);
void last_fm_core_initialize (LastFMCore* self,
                              const gchar* api_key,
                              const gchar* api_secret,
                              const gchar* session_key);
NoiseStaticPlaylist* last_fm_core_get_similar_playlist (LastFMCore* self);
void last_fm_core_loveTrack (LastFMCore* self,
                             const gchar* title,
                             const gchar* artist);
gchar* last_fm_core_generate_tracklove_signature (LastFMCore* self,
                                                  const gchar* artist,
                                                  const gchar* track);
static void _vala_SoupURI_free (SoupURI* self);
void last_fm_core_banTrack (LastFMCore* self,
                            const gchar* title,
                            const gchar* artist);
gchar* last_fm_core_generate_trackban_signature (LastFMCore* self,
                                                 const gchar* artist,
                                                 const gchar* track);
static void last_fm_core_fetch_albums_slowly_data_free (gpointer _data);
static gboolean last_fm_core_fetch_albums_slowly_co (LastFmCoreFetchAlbumsSlowlyData* _data_);
void last_fm_core_get_album_infos (LastFMCore* self,
                                   NoiseAlbum* album,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
void last_fm_core_get_album_infos_finish (LastFMCore* self,
                                          GAsyncResult* _res_);
gchar* last_fm_core_generate_trackupdatenowplaying_signature (LastFMCore* self,
                                                              const gchar* artist,
                                                              const gchar* track);
gchar* last_fm_core_generate_trackscrobble_signature (LastFMCore* self,
                                                      const gchar* artist,
                                                      const gchar* track,
                                                      gint timestamp);
void last_fm_core_fetchCurrentSimilarSongs (LastFMCore* self);
void last_fm_similar_medias_query_for_similar (LastFMSimilarMedias* self,
                                               NoiseMedia* s);
static void last_fm_core_get_similar_tracks_data_free (gpointer _data);
void last_fm_core_get_similar_tracks (LastFMCore* self,
                                      const gchar* title,
                                      const gchar* artist,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
GeeTreeSet* last_fm_core_get_similar_tracks_finish (LastFMCore* self,
                                                    GAsyncResult* _res_);
static gboolean last_fm_core_get_similar_tracks_co (LastFmCoreGetSimilarTracksData* _data_);
static void last_fm_core_get_similar_tracks_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static void last_fm_core_get_album_infos_data_free (gpointer _data);
static gboolean last_fm_core_get_album_infos_co (LastFmCoreGetAlbumInfosData* _data_);
static void last_fm_core_get_album_infos_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
gchar* last_fm_core_generate_md5 (LastFMCore* self,
                                  const gchar* text);
gchar* last_fm_core_generate_getsession_signature (LastFMCore* self,
                                                   const gchar* token);
gchar* last_fm_core_generate_trackscrobble_signature2 (LastFMCore* self,
                                                       const gchar* artist,
                                                       const gchar* track,
                                                       const gchar* album,
                                                       gint timestamp);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void last_fm_core_finalize (GObject * obj);

static inline gpointer
last_fm_core_get_instance_private (LastFMCore* self)
{
	return G_STRUCT_MEMBER_P (self, LastFMCore_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../plugins/LastFM/Core.vala"
	return self ? g_object_ref (self) : NULL;
#line 464 "Core.c"
}

LastFMCore*
last_fm_core_get_default (void)
{
	LastFMCore* result = NULL;
	LastFMCore* _tmp0_;
	LastFMCore* _tmp2_;
	LastFMCore* _tmp3_;
#line 49 "../plugins/LastFM/Core.vala"
	_tmp0_ = last_fm_core_core;
#line 49 "../plugins/LastFM/Core.vala"
	if (_tmp0_ == NULL) {
#line 478 "Core.c"
		LastFMCore* _tmp1_;
#line 50 "../plugins/LastFM/Core.vala"
		_tmp1_ = last_fm_core_new ();
#line 50 "../plugins/LastFM/Core.vala"
		_g_object_unref0 (last_fm_core_core);
#line 50 "../plugins/LastFM/Core.vala"
		last_fm_core_core = _tmp1_;
#line 486 "Core.c"
	}
#line 52 "../plugins/LastFM/Core.vala"
	_tmp2_ = last_fm_core_core;
#line 52 "../plugins/LastFM/Core.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 52 "../plugins/LastFM/Core.vala"
	result = _tmp3_;
#line 52 "../plugins/LastFM/Core.vala"
	return result;
#line 496 "Core.c"
}

static void
__lambda5_ (LastFMCore* self,
            NoiseMedia* media)
{
#line 60 "../plugins/LastFM/Core.vala"
	g_return_if_fail (media != NULL);
#line 60 "../plugins/LastFM/Core.vala"
	last_fm_core_postNowPlaying (self, media);
#line 507 "Core.c"
}

static void
___lambda5__noise_library_window_interface_update_media_info (NoiseLibraryWindowInterface* _sender,
                                                              NoiseMedia* m,
                                                              gpointer self)
{
#line 60 "../plugins/LastFM/Core.vala"
	__lambda5_ ((LastFMCore*) self, m);
#line 517 "Core.c"
}

static void
__lambda6_ (LastFMCore* self,
            NoiseMedia* media)
{
#line 61 "../plugins/LastFM/Core.vala"
	g_return_if_fail (media != NULL);
#line 61 "../plugins/LastFM/Core.vala"
	last_fm_core_postScrobbleTrack (self, media);
#line 528 "Core.c"
}

static void
___lambda6__noise_library_window_interface_media_half_played (NoiseLibraryWindowInterface* _sender,
                                                              NoiseMedia* m,
                                                              gpointer self)
{
#line 61 "../plugins/LastFM/Core.vala"
	__lambda6_ ((LastFMCore*) self, m);
#line 538 "Core.c"
}

static void
__lambda7_ (LastFMCore* self,
            GeeCollection* medias)
{
#line 62 "../plugins/LastFM/Core.vala"
	g_return_if_fail (medias != NULL);
#line 62 "../plugins/LastFM/Core.vala"
	last_fm_core_fetch_albums_slowly (self, medias, NULL, NULL);
#line 549 "Core.c"
}

static void
___lambda7__noise_library_media_added (NoiseLibrary* _sender,
                                       GeeCollection* medias,
                                       gpointer self)
{
#line 62 "../plugins/LastFM/Core.vala"
	__lambda7_ ((LastFMCore*) self, medias);
#line 559 "Core.c"
}

static void
_last_fm_core_similar_retrieved_signal_last_fm_similar_medias_similar_retrieved (LastFMSimilarMedias* _sender,
                                                                                 GeeLinkedList* similarIDs,
                                                                                 GeeLinkedList* similarDont,
                                                                                 gpointer self)
{
#line 63 "../plugins/LastFM/Core.vala"
	last_fm_core_similar_retrieved_signal ((LastFMCore*) self, similarIDs, similarDont);
#line 570 "Core.c"
}

static LastFMCore*
last_fm_core_construct (GType object_type)
{
	LastFMCore * self = NULL;
	GCancellable* _tmp0_;
	LastFMSimilarMedias* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	NoiseLibraryWindow* _tmp3_;
	NoiseLibraryWindow* _tmp4_;
	NoiseLibraryWindow* _tmp5_;
	NoiseLibrariesManager* _tmp6_;
	NoiseLibrary* _tmp7_;
	LastFMSimilarMedias* _tmp8_;
#line 57 "../plugins/LastFM/Core.vala"
	self = (LastFMCore*) g_object_new (object_type, NULL);
#line 58 "../plugins/LastFM/Core.vala"
	_tmp0_ = g_cancellable_new ();
#line 58 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (self->priv->fetch_cancellable);
#line 58 "../plugins/LastFM/Core.vala"
	self->priv->fetch_cancellable = _tmp0_;
#line 59 "../plugins/LastFM/Core.vala"
	_tmp1_ = last_fm_similar_medias_new ();
#line 59 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (self->priv->similarMedias);
#line 59 "../plugins/LastFM/Core.vala"
	self->priv->similarMedias = _tmp1_;
#line 60 "../plugins/LastFM/Core.vala"
	_tmp2_ = noise_app_get_main_window ();
#line 60 "../plugins/LastFM/Core.vala"
	_tmp3_ = _tmp2_;
#line 60 "../plugins/LastFM/Core.vala"
	g_signal_connect_object ((NoiseLibraryWindowInterface*) _tmp3_, "update-media-info", (GCallback) ___lambda5__noise_library_window_interface_update_media_info, self, 0);
#line 61 "../plugins/LastFM/Core.vala"
	_tmp4_ = noise_app_get_main_window ();
#line 61 "../plugins/LastFM/Core.vala"
	_tmp5_ = _tmp4_;
#line 61 "../plugins/LastFM/Core.vala"
	g_signal_connect_object ((NoiseLibraryWindowInterface*) _tmp5_, "media-half-played", (GCallback) ___lambda6__noise_library_window_interface_media_half_played, self, 0);
#line 62 "../plugins/LastFM/Core.vala"
	_tmp6_ = noise_libraries_manager;
#line 62 "../plugins/LastFM/Core.vala"
	_tmp7_ = _tmp6_->local_library;
#line 62 "../plugins/LastFM/Core.vala"
	g_signal_connect_object (_tmp7_, "media-added", (GCallback) ___lambda7__noise_library_media_added, self, 0);
#line 63 "../plugins/LastFM/Core.vala"
	_tmp8_ = self->priv->similarMedias;
#line 63 "../plugins/LastFM/Core.vala"
	g_signal_connect_object (_tmp8_, "similar-retrieved", (GCallback) _last_fm_core_similar_retrieved_signal_last_fm_similar_medias_similar_retrieved, self, 0);
#line 57 "../plugins/LastFM/Core.vala"
	return self;
#line 624 "Core.c"
}

static LastFMCore*
last_fm_core_new (void)
{
#line 57 "../plugins/LastFM/Core.vala"
	return last_fm_core_construct (LAST_FM_TYPE_CORE);
#line 632 "Core.c"
}

void
last_fm_core_initialize (LastFMCore* self,
                         const gchar* api_key,
                         const gchar* api_secret,
                         const gchar* session_key)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 66 "../plugins/LastFM/Core.vala"
	g_return_if_fail (self != NULL);
#line 66 "../plugins/LastFM/Core.vala"
	g_return_if_fail (api_key != NULL);
#line 66 "../plugins/LastFM/Core.vala"
	g_return_if_fail (api_secret != NULL);
#line 66 "../plugins/LastFM/Core.vala"
	g_return_if_fail (session_key != NULL);
#line 67 "../plugins/LastFM/Core.vala"
	_tmp0_ = g_strdup (api_key);
#line 67 "../plugins/LastFM/Core.vala"
	_g_free0 (self->api_key);
#line 67 "../plugins/LastFM/Core.vala"
	self->api_key = _tmp0_;
#line 68 "../plugins/LastFM/Core.vala"
	_tmp1_ = g_strdup (api_secret);
#line 68 "../plugins/LastFM/Core.vala"
	_g_free0 (self->api_secret);
#line 68 "../plugins/LastFM/Core.vala"
	self->api_secret = _tmp1_;
#line 69 "../plugins/LastFM/Core.vala"
	_tmp2_ = g_strdup (session_key);
#line 69 "../plugins/LastFM/Core.vala"
	_g_free0 (self->session_key);
#line 69 "../plugins/LastFM/Core.vala"
	self->session_key = _tmp2_;
#line 70 "../plugins/LastFM/Core.vala"
	self->is_initialized = TRUE;
#line 672 "Core.c"
}

NoiseStaticPlaylist*
last_fm_core_get_similar_playlist (LastFMCore* self)
{
	NoiseStaticPlaylist* result = NULL;
	LastFMSimilarMedias* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	NoiseStaticPlaylist* _tmp2_;
#line 73 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "../plugins/LastFM/Core.vala"
	_tmp0_ = self->priv->similarMedias;
#line 74 "../plugins/LastFM/Core.vala"
	_tmp1_ = _tmp0_->similar_playlist;
#line 74 "../plugins/LastFM/Core.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 74 "../plugins/LastFM/Core.vala"
	result = _tmp2_;
#line 74 "../plugins/LastFM/Core.vala"
	return result;
#line 694 "Core.c"
}

static void
_vala_SoupURI_free (SoupURI* self)
{
#line 77 "../plugins/LastFM/Core.vala"
	g_boxed_free (soup_uri_get_type (), self);
#line 702 "Core.c"
}

void
last_fm_core_loveTrack (LastFMCore* self,
                        const gchar* title,
                        const gchar* artist)
{
	SoupURI* uri = NULL;
	SoupURI* _tmp0_;
	SoupURI* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	SoupSession* session = NULL;
	SoupSession* _tmp6_;
	SoupMessage* message = NULL;
	SoupURI* _tmp7_;
	SoupMessage* _tmp8_;
	SoupSession* _tmp9_;
	SoupMessage* _tmp10_;
	SoupMessage* _tmp11_;
	guint _tmp12_;
	guint _tmp13_;
#line 77 "../plugins/LastFM/Core.vala"
	g_return_if_fail (self != NULL);
#line 77 "../plugins/LastFM/Core.vala"
	g_return_if_fail (title != NULL);
#line 77 "../plugins/LastFM/Core.vala"
	g_return_if_fail (artist != NULL);
#line 78 "../plugins/LastFM/Core.vala"
	if (noise_string_is_empty (title, TRUE) | noise_string_is_empty (artist, TRUE)) {
#line 79 "../plugins/LastFM/Core.vala"
		return;
#line 737 "Core.c"
	}
#line 81 "../plugins/LastFM/Core.vala"
	_tmp0_ = soup_uri_new (LAST_FM_CORE_API_URL);
#line 81 "../plugins/LastFM/Core.vala"
	uri = _tmp0_;
#line 82 "../plugins/LastFM/Core.vala"
	_tmp1_ = uri;
#line 82 "../plugins/LastFM/Core.vala"
	_tmp2_ = self->api_key;
#line 82 "../plugins/LastFM/Core.vala"
	_tmp3_ = self->session_key;
#line 82 "../plugins/LastFM/Core.vala"
	_tmp4_ = last_fm_core_generate_tracklove_signature (self, artist, title);
#line 82 "../plugins/LastFM/Core.vala"
	_tmp5_ = _tmp4_;
#line 82 "../plugins/LastFM/Core.vala"
	soup_uri_set_query_from_fields (_tmp1_, "method", "track.love", "api_key", _tmp2_, "artist", artist, "track", title, "sk", _tmp3_, "api_sig", _tmp5_, NULL);
#line 82 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp5_);
#line 89 "../plugins/LastFM/Core.vala"
	_tmp6_ = soup_session_new ();
#line 89 "../plugins/LastFM/Core.vala"
	session = _tmp6_;
#line 90 "../plugins/LastFM/Core.vala"
	_tmp7_ = uri;
#line 90 "../plugins/LastFM/Core.vala"
	_tmp8_ = soup_message_new_from_uri ("POST", _tmp7_);
#line 90 "../plugins/LastFM/Core.vala"
	message = _tmp8_;
#line 93 "../plugins/LastFM/Core.vala"
	_tmp9_ = session;
#line 93 "../plugins/LastFM/Core.vala"
	_tmp10_ = message;
#line 93 "../plugins/LastFM/Core.vala"
	soup_session_send_message (_tmp9_, _tmp10_);
#line 95 "../plugins/LastFM/Core.vala"
	_tmp11_ = message;
#line 95 "../plugins/LastFM/Core.vala"
	g_object_get (_tmp11_, "status-code", &_tmp12_, NULL);
#line 95 "../plugins/LastFM/Core.vala"
	_tmp13_ = _tmp12_;
#line 95 "../plugins/LastFM/Core.vala"
	if (_tmp13_ == ((guint) SOUP_STATUS_OK)) {
#line 96 "../plugins/LastFM/Core.vala"
		g_signal_emit (self, last_fm_core_signals[LAST_FM_CORE_LOVED_SIGNAL], 0, title, artist);
#line 783 "Core.c"
	}
#line 77 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (message);
#line 77 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (session);
#line 77 "../plugins/LastFM/Core.vala"
	__vala_SoupURI_free0 (uri);
#line 791 "Core.c"
}

void
last_fm_core_banTrack (LastFMCore* self,
                       const gchar* title,
                       const gchar* artist)
{
	SoupURI* uri = NULL;
	SoupURI* _tmp0_;
	SoupURI* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	SoupSession* session = NULL;
	SoupSession* _tmp6_;
	SoupMessage* message = NULL;
	SoupURI* _tmp7_;
	SoupMessage* _tmp8_;
	SoupSession* _tmp9_;
	SoupMessage* _tmp10_;
	SoupMessage* _tmp11_;
	guint _tmp12_;
	guint _tmp13_;
#line 100 "../plugins/LastFM/Core.vala"
	g_return_if_fail (self != NULL);
#line 100 "../plugins/LastFM/Core.vala"
	g_return_if_fail (title != NULL);
#line 100 "../plugins/LastFM/Core.vala"
	g_return_if_fail (artist != NULL);
#line 101 "../plugins/LastFM/Core.vala"
	if (noise_string_is_empty (title, TRUE) | noise_string_is_empty (artist, TRUE)) {
#line 102 "../plugins/LastFM/Core.vala"
		return;
#line 826 "Core.c"
	}
#line 104 "../plugins/LastFM/Core.vala"
	_tmp0_ = soup_uri_new (LAST_FM_CORE_API_URL);
#line 104 "../plugins/LastFM/Core.vala"
	uri = _tmp0_;
#line 105 "../plugins/LastFM/Core.vala"
	_tmp1_ = uri;
#line 105 "../plugins/LastFM/Core.vala"
	_tmp2_ = self->api_key;
#line 105 "../plugins/LastFM/Core.vala"
	_tmp3_ = self->session_key;
#line 105 "../plugins/LastFM/Core.vala"
	_tmp4_ = last_fm_core_generate_trackban_signature (self, artist, title);
#line 105 "../plugins/LastFM/Core.vala"
	_tmp5_ = _tmp4_;
#line 105 "../plugins/LastFM/Core.vala"
	soup_uri_set_query_from_fields (_tmp1_, "method", "track.ban", "api_key", _tmp2_, "artist", artist, "track", title, "sk", _tmp3_, "api_sig", _tmp5_, NULL);
#line 105 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp5_);
#line 112 "../plugins/LastFM/Core.vala"
	_tmp6_ = soup_session_new ();
#line 112 "../plugins/LastFM/Core.vala"
	session = _tmp6_;
#line 113 "../plugins/LastFM/Core.vala"
	_tmp7_ = uri;
#line 113 "../plugins/LastFM/Core.vala"
	_tmp8_ = soup_message_new_from_uri ("POST", _tmp7_);
#line 113 "../plugins/LastFM/Core.vala"
	message = _tmp8_;
#line 116 "../plugins/LastFM/Core.vala"
	_tmp9_ = session;
#line 116 "../plugins/LastFM/Core.vala"
	_tmp10_ = message;
#line 116 "../plugins/LastFM/Core.vala"
	soup_session_send_message (_tmp9_, _tmp10_);
#line 118 "../plugins/LastFM/Core.vala"
	_tmp11_ = message;
#line 118 "../plugins/LastFM/Core.vala"
	g_object_get (_tmp11_, "status-code", &_tmp12_, NULL);
#line 118 "../plugins/LastFM/Core.vala"
	_tmp13_ = _tmp12_;
#line 118 "../plugins/LastFM/Core.vala"
	if (_tmp13_ == ((guint) SOUP_STATUS_OK)) {
#line 119 "../plugins/LastFM/Core.vala"
		g_signal_emit (self, last_fm_core_signals[LAST_FM_CORE_BANED_SIGNAL], 0, title, artist);
#line 872 "Core.c"
	}
#line 100 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (message);
#line 100 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (session);
#line 100 "../plugins/LastFM/Core.vala"
	__vala_SoupURI_free0 (uri);
#line 880 "Core.c"
}

static void
last_fm_core_fetch_albums_slowly_data_free (gpointer _data)
{
	LastFmCoreFetchAlbumsSlowlyData* _data_;
	_data_ = _data;
#line 33 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->new_medias);
#line 33 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->self);
#line 33 "../plugins/LastFM/Core.vala"
	g_slice_free (LastFmCoreFetchAlbumsSlowlyData, _data_);
#line 894 "Core.c"
}

void
last_fm_core_fetch_albums_slowly (LastFMCore* self,
                                  GeeCollection* new_medias,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	LastFmCoreFetchAlbumsSlowlyData* _data_;
	LastFMCore* _tmp0_;
	GeeCollection* _tmp1_;
#line 33 "../plugins/LastFM/Core.vala"
	_data_ = g_slice_new0 (LastFmCoreFetchAlbumsSlowlyData);
#line 33 "../plugins/LastFM/Core.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 33 "../plugins/LastFM/Core.vala"
	g_task_set_task_data (_data_->_async_result, _data_, last_fm_core_fetch_albums_slowly_data_free);
#line 33 "../plugins/LastFM/Core.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 33 "../plugins/LastFM/Core.vala"
	_data_->self = _tmp0_;
#line 33 "../plugins/LastFM/Core.vala"
	_tmp1_ = _g_object_ref0 (new_medias);
#line 33 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->new_medias);
#line 33 "../plugins/LastFM/Core.vala"
	_data_->new_medias = _tmp1_;
#line 33 "../plugins/LastFM/Core.vala"
	last_fm_core_fetch_albums_slowly_co (_data_);
#line 924 "Core.c"
}

void
last_fm_core_fetch_albums_slowly_finish (LastFMCore* self,
                                         GAsyncResult* _res_)
{
	LastFmCoreFetchAlbumsSlowlyData* _data_;
#line 33 "../plugins/LastFM/Core.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 934 "Core.c"
}

/** Fetches the current track's info from last.fm
     */
static gboolean
last_fm_core_fetch_albums_slowly_co (LastFmCoreFetchAlbumsSlowlyData* _data_)
{
#line 125 "../plugins/LastFM/Core.vala"
	switch (_data_->_state_) {
#line 125 "../plugins/LastFM/Core.vala"
		case 0:
#line 946 "Core.c"
		goto _state_0;
		default:
#line 125 "../plugins/LastFM/Core.vala"
		g_assert_not_reached ();
#line 951 "Core.c"
	}
	_state_0:
#line 126 "../plugins/LastFM/Core.vala"
	_data_->_tmp0_ = gee_tree_set_new (NOISE_TYPE_ALBUM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 126 "../plugins/LastFM/Core.vala"
	_data_->albums = _data_->_tmp0_;
#line 958 "Core.c"
	{
#line 127 "../plugins/LastFM/Core.vala"
		_data_->_tmp1_ = gee_iterable_iterator ((GeeIterable*) _data_->new_medias);
#line 127 "../plugins/LastFM/Core.vala"
		_data_->_media_it = _data_->_tmp1_;
#line 127 "../plugins/LastFM/Core.vala"
		while (TRUE) {
#line 127 "../plugins/LastFM/Core.vala"
			_data_->_tmp2_ = _data_->_media_it;
#line 127 "../plugins/LastFM/Core.vala"
			if (!gee_iterator_next (_data_->_tmp2_)) {
#line 127 "../plugins/LastFM/Core.vala"
				break;
#line 972 "Core.c"
			}
#line 127 "../plugins/LastFM/Core.vala"
			_data_->_tmp3_ = _data_->_media_it;
#line 127 "../plugins/LastFM/Core.vala"
			_data_->_tmp4_ = gee_iterator_get (_data_->_tmp3_);
#line 127 "../plugins/LastFM/Core.vala"
			_data_->media = (NoiseMedia*) _data_->_tmp4_;
#line 128 "../plugins/LastFM/Core.vala"
			_data_->_tmp5_ = _data_->albums;
#line 128 "../plugins/LastFM/Core.vala"
			_data_->_tmp6_ = _data_->media;
#line 128 "../plugins/LastFM/Core.vala"
			_data_->_tmp7_ = noise_media_get_album_info (_data_->_tmp6_);
#line 128 "../plugins/LastFM/Core.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 128 "../plugins/LastFM/Core.vala"
			if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _data_->_tmp5_, _data_->_tmp8_)) {
#line 129 "../plugins/LastFM/Core.vala"
				_data_->_tmp9_ = _data_->albums;
#line 129 "../plugins/LastFM/Core.vala"
				_data_->_tmp10_ = _data_->media;
#line 129 "../plugins/LastFM/Core.vala"
				_data_->_tmp11_ = noise_media_get_album_info (_data_->_tmp10_);
#line 129 "../plugins/LastFM/Core.vala"
				_data_->_tmp12_ = _data_->_tmp11_;
#line 129 "../plugins/LastFM/Core.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp9_, _data_->_tmp12_);
#line 130 "../plugins/LastFM/Core.vala"
				_data_->_tmp13_ = _data_->media;
#line 130 "../plugins/LastFM/Core.vala"
				_data_->_tmp14_ = noise_media_get_album_info (_data_->_tmp13_);
#line 130 "../plugins/LastFM/Core.vala"
				_data_->_tmp15_ = _data_->_tmp14_;
#line 130 "../plugins/LastFM/Core.vala"
				_data_->_tmp16_ = _data_->self->priv->fetch_cancellable;
#line 130 "../plugins/LastFM/Core.vala"
				last_fm_core_get_album_infos (_data_->self, _data_->_tmp15_, _data_->_tmp16_, NULL, NULL);
#line 1010 "Core.c"
			}
#line 127 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->media);
#line 1014 "Core.c"
		}
#line 127 "../plugins/LastFM/Core.vala"
		_g_object_unref0 (_data_->_media_it);
#line 1018 "Core.c"
	}
#line 125 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->albums);
#line 125 "../plugins/LastFM/Core.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 125 "../plugins/LastFM/Core.vala"
	if (_data_->_state_ != 0) {
#line 125 "../plugins/LastFM/Core.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 125 "../plugins/LastFM/Core.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1030 "Core.c"
		}
	}
#line 125 "../plugins/LastFM/Core.vala"
	g_object_unref (_data_->_async_result);
#line 125 "../plugins/LastFM/Core.vala"
	return FALSE;
#line 1037 "Core.c"
}

/** Update's the user's currently playing track on last.fm
     *
     */
void
last_fm_core_postNowPlaying (LastFMCore* self,
                             NoiseMedia* m)
{
	SoupURI* uri = NULL;
	SoupURI* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	SoupSession* session = NULL;
	SoupSession* _tmp13_;
	SoupMessage* message = NULL;
	SoupMessage* _tmp14_;
#line 138 "../plugins/LastFM/Core.vala"
	g_return_if_fail (self != NULL);
#line 138 "../plugins/LastFM/Core.vala"
	g_return_if_fail (m != NULL);
#line 139 "../plugins/LastFM/Core.vala"
	g_debug ("Core.vala:139: Sound send as now_playing");
#line 140 "../plugins/LastFM/Core.vala"
	_tmp0_ = soup_uri_new (LAST_FM_CORE_API_URL);
#line 140 "../plugins/LastFM/Core.vala"
	uri = _tmp0_;
#line 141 "../plugins/LastFM/Core.vala"
	_tmp1_ = self->api_key;
#line 141 "../plugins/LastFM/Core.vala"
	_tmp2_ = noise_media_get_artist (m);
#line 141 "../plugins/LastFM/Core.vala"
	_tmp3_ = _tmp2_;
#line 141 "../plugins/LastFM/Core.vala"
	_tmp4_ = noise_media_get_title (m);
#line 141 "../plugins/LastFM/Core.vala"
	_tmp5_ = _tmp4_;
#line 141 "../plugins/LastFM/Core.vala"
	_tmp6_ = self->session_key;
#line 141 "../plugins/LastFM/Core.vala"
	_tmp7_ = noise_media_get_artist (m);
#line 141 "../plugins/LastFM/Core.vala"
	_tmp8_ = _tmp7_;
#line 141 "../plugins/LastFM/Core.vala"
	_tmp9_ = noise_media_get_title (m);
#line 141 "../plugins/LastFM/Core.vala"
	_tmp10_ = _tmp9_;
#line 141 "../plugins/LastFM/Core.vala"
	_tmp11_ = last_fm_core_generate_trackupdatenowplaying_signature (self, _tmp8_, _tmp10_);
#line 141 "../plugins/LastFM/Core.vala"
	_tmp12_ = _tmp11_;
#line 141 "../plugins/LastFM/Core.vala"
	soup_uri_set_query_from_fields (uri, "method", "track.updateNowPlaying", "api_key", _tmp1_, "artist", _tmp3_, "track", _tmp5_, "sk", _tmp6_, "api_sig", _tmp12_, NULL);
#line 141 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp12_);
#line 148 "../plugins/LastFM/Core.vala"
	_tmp13_ = soup_session_new ();
#line 148 "../plugins/LastFM/Core.vala"
	session = _tmp13_;
#line 149 "../plugins/LastFM/Core.vala"
	_tmp14_ = soup_message_new_from_uri ("POST", uri);
#line 149 "../plugins/LastFM/Core.vala"
	message = _tmp14_;
#line 152 "../plugins/LastFM/Core.vala"
	soup_session_send_message (session, message);
#line 138 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (message);
#line 138 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (session);
#line 138 "../plugins/LastFM/Core.vala"
	__vala_SoupURI_free0 (uri);
#line 1119 "Core.c"
}

/**
     * Scrobbles the currently playing track to last.fm
     */
void
last_fm_core_postScrobbleTrack (LastFMCore* self,
                                NoiseMedia* m)
{
	NoisePlaybackManager* _tmp0_;
	NoisePlaybackManager* _tmp1_;
	NoiseMedia* _tmp2_;
	NoiseMedia* _tmp3_;
	gint timestamp = 0;
	time_t _tmp4_;
	SoupURI* uri = NULL;
	SoupURI* _tmp5_;
	SoupURI* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	SoupSession* session = NULL;
	SoupSession* _tmp21_;
	SoupMessage* message = NULL;
	SoupURI* _tmp22_;
	SoupMessage* _tmp23_;
	SoupSession* _tmp24_;
	SoupMessage* _tmp25_;
#line 158 "../plugins/LastFM/Core.vala"
	g_return_if_fail (self != NULL);
#line 158 "../plugins/LastFM/Core.vala"
	g_return_if_fail (m != NULL);
#line 159 "../plugins/LastFM/Core.vala"
	_tmp0_ = noise_app_get_player ();
#line 159 "../plugins/LastFM/Core.vala"
	_tmp1_ = _tmp0_;
#line 159 "../plugins/LastFM/Core.vala"
	_tmp2_ = noise_playback_manager_get_current_media (_tmp1_);
#line 159 "../plugins/LastFM/Core.vala"
	_tmp3_ = _tmp2_;
#line 159 "../plugins/LastFM/Core.vala"
	if (_tmp3_ == NULL) {
#line 160 "../plugins/LastFM/Core.vala"
		return;
#line 1175 "Core.c"
	}
#line 162 "../plugins/LastFM/Core.vala"
	g_debug ("Core.vala:162: Sound Scrobbled");
#line 163 "../plugins/LastFM/Core.vala"
	_tmp4_ = time (NULL);
#line 163 "../plugins/LastFM/Core.vala"
	timestamp = (gint) _tmp4_;
#line 164 "../plugins/LastFM/Core.vala"
	_tmp5_ = soup_uri_new (LAST_FM_CORE_API_URL);
#line 164 "../plugins/LastFM/Core.vala"
	uri = _tmp5_;
#line 165 "../plugins/LastFM/Core.vala"
	_tmp6_ = uri;
#line 165 "../plugins/LastFM/Core.vala"
	_tmp7_ = self->api_key;
#line 165 "../plugins/LastFM/Core.vala"
	_tmp8_ = noise_media_get_artist (m);
#line 165 "../plugins/LastFM/Core.vala"
	_tmp9_ = _tmp8_;
#line 165 "../plugins/LastFM/Core.vala"
	_tmp10_ = noise_media_get_title (m);
#line 165 "../plugins/LastFM/Core.vala"
	_tmp11_ = _tmp10_;
#line 165 "../plugins/LastFM/Core.vala"
	_tmp12_ = g_strdup_printf ("%i", timestamp);
#line 165 "../plugins/LastFM/Core.vala"
	_tmp13_ = _tmp12_;
#line 165 "../plugins/LastFM/Core.vala"
	_tmp14_ = self->session_key;
#line 165 "../plugins/LastFM/Core.vala"
	_tmp15_ = noise_media_get_artist (m);
#line 165 "../plugins/LastFM/Core.vala"
	_tmp16_ = _tmp15_;
#line 165 "../plugins/LastFM/Core.vala"
	_tmp17_ = noise_media_get_title (m);
#line 165 "../plugins/LastFM/Core.vala"
	_tmp18_ = _tmp17_;
#line 165 "../plugins/LastFM/Core.vala"
	_tmp19_ = last_fm_core_generate_trackscrobble_signature (self, _tmp16_, _tmp18_, timestamp);
#line 165 "../plugins/LastFM/Core.vala"
	_tmp20_ = _tmp19_;
#line 165 "../plugins/LastFM/Core.vala"
	soup_uri_set_query_from_fields (_tmp6_, "method", "track.scrobble", "api_key", _tmp7_, "artist", _tmp9_, "track", _tmp11_, "timestamp", _tmp13_, "sk", _tmp14_, "api_sig", _tmp20_, NULL);
#line 165 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp20_);
#line 165 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp13_);
#line 173 "../plugins/LastFM/Core.vala"
	_tmp21_ = soup_session_new ();
#line 173 "../plugins/LastFM/Core.vala"
	session = _tmp21_;
#line 174 "../plugins/LastFM/Core.vala"
	_tmp22_ = uri;
#line 174 "../plugins/LastFM/Core.vala"
	_tmp23_ = soup_message_new_from_uri ("POST", _tmp22_);
#line 174 "../plugins/LastFM/Core.vala"
	message = _tmp23_;
#line 177 "../plugins/LastFM/Core.vala"
	_tmp24_ = session;
#line 177 "../plugins/LastFM/Core.vala"
	_tmp25_ = message;
#line 177 "../plugins/LastFM/Core.vala"
	soup_session_send_message (_tmp24_, _tmp25_);
#line 158 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (message);
#line 158 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (session);
#line 158 "../plugins/LastFM/Core.vala"
	__vala_SoupURI_free0 (uri);
#line 1245 "Core.c"
}

void
last_fm_core_fetchCurrentSimilarSongs (LastFMCore* self)
{
	LastFMSimilarMedias* _tmp0_;
	NoisePlaybackManager* _tmp1_;
	NoisePlaybackManager* _tmp2_;
	NoiseMedia* _tmp3_;
	NoiseMedia* _tmp4_;
#line 180 "../plugins/LastFM/Core.vala"
	g_return_if_fail (self != NULL);
#line 181 "../plugins/LastFM/Core.vala"
	_tmp0_ = self->priv->similarMedias;
#line 181 "../plugins/LastFM/Core.vala"
	_tmp1_ = noise_app_get_player ();
#line 181 "../plugins/LastFM/Core.vala"
	_tmp2_ = _tmp1_;
#line 181 "../plugins/LastFM/Core.vala"
	_tmp3_ = noise_playback_manager_get_current_media (_tmp2_);
#line 181 "../plugins/LastFM/Core.vala"
	_tmp4_ = _tmp3_;
#line 181 "../plugins/LastFM/Core.vala"
	last_fm_similar_medias_query_for_similar (_tmp0_, _tmp4_);
#line 1270 "Core.c"
}

static void
last_fm_core_similar_retrieved_signal (LastFMCore* self,
                                       GeeLinkedList* similarIDs,
                                       GeeLinkedList* similarDont)
{
#line 184 "../plugins/LastFM/Core.vala"
	g_return_if_fail (self != NULL);
#line 184 "../plugins/LastFM/Core.vala"
	g_return_if_fail (similarIDs != NULL);
#line 184 "../plugins/LastFM/Core.vala"
	g_return_if_fail (similarDont != NULL);
#line 185 "../plugins/LastFM/Core.vala"
	g_signal_emit (self, last_fm_core_signals[LAST_FM_CORE_SIMILAR_RETRIEVED_SIGNAL], 0, similarIDs, similarDont);
#line 1286 "Core.c"
}

static void
last_fm_core_get_similar_tracks_data_free (gpointer _data)
{
	LastFmCoreGetSimilarTracksData* _data_;
	_data_ = _data;
#line 33 "../plugins/LastFM/Core.vala"
	_g_free0 (_data_->title);
#line 33 "../plugins/LastFM/Core.vala"
	_g_free0 (_data_->artist);
#line 33 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->cancellable);
#line 33 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->result);
#line 33 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->self);
#line 33 "../plugins/LastFM/Core.vala"
	g_slice_free (LastFmCoreGetSimilarTracksData, _data_);
#line 1306 "Core.c"
}

void
last_fm_core_get_similar_tracks (LastFMCore* self,
                                 const gchar* title,
                                 const gchar* artist,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	LastFmCoreGetSimilarTracksData* _data_;
	LastFMCore* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
#line 33 "../plugins/LastFM/Core.vala"
	_data_ = g_slice_new0 (LastFmCoreGetSimilarTracksData);
#line 33 "../plugins/LastFM/Core.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 33 "../plugins/LastFM/Core.vala"
	g_task_set_task_data (_data_->_async_result, _data_, last_fm_core_get_similar_tracks_data_free);
#line 33 "../plugins/LastFM/Core.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 33 "../plugins/LastFM/Core.vala"
	_data_->self = _tmp0_;
#line 33 "../plugins/LastFM/Core.vala"
	_tmp1_ = g_strdup (title);
#line 33 "../plugins/LastFM/Core.vala"
	_g_free0 (_data_->title);
#line 33 "../plugins/LastFM/Core.vala"
	_data_->title = _tmp1_;
#line 33 "../plugins/LastFM/Core.vala"
	_tmp2_ = g_strdup (artist);
#line 33 "../plugins/LastFM/Core.vala"
	_g_free0 (_data_->artist);
#line 33 "../plugins/LastFM/Core.vala"
	_data_->artist = _tmp2_;
#line 33 "../plugins/LastFM/Core.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 33 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->cancellable);
#line 33 "../plugins/LastFM/Core.vala"
	_data_->cancellable = _tmp3_;
#line 33 "../plugins/LastFM/Core.vala"
	last_fm_core_get_similar_tracks_co (_data_);
#line 1352 "Core.c"
}

GeeTreeSet*
last_fm_core_get_similar_tracks_finish (LastFMCore* self,
                                        GAsyncResult* _res_)
{
	GeeTreeSet* result;
	LastFmCoreGetSimilarTracksData* _data_;
#line 33 "../plugins/LastFM/Core.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 33 "../plugins/LastFM/Core.vala"
	if (NULL == _data_) {
#line 33 "../plugins/LastFM/Core.vala"
		return NULL;
#line 1367 "Core.c"
	}
#line 33 "../plugins/LastFM/Core.vala"
	result = _data_->result;
#line 33 "../plugins/LastFM/Core.vala"
	_data_->result = NULL;
#line 33 "../plugins/LastFM/Core.vala"
	return result;
#line 1375 "Core.c"
}

/** Gets similar medias
     * @param artist The artist of media to get similar to
     * @param title The title of media to get similar to
     * @return The media that are similar
     */
static void
last_fm_core_get_similar_tracks_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	LastFmCoreGetSimilarTracksData* _data_;
#line 208 "../plugins/LastFM/Core.vala"
	_data_ = _user_data_;
#line 208 "../plugins/LastFM/Core.vala"
	_data_->_source_object_ = source_object;
#line 208 "../plugins/LastFM/Core.vala"
	_data_->_res_ = _res_;
#line 208 "../plugins/LastFM/Core.vala"
	last_fm_core_get_similar_tracks_co (_data_);
#line 1397 "Core.c"
}

static gboolean
last_fm_core_get_similar_tracks_co (LastFmCoreGetSimilarTracksData* _data_)
{
#line 194 "../plugins/LastFM/Core.vala"
	switch (_data_->_state_) {
#line 194 "../plugins/LastFM/Core.vala"
		case 0:
#line 1407 "Core.c"
		goto _state_0;
#line 194 "../plugins/LastFM/Core.vala"
		case 1:
#line 1411 "Core.c"
		goto _state_1;
		default:
#line 194 "../plugins/LastFM/Core.vala"
		g_assert_not_reached ();
#line 1416 "Core.c"
	}
	_state_0:
#line 195 "../plugins/LastFM/Core.vala"
	_data_->_tmp0_ = gee_tree_set_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 195 "../plugins/LastFM/Core.vala"
	_data_->returned_medias = _data_->_tmp0_;
#line 197 "../plugins/LastFM/Core.vala"
	_data_->_tmp1_ = soup_uri_new (LAST_FM_CORE_API_URL);
#line 197 "../plugins/LastFM/Core.vala"
	_data_->uri = _data_->_tmp1_;
#line 198 "../plugins/LastFM/Core.vala"
	_data_->_tmp2_ = _data_->uri;
#line 198 "../plugins/LastFM/Core.vala"
	_data_->_tmp3_ = _data_->self->api_key;
#line 198 "../plugins/LastFM/Core.vala"
	soup_uri_set_query_from_fields (_data_->_tmp2_, "method", "track.getsimilar", "api_key", _data_->_tmp3_, "artist", _data_->artist, "track", _data_->title, "format", "json", NULL);
#line 203 "../plugins/LastFM/Core.vala"
	_data_->_tmp4_ = soup_session_new ();
#line 203 "../plugins/LastFM/Core.vala"
	_data_->session = _data_->_tmp4_;
#line 1437 "Core.c"
	{
#line 205 "../plugins/LastFM/Core.vala"
		_data_->_tmp5_ = _data_->session;
#line 205 "../plugins/LastFM/Core.vala"
		_data_->_tmp6_ = _data_->uri;
#line 205 "../plugins/LastFM/Core.vala"
		_data_->_tmp7_ = soup_session_request_uri (_data_->_tmp5_, _data_->_tmp6_, &_data_->_inner_error0_);
#line 205 "../plugins/LastFM/Core.vala"
		_data_->uri_request = _data_->_tmp7_;
#line 205 "../plugins/LastFM/Core.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1449 "Core.c"
			goto __catch0_g_error;
		}
#line 208 "../plugins/LastFM/Core.vala"
		_data_->_tmp8_ = _data_->uri_request;
#line 208 "../plugins/LastFM/Core.vala"
		_data_->_state_ = 1;
#line 208 "../plugins/LastFM/Core.vala"
		soup_request_send_async (_data_->_tmp8_, _data_->cancellable, last_fm_core_get_similar_tracks_ready, _data_);
#line 208 "../plugins/LastFM/Core.vala"
		return FALSE;
#line 1460 "Core.c"
		_state_1:
#line 208 "../plugins/LastFM/Core.vala"
		_data_->_tmp9_ = soup_request_send_finish (_data_->_tmp8_, _data_->_res_, &_data_->_inner_error0_);
#line 208 "../plugins/LastFM/Core.vala"
		_data_->stream = _data_->_tmp9_;
#line 208 "../plugins/LastFM/Core.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 208 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->uri_request);
#line 1470 "Core.c"
			goto __catch0_g_error;
		}
#line 209 "../plugins/LastFM/Core.vala"
		_data_->_tmp10_ = json_parser_new ();
#line 209 "../plugins/LastFM/Core.vala"
		_data_->parser = _data_->_tmp10_;
#line 210 "../plugins/LastFM/Core.vala"
		_data_->_tmp11_ = _data_->parser;
#line 210 "../plugins/LastFM/Core.vala"
		_data_->_tmp12_ = _data_->stream;
#line 210 "../plugins/LastFM/Core.vala"
		json_parser_load_from_stream (_data_->_tmp11_, _data_->_tmp12_, NULL, &_data_->_inner_error0_);
#line 210 "../plugins/LastFM/Core.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 210 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->parser);
#line 210 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->stream);
#line 210 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->uri_request);
#line 1491 "Core.c"
			goto __catch0_g_error;
		}
#line 211 "../plugins/LastFM/Core.vala"
		_data_->_tmp13_ = _data_->parser;
#line 211 "../plugins/LastFM/Core.vala"
		_data_->_tmp14_ = json_parser_get_root (_data_->_tmp13_);
#line 211 "../plugins/LastFM/Core.vala"
		_data_->_tmp15_ = json_node_get_object (_data_->_tmp14_);
#line 211 "../plugins/LastFM/Core.vala"
		_data_->parser_object = _data_->_tmp15_;
#line 212 "../plugins/LastFM/Core.vala"
		_data_->_tmp17_ = _data_->parser_object;
#line 212 "../plugins/LastFM/Core.vala"
		if (_data_->_tmp17_ == NULL) {
#line 212 "../plugins/LastFM/Core.vala"
			_data_->_tmp16_ = TRUE;
#line 1508 "Core.c"
		} else {
#line 212 "../plugins/LastFM/Core.vala"
			_data_->_tmp18_ = _data_->parser_object;
#line 212 "../plugins/LastFM/Core.vala"
			_data_->_tmp16_ = json_object_has_member (_data_->_tmp18_, "similartracks") == FALSE;
#line 1514 "Core.c"
		}
#line 212 "../plugins/LastFM/Core.vala"
		if (_data_->_tmp16_) {
#line 213 "../plugins/LastFM/Core.vala"
			_data_->result = _data_->returned_medias;
#line 213 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->parser);
#line 213 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->stream);
#line 213 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->uri_request);
#line 213 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->session);
#line 213 "../plugins/LastFM/Core.vala"
			__vala_SoupURI_free0 (_data_->uri);
#line 213 "../plugins/LastFM/Core.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 213 "../plugins/LastFM/Core.vala"
			if (_data_->_state_ != 0) {
#line 213 "../plugins/LastFM/Core.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 213 "../plugins/LastFM/Core.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1538 "Core.c"
				}
			}
#line 213 "../plugins/LastFM/Core.vala"
			g_object_unref (_data_->_async_result);
#line 213 "../plugins/LastFM/Core.vala"
			return FALSE;
#line 1545 "Core.c"
		}
#line 215 "../plugins/LastFM/Core.vala"
		_data_->_tmp19_ = _data_->parser_object;
#line 215 "../plugins/LastFM/Core.vala"
		_data_->_tmp20_ = json_object_get_object_member (_data_->_tmp19_, "similartracks");
#line 215 "../plugins/LastFM/Core.vala"
		_data_->similartracks = _data_->_tmp20_;
#line 216 "../plugins/LastFM/Core.vala"
		_data_->_tmp22_ = _data_->similartracks;
#line 216 "../plugins/LastFM/Core.vala"
		if (json_object_has_member (_data_->_tmp22_, "track")) {
#line 216 "../plugins/LastFM/Core.vala"
			_data_->_tmp23_ = _data_->similartracks;
#line 216 "../plugins/LastFM/Core.vala"
			_data_->_tmp24_ = json_object_get_member (_data_->_tmp23_, "track");
#line 216 "../plugins/LastFM/Core.vala"
			_data_->_tmp21_ = json_node_get_node_type (_data_->_tmp24_) == JSON_NODE_ARRAY;
#line 1563 "Core.c"
		} else {
#line 216 "../plugins/LastFM/Core.vala"
			_data_->_tmp21_ = FALSE;
#line 1567 "Core.c"
		}
#line 216 "../plugins/LastFM/Core.vala"
		if (_data_->_tmp21_) {
#line 217 "../plugins/LastFM/Core.vala"
			_data_->_tmp25_ = _data_->similartracks;
#line 217 "../plugins/LastFM/Core.vala"
			_data_->_tmp26_ = json_object_get_array_member (_data_->_tmp25_, "track");
#line 217 "../plugins/LastFM/Core.vala"
			_data_->_tmp27_ = json_array_get_elements (_data_->_tmp26_);
#line 217 "../plugins/LastFM/Core.vala"
			_data_->similar_tracks_values = _data_->_tmp27_;
#line 218 "../plugins/LastFM/Core.vala"
			_data_->_tmp28_ = _data_->similar_tracks_values;
#line 1581 "Core.c"
			{
#line 218 "../plugins/LastFM/Core.vala"
				_data_->element_collection = _data_->_tmp28_;
#line 218 "../plugins/LastFM/Core.vala"
				for (_data_->element_it = _data_->element_collection; _data_->element_it != NULL; _data_->element_it = _data_->element_it->next) {
#line 218 "../plugins/LastFM/Core.vala"
					_data_->element = (JsonNode*) _data_->element_it->data;
#line 1589 "Core.c"
					{
#line 219 "../plugins/LastFM/Core.vala"
						_data_->_tmp29_ = _data_->element;
#line 219 "../plugins/LastFM/Core.vala"
						_data_->_tmp30_ = json_node_get_object (_data_->_tmp29_);
#line 219 "../plugins/LastFM/Core.vala"
						_data_->track_object = _data_->_tmp30_;
#line 220 "../plugins/LastFM/Core.vala"
						_data_->_tmp31_ = noise_media_new ("");
#line 220 "../plugins/LastFM/Core.vala"
						_data_->similar_to_add = _data_->_tmp31_;
#line 221 "../plugins/LastFM/Core.vala"
						_data_->_tmp32_ = _data_->returned_medias;
#line 221 "../plugins/LastFM/Core.vala"
						_data_->_tmp33_ = _data_->similar_to_add;
#line 221 "../plugins/LastFM/Core.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp32_, _data_->_tmp33_);
#line 222 "../plugins/LastFM/Core.vala"
						_data_->_tmp34_ = _data_->similar_to_add;
#line 222 "../plugins/LastFM/Core.vala"
						_data_->_tmp35_ = _data_->track_object;
#line 222 "../plugins/LastFM/Core.vala"
						_data_->_tmp36_ = json_object_get_string_member (_data_->_tmp35_, "name");
#line 222 "../plugins/LastFM/Core.vala"
						noise_media_set_title (_data_->_tmp34_, _data_->_tmp36_);
#line 223 "../plugins/LastFM/Core.vala"
						_data_->_tmp37_ = _data_->track_object;
#line 223 "../plugins/LastFM/Core.vala"
						if (json_object_has_member (_data_->_tmp37_, "url")) {
#line 224 "../plugins/LastFM/Core.vala"
							_data_->_tmp38_ = _data_->similar_to_add;
#line 224 "../plugins/LastFM/Core.vala"
							_data_->_tmp39_ = _data_->track_object;
#line 224 "../plugins/LastFM/Core.vala"
							_data_->_tmp40_ = json_object_get_string_member (_data_->_tmp39_, "url");
#line 224 "../plugins/LastFM/Core.vala"
							noise_media_set_comment (_data_->_tmp38_, _data_->_tmp40_);
#line 1627 "Core.c"
						}
#line 225 "../plugins/LastFM/Core.vala"
						_data_->_tmp41_ = _data_->track_object;
#line 225 "../plugins/LastFM/Core.vala"
						if (json_object_has_member (_data_->_tmp41_, "artist")) {
#line 226 "../plugins/LastFM/Core.vala"
							_data_->_tmp42_ = _data_->track_object;
#line 226 "../plugins/LastFM/Core.vala"
							_data_->_tmp43_ = json_object_get_object_member (_data_->_tmp42_, "artist");
#line 226 "../plugins/LastFM/Core.vala"
							_data_->artist_object = _data_->_tmp43_;
#line 227 "../plugins/LastFM/Core.vala"
							_data_->_tmp44_ = _data_->artist_object;
#line 227 "../plugins/LastFM/Core.vala"
							if (json_object_has_member (_data_->_tmp44_, "name")) {
#line 228 "../plugins/LastFM/Core.vala"
								_data_->_tmp45_ = _data_->similar_to_add;
#line 228 "../plugins/LastFM/Core.vala"
								_data_->_tmp46_ = _data_->artist_object;
#line 228 "../plugins/LastFM/Core.vala"
								_data_->_tmp47_ = json_object_get_string_member (_data_->_tmp46_, "name");
#line 228 "../plugins/LastFM/Core.vala"
								noise_media_set_artist (_data_->_tmp45_, _data_->_tmp47_);
#line 1651 "Core.c"
							}
						}
#line 218 "../plugins/LastFM/Core.vala"
						_g_object_unref0 (_data_->similar_to_add);
#line 1656 "Core.c"
					}
				}
			}
#line 216 "../plugins/LastFM/Core.vala"
			(_data_->similar_tracks_values == NULL) ? NULL : (_data_->similar_tracks_values = (g_list_free (_data_->similar_tracks_values), NULL));
#line 1662 "Core.c"
		}
#line 204 "../plugins/LastFM/Core.vala"
		_g_object_unref0 (_data_->parser);
#line 204 "../plugins/LastFM/Core.vala"
		_g_object_unref0 (_data_->stream);
#line 204 "../plugins/LastFM/Core.vala"
		_g_object_unref0 (_data_->uri_request);
#line 1670 "Core.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 204 "../plugins/LastFM/Core.vala"
		_data_->e = _data_->_inner_error0_;
#line 204 "../plugins/LastFM/Core.vala"
		_data_->_inner_error0_ = NULL;
#line 233 "../plugins/LastFM/Core.vala"
		_data_->_tmp48_ = _data_->e;
#line 233 "../plugins/LastFM/Core.vala"
		_data_->_tmp49_ = _data_->_tmp48_->message;
#line 233 "../plugins/LastFM/Core.vala"
		g_critical ("Core.vala:233: %s", _data_->_tmp49_);
#line 204 "../plugins/LastFM/Core.vala"
		_g_error_free0 (_data_->e);
#line 1687 "Core.c"
	}
	__finally0:
#line 204 "../plugins/LastFM/Core.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 204 "../plugins/LastFM/Core.vala"
		_g_object_unref0 (_data_->session);
#line 204 "../plugins/LastFM/Core.vala"
		__vala_SoupURI_free0 (_data_->uri);
#line 204 "../plugins/LastFM/Core.vala"
		_g_object_unref0 (_data_->returned_medias);
#line 204 "../plugins/LastFM/Core.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 204 "../plugins/LastFM/Core.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 204 "../plugins/LastFM/Core.vala"
		g_object_unref (_data_->_async_result);
#line 204 "../plugins/LastFM/Core.vala"
		return FALSE;
#line 1706 "Core.c"
	}
#line 236 "../plugins/LastFM/Core.vala"
	_data_->result = _data_->returned_medias;
#line 236 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->session);
#line 236 "../plugins/LastFM/Core.vala"
	__vala_SoupURI_free0 (_data_->uri);
#line 236 "../plugins/LastFM/Core.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 236 "../plugins/LastFM/Core.vala"
	if (_data_->_state_ != 0) {
#line 236 "../plugins/LastFM/Core.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 236 "../plugins/LastFM/Core.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1722 "Core.c"
		}
	}
#line 236 "../plugins/LastFM/Core.vala"
	g_object_unref (_data_->_async_result);
#line 236 "../plugins/LastFM/Core.vala"
	return FALSE;
#line 1729 "Core.c"
}

static void
last_fm_core_get_album_infos_data_free (gpointer _data)
{
	LastFmCoreGetAlbumInfosData* _data_;
	_data_ = _data;
#line 33 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->album);
#line 33 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->cancellable);
#line 33 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->self);
#line 33 "../plugins/LastFM/Core.vala"
	g_slice_free (LastFmCoreGetAlbumInfosData, _data_);
#line 1745 "Core.c"
}

void
last_fm_core_get_album_infos (LastFMCore* self,
                              NoiseAlbum* album,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	LastFmCoreGetAlbumInfosData* _data_;
	LastFMCore* _tmp0_;
	NoiseAlbum* _tmp1_;
	GCancellable* _tmp2_;
#line 33 "../plugins/LastFM/Core.vala"
	_data_ = g_slice_new0 (LastFmCoreGetAlbumInfosData);
#line 33 "../plugins/LastFM/Core.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 33 "../plugins/LastFM/Core.vala"
	g_task_set_task_data (_data_->_async_result, _data_, last_fm_core_get_album_infos_data_free);
#line 33 "../plugins/LastFM/Core.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 33 "../plugins/LastFM/Core.vala"
	_data_->self = _tmp0_;
#line 33 "../plugins/LastFM/Core.vala"
	_tmp1_ = _g_object_ref0 (album);
#line 33 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->album);
#line 33 "../plugins/LastFM/Core.vala"
	_data_->album = _tmp1_;
#line 33 "../plugins/LastFM/Core.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 33 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->cancellable);
#line 33 "../plugins/LastFM/Core.vala"
	_data_->cancellable = _tmp2_;
#line 33 "../plugins/LastFM/Core.vala"
	last_fm_core_get_album_infos_co (_data_);
#line 1783 "Core.c"
}

void
last_fm_core_get_album_infos_finish (LastFMCore* self,
                                     GAsyncResult* _res_)
{
	LastFmCoreGetAlbumInfosData* _data_;
#line 33 "../plugins/LastFM/Core.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 33 "../plugins/LastFM/Core.vala"
	if (NULL == _data_) {
#line 33 "../plugins/LastFM/Core.vala"
		return;
#line 1797 "Core.c"
	}
}

static void
last_fm_core_get_album_infos_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	LastFmCoreGetAlbumInfosData* _data_;
#line 251 "../plugins/LastFM/Core.vala"
	_data_ = _user_data_;
#line 251 "../plugins/LastFM/Core.vala"
	_data_->_source_object_ = source_object;
#line 251 "../plugins/LastFM/Core.vala"
	_data_->_res_ = _res_;
#line 251 "../plugins/LastFM/Core.vala"
	last_fm_core_get_album_infos_co (_data_);
#line 1815 "Core.c"
}

static gboolean
last_fm_core_get_album_infos_co (LastFmCoreGetAlbumInfosData* _data_)
{
#line 239 "../plugins/LastFM/Core.vala"
	switch (_data_->_state_) {
#line 239 "../plugins/LastFM/Core.vala"
		case 0:
#line 1825 "Core.c"
		goto _state_0;
#line 239 "../plugins/LastFM/Core.vala"
		case 1:
#line 1829 "Core.c"
		goto _state_1;
		default:
#line 239 "../plugins/LastFM/Core.vala"
		g_assert_not_reached ();
#line 1834 "Core.c"
	}
	_state_0:
#line 240 "../plugins/LastFM/Core.vala"
	_data_->_tmp0_ = soup_uri_new (LAST_FM_CORE_API_URL);
#line 240 "../plugins/LastFM/Core.vala"
	_data_->uri = _data_->_tmp0_;
#line 241 "../plugins/LastFM/Core.vala"
	_data_->_tmp1_ = _data_->uri;
#line 241 "../plugins/LastFM/Core.vala"
	_data_->_tmp2_ = _data_->self->api_key;
#line 241 "../plugins/LastFM/Core.vala"
	_data_->_tmp3_ = noise_album_get_artist (_data_->album);
#line 241 "../plugins/LastFM/Core.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 241 "../plugins/LastFM/Core.vala"
	_data_->_tmp5_ = noise_album_get_name (_data_->album);
#line 241 "../plugins/LastFM/Core.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 241 "../plugins/LastFM/Core.vala"
	soup_uri_set_query_from_fields (_data_->_tmp1_, "method", "album.getinfo", "api_key", _data_->_tmp2_, "artist", _data_->_tmp4_, "album", _data_->_tmp6_, "format", "json", NULL);
#line 246 "../plugins/LastFM/Core.vala"
	_data_->_tmp7_ = soup_session_new ();
#line 246 "../plugins/LastFM/Core.vala"
	_data_->session = _data_->_tmp7_;
#line 1859 "Core.c"
	{
#line 248 "../plugins/LastFM/Core.vala"
		_data_->_tmp8_ = _data_->session;
#line 248 "../plugins/LastFM/Core.vala"
		_data_->_tmp9_ = _data_->uri;
#line 248 "../plugins/LastFM/Core.vala"
		_data_->_tmp10_ = soup_session_request_uri (_data_->_tmp8_, _data_->_tmp9_, &_data_->_inner_error0_);
#line 248 "../plugins/LastFM/Core.vala"
		_data_->uri_request = _data_->_tmp10_;
#line 248 "../plugins/LastFM/Core.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1871 "Core.c"
			goto __catch1_g_error;
		}
#line 251 "../plugins/LastFM/Core.vala"
		_data_->_tmp11_ = _data_->uri_request;
#line 251 "../plugins/LastFM/Core.vala"
		_data_->_state_ = 1;
#line 251 "../plugins/LastFM/Core.vala"
		soup_request_send_async (_data_->_tmp11_, _data_->cancellable, last_fm_core_get_album_infos_ready, _data_);
#line 251 "../plugins/LastFM/Core.vala"
		return FALSE;
#line 1882 "Core.c"
		_state_1:
#line 251 "../plugins/LastFM/Core.vala"
		_data_->_tmp12_ = soup_request_send_finish (_data_->_tmp11_, _data_->_res_, &_data_->_inner_error0_);
#line 251 "../plugins/LastFM/Core.vala"
		_data_->stream = _data_->_tmp12_;
#line 251 "../plugins/LastFM/Core.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 251 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->uri_request);
#line 1892 "Core.c"
			goto __catch1_g_error;
		}
#line 252 "../plugins/LastFM/Core.vala"
		_data_->_tmp13_ = json_parser_new ();
#line 252 "../plugins/LastFM/Core.vala"
		_data_->parser = _data_->_tmp13_;
#line 253 "../plugins/LastFM/Core.vala"
		_data_->_tmp14_ = _data_->parser;
#line 253 "../plugins/LastFM/Core.vala"
		_data_->_tmp15_ = _data_->stream;
#line 253 "../plugins/LastFM/Core.vala"
		json_parser_load_from_stream (_data_->_tmp14_, _data_->_tmp15_, NULL, &_data_->_inner_error0_);
#line 253 "../plugins/LastFM/Core.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 253 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->parser);
#line 253 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->stream);
#line 253 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->uri_request);
#line 1913 "Core.c"
			goto __catch1_g_error;
		}
#line 254 "../plugins/LastFM/Core.vala"
		_data_->_tmp16_ = _data_->parser;
#line 254 "../plugins/LastFM/Core.vala"
		_data_->_tmp17_ = json_parser_get_root (_data_->_tmp16_);
#line 254 "../plugins/LastFM/Core.vala"
		_data_->_tmp18_ = json_node_get_object (_data_->_tmp17_);
#line 254 "../plugins/LastFM/Core.vala"
		_data_->parser_object = _data_->_tmp18_;
#line 255 "../plugins/LastFM/Core.vala"
		_data_->_tmp20_ = _data_->parser_object;
#line 255 "../plugins/LastFM/Core.vala"
		if (_data_->_tmp20_ == NULL) {
#line 255 "../plugins/LastFM/Core.vala"
			_data_->_tmp19_ = TRUE;
#line 1930 "Core.c"
		} else {
#line 255 "../plugins/LastFM/Core.vala"
			_data_->_tmp21_ = _data_->parser_object;
#line 255 "../plugins/LastFM/Core.vala"
			_data_->_tmp19_ = json_object_has_member (_data_->_tmp21_, "album") == FALSE;
#line 1936 "Core.c"
		}
#line 255 "../plugins/LastFM/Core.vala"
		if (_data_->_tmp19_) {
#line 256 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->parser);
#line 256 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->stream);
#line 256 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->uri_request);
#line 256 "../plugins/LastFM/Core.vala"
			_g_object_unref0 (_data_->session);
#line 256 "../plugins/LastFM/Core.vala"
			__vala_SoupURI_free0 (_data_->uri);
#line 256 "../plugins/LastFM/Core.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 256 "../plugins/LastFM/Core.vala"
			if (_data_->_state_ != 0) {
#line 256 "../plugins/LastFM/Core.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 256 "../plugins/LastFM/Core.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1958 "Core.c"
				}
			}
#line 256 "../plugins/LastFM/Core.vala"
			g_object_unref (_data_->_async_result);
#line 256 "../plugins/LastFM/Core.vala"
			return FALSE;
#line 1965 "Core.c"
		}
#line 258 "../plugins/LastFM/Core.vala"
		_data_->_tmp22_ = _data_->parser_object;
#line 258 "../plugins/LastFM/Core.vala"
		_data_->_tmp23_ = json_object_get_member (_data_->_tmp22_, "album");
#line 258 "../plugins/LastFM/Core.vala"
		_data_->_tmp24_ = json_node_get_object (_data_->_tmp23_);
#line 258 "../plugins/LastFM/Core.vala"
		_data_->album_object = _data_->_tmp24_;
#line 259 "../plugins/LastFM/Core.vala"
		_data_->_tmp26_ = _data_->album_object;
#line 259 "../plugins/LastFM/Core.vala"
		if (json_object_has_member (_data_->_tmp26_, "image")) {
#line 259 "../plugins/LastFM/Core.vala"
			_data_->_tmp27_ = _data_->album_object;
#line 259 "../plugins/LastFM/Core.vala"
			_data_->_tmp28_ = json_object_get_member (_data_->_tmp27_, "image");
#line 259 "../plugins/LastFM/Core.vala"
			_data_->_tmp25_ = json_node_get_node_type (_data_->_tmp28_) == JSON_NODE_ARRAY;
#line 1985 "Core.c"
		} else {
#line 259 "../plugins/LastFM/Core.vala"
			_data_->_tmp25_ = FALSE;
#line 1989 "Core.c"
		}
#line 259 "../plugins/LastFM/Core.vala"
		if (_data_->_tmp25_) {
#line 260 "../plugins/LastFM/Core.vala"
			_data_->_tmp29_ = _data_->album_object;
#line 260 "../plugins/LastFM/Core.vala"
			_data_->_tmp30_ = json_object_get_array_member (_data_->_tmp29_, "image");
#line 260 "../plugins/LastFM/Core.vala"
			_data_->_tmp31_ = json_array_get_elements (_data_->_tmp30_);
#line 260 "../plugins/LastFM/Core.vala"
			_data_->image_values = _data_->_tmp31_;
#line 261 "../plugins/LastFM/Core.vala"
			_data_->_tmp32_ = g_strdup ("");
#line 261 "../plugins/LastFM/Core.vala"
			_data_->image_url = _data_->_tmp32_;
#line 262 "../plugins/LastFM/Core.vala"
			_data_->_tmp33_ = g_strdup ("");
#line 262 "../plugins/LastFM/Core.vala"
			_data_->image_size = _data_->_tmp33_;
#line 263 "../plugins/LastFM/Core.vala"
			_data_->_tmp34_ = _data_->image_values;
#line 2011 "Core.c"
			{
#line 263 "../plugins/LastFM/Core.vala"
				_data_->element_collection = _data_->_tmp34_;
#line 263 "../plugins/LastFM/Core.vala"
				for (_data_->element_it = _data_->element_collection; _data_->element_it != NULL; _data_->element_it = _data_->element_it->next) {
#line 263 "../plugins/LastFM/Core.vala"
					_data_->element = (JsonNode*) _data_->element_it->data;
#line 2019 "Core.c"
					{
#line 264 "../plugins/LastFM/Core.vala"
						_data_->_tmp35_ = _data_->element;
#line 264 "../plugins/LastFM/Core.vala"
						_data_->_tmp36_ = json_node_get_object (_data_->_tmp35_);
#line 264 "../plugins/LastFM/Core.vala"
						_data_->image_object = _data_->_tmp36_;
#line 265 "../plugins/LastFM/Core.vala"
						_data_->_tmp37_ = _data_->image_object;
#line 265 "../plugins/LastFM/Core.vala"
						_data_->_tmp38_ = json_object_get_string_member (_data_->_tmp37_, "size");
#line 265 "../plugins/LastFM/Core.vala"
						_data_->new_size = _data_->_tmp38_;
#line 266 "../plugins/LastFM/Core.vala"
						_data_->_tmp41_ = _data_->new_size;
#line 266 "../plugins/LastFM/Core.vala"
						if (g_strcmp0 (_data_->_tmp41_, "mega") == 0) {
#line 266 "../plugins/LastFM/Core.vala"
							_data_->_tmp40_ = TRUE;
#line 2039 "Core.c"
						} else {
#line 267 "../plugins/LastFM/Core.vala"
							_data_->_tmp43_ = _data_->new_size;
#line 267 "../plugins/LastFM/Core.vala"
							if (g_strcmp0 (_data_->_tmp43_, "extralarge") == 0) {
#line 267 "../plugins/LastFM/Core.vala"
								_data_->_tmp44_ = _data_->image_size;
#line 267 "../plugins/LastFM/Core.vala"
								_data_->_tmp42_ = g_strcmp0 (_data_->_tmp44_, "mega") != 0;
#line 2049 "Core.c"
							} else {
#line 267 "../plugins/LastFM/Core.vala"
								_data_->_tmp42_ = FALSE;
#line 2053 "Core.c"
							}
#line 267 "../plugins/LastFM/Core.vala"
							_data_->_tmp40_ = _data_->_tmp42_;
#line 2057 "Core.c"
						}
#line 266 "../plugins/LastFM/Core.vala"
						if (_data_->_tmp40_) {
#line 266 "../plugins/LastFM/Core.vala"
							_data_->_tmp39_ = TRUE;
#line 2063 "Core.c"
						} else {
#line 268 "../plugins/LastFM/Core.vala"
							_data_->_tmp47_ = _data_->new_size;
#line 268 "../plugins/LastFM/Core.vala"
							if (g_strcmp0 (_data_->_tmp47_, "large") == 0) {
#line 268 "../plugins/LastFM/Core.vala"
								_data_->_tmp48_ = _data_->image_size;
#line 268 "../plugins/LastFM/Core.vala"
								_data_->_tmp46_ = g_strcmp0 (_data_->_tmp48_, "mega") != 0;
#line 2073 "Core.c"
							} else {
#line 268 "../plugins/LastFM/Core.vala"
								_data_->_tmp46_ = FALSE;
#line 2077 "Core.c"
							}
#line 268 "../plugins/LastFM/Core.vala"
							if (_data_->_tmp46_) {
#line 268 "../plugins/LastFM/Core.vala"
								_data_->_tmp49_ = _data_->image_size;
#line 268 "../plugins/LastFM/Core.vala"
								_data_->_tmp45_ = g_strcmp0 (_data_->_tmp49_, "extralarge") != 0;
#line 2085 "Core.c"
							} else {
#line 268 "../plugins/LastFM/Core.vala"
								_data_->_tmp45_ = FALSE;
#line 2089 "Core.c"
							}
#line 268 "../plugins/LastFM/Core.vala"
							_data_->_tmp39_ = _data_->_tmp45_;
#line 2093 "Core.c"
						}
#line 266 "../plugins/LastFM/Core.vala"
						if (_data_->_tmp39_) {
#line 269 "../plugins/LastFM/Core.vala"
							_data_->_tmp50_ = _data_->image_object;
#line 269 "../plugins/LastFM/Core.vala"
							_data_->_tmp51_ = json_object_get_string_member (_data_->_tmp50_, "#text");
#line 269 "../plugins/LastFM/Core.vala"
							_data_->_tmp52_ = g_strdup (_data_->_tmp51_);
#line 269 "../plugins/LastFM/Core.vala"
							_g_free0 (_data_->image_url);
#line 269 "../plugins/LastFM/Core.vala"
							_data_->image_url = _data_->_tmp52_;
#line 270 "../plugins/LastFM/Core.vala"
							_data_->_tmp53_ = _data_->new_size;
#line 270 "../plugins/LastFM/Core.vala"
							_data_->_tmp54_ = g_strdup (_data_->_tmp53_);
#line 270 "../plugins/LastFM/Core.vala"
							_g_free0 (_data_->image_size);
#line 270 "../plugins/LastFM/Core.vala"
							_data_->image_size = _data_->_tmp54_;
#line 2115 "Core.c"
						}
					}
				}
			}
#line 274 "../plugins/LastFM/Core.vala"
			_data_->_tmp55_ = _data_->image_url;
#line 274 "../plugins/LastFM/Core.vala"
			if (g_strcmp0 (_data_->_tmp55_, "") != 0) {
#line 275 "../plugins/LastFM/Core.vala"
				_data_->_tmp56_ = _data_->image_url;
#line 275 "../plugins/LastFM/Core.vala"
				g_debug ("Core.vala:275: Caching last.fm image from URL: %s", _data_->_tmp56_);
#line 276 "../plugins/LastFM/Core.vala"
				_data_->_tmp57_ = _data_->image_url;
#line 276 "../plugins/LastFM/Core.vala"
				_data_->_tmp58_ = g_file_new_for_uri (_data_->_tmp57_);
#line 276 "../plugins/LastFM/Core.vala"
				_data_->_tmp59_ = _data_->_tmp58_;
#line 276 "../plugins/LastFM/Core.vala"
				noise_album_save_cover_file (_data_->album, _data_->_tmp59_);
#line 276 "../plugins/LastFM/Core.vala"
				_g_object_unref0 (_data_->_tmp59_);
#line 2138 "Core.c"
			}
#line 259 "../plugins/LastFM/Core.vala"
			_g_free0 (_data_->image_size);
#line 259 "../plugins/LastFM/Core.vala"
			_g_free0 (_data_->image_url);
#line 259 "../plugins/LastFM/Core.vala"
			(_data_->image_values == NULL) ? NULL : (_data_->image_values = (g_list_free (_data_->image_values), NULL));
#line 2146 "Core.c"
		}
#line 280 "../plugins/LastFM/Core.vala"
		_data_->_tmp61_ = _data_->album_object;
#line 280 "../plugins/LastFM/Core.vala"
		if (json_object_has_member (_data_->_tmp61_, "releasedate")) {
#line 280 "../plugins/LastFM/Core.vala"
			_data_->_tmp62_ = noise_album_get_year (_data_->album);
#line 280 "../plugins/LastFM/Core.vala"
			_data_->_tmp63_ = _data_->_tmp62_;
#line 280 "../plugins/LastFM/Core.vala"
			_data_->_tmp60_ = _data_->_tmp63_ == ((guint) 0);
#line 2158 "Core.c"
		} else {
#line 280 "../plugins/LastFM/Core.vala"
			_data_->_tmp60_ = FALSE;
#line 2162 "Core.c"
		}
#line 280 "../plugins/LastFM/Core.vala"
		if (_data_->_tmp60_) {
#line 281 "../plugins/LastFM/Core.vala"
			_data_->_tmp64_ = _data_->album_object;
#line 281 "../plugins/LastFM/Core.vala"
			_data_->_tmp65_ = json_object_get_string_member (_data_->_tmp64_, "releasedate");
#line 281 "../plugins/LastFM/Core.vala"
			_data_->_tmp66_ = g_strdup (_data_->_tmp65_);
#line 281 "../plugins/LastFM/Core.vala"
			_data_->releasedate = _data_->_tmp66_;
#line 282 "../plugins/LastFM/Core.vala"
			memset (&_data_->date, 0, sizeof (GDate));
#line 283 "../plugins/LastFM/Core.vala"
			_data_->_tmp67_ = _data_->releasedate;
#line 283 "../plugins/LastFM/Core.vala"
			g_date_set_parse (&_data_->date, _data_->_tmp67_);
#line 284 "../plugins/LastFM/Core.vala"
			if (g_date_valid (&_data_->date)) {
#line 285 "../plugins/LastFM/Core.vala"
				noise_album_set_year (_data_->album, (guint) g_date_get_year (&_data_->date));
#line 2184 "Core.c"
			}
#line 280 "../plugins/LastFM/Core.vala"
			_g_free0 (_data_->releasedate);
#line 2188 "Core.c"
		}
#line 247 "../plugins/LastFM/Core.vala"
		_g_object_unref0 (_data_->parser);
#line 247 "../plugins/LastFM/Core.vala"
		_g_object_unref0 (_data_->stream);
#line 247 "../plugins/LastFM/Core.vala"
		_g_object_unref0 (_data_->uri_request);
#line 2196 "Core.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 247 "../plugins/LastFM/Core.vala"
		_data_->e = _data_->_inner_error0_;
#line 247 "../plugins/LastFM/Core.vala"
		_data_->_inner_error0_ = NULL;
#line 289 "../plugins/LastFM/Core.vala"
		_data_->_tmp68_ = _data_->e;
#line 289 "../plugins/LastFM/Core.vala"
		_data_->_tmp69_ = _data_->_tmp68_->message;
#line 289 "../plugins/LastFM/Core.vala"
		g_critical ("Core.vala:289: %s", _data_->_tmp69_);
#line 247 "../plugins/LastFM/Core.vala"
		_g_error_free0 (_data_->e);
#line 2213 "Core.c"
	}
	__finally1:
#line 247 "../plugins/LastFM/Core.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 247 "../plugins/LastFM/Core.vala"
		_g_object_unref0 (_data_->session);
#line 247 "../plugins/LastFM/Core.vala"
		__vala_SoupURI_free0 (_data_->uri);
#line 247 "../plugins/LastFM/Core.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 247 "../plugins/LastFM/Core.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 247 "../plugins/LastFM/Core.vala"
		g_object_unref (_data_->_async_result);
#line 247 "../plugins/LastFM/Core.vala"
		return FALSE;
#line 2230 "Core.c"
	}
#line 239 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (_data_->session);
#line 239 "../plugins/LastFM/Core.vala"
	__vala_SoupURI_free0 (_data_->uri);
#line 239 "../plugins/LastFM/Core.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 239 "../plugins/LastFM/Core.vala"
	if (_data_->_state_ != 0) {
#line 239 "../plugins/LastFM/Core.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 239 "../plugins/LastFM/Core.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2244 "Core.c"
		}
	}
#line 239 "../plugins/LastFM/Core.vala"
	g_object_unref (_data_->_async_result);
#line 239 "../plugins/LastFM/Core.vala"
	return FALSE;
#line 2251 "Core.c"
}

gchar*
last_fm_core_generate_md5 (LastFMCore* self,
                           const gchar* text)
{
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
#line 297 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 297 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 298 "../plugins/LastFM/Core.vala"
	_tmp0_ = strlen (text);
#line 298 "../plugins/LastFM/Core.vala"
	_tmp1_ = _tmp0_;
#line 298 "../plugins/LastFM/Core.vala"
	_tmp2_ = g_compute_checksum_for_string (G_CHECKSUM_MD5, text, (gsize) _tmp1_);
#line 298 "../plugins/LastFM/Core.vala"
	result = _tmp2_;
#line 298 "../plugins/LastFM/Core.vala"
	return result;
#line 2276 "Core.c"
}

gchar*
last_fm_core_generate_getsession_signature (LastFMCore* self,
                                            const gchar* token)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
#line 301 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 301 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (token != NULL, NULL);
#line 302 "../plugins/LastFM/Core.vala"
	_tmp0_ = self->api_key;
#line 302 "../plugins/LastFM/Core.vala"
	_tmp1_ = g_strconcat ("api_key", _tmp0_, NULL);
#line 302 "../plugins/LastFM/Core.vala"
	_tmp2_ = _tmp1_;
#line 302 "../plugins/LastFM/Core.vala"
	_tmp3_ = g_strconcat (_tmp2_, "methodauth.getSessiontoken", NULL);
#line 302 "../plugins/LastFM/Core.vala"
	_tmp4_ = _tmp3_;
#line 302 "../plugins/LastFM/Core.vala"
	_tmp5_ = g_strconcat (_tmp4_, token, NULL);
#line 302 "../plugins/LastFM/Core.vala"
	_tmp6_ = _tmp5_;
#line 302 "../plugins/LastFM/Core.vala"
	_tmp7_ = self->api_secret;
#line 302 "../plugins/LastFM/Core.vala"
	_tmp8_ = g_strconcat (_tmp6_, _tmp7_, NULL);
#line 302 "../plugins/LastFM/Core.vala"
	_tmp9_ = _tmp8_;
#line 302 "../plugins/LastFM/Core.vala"
	_tmp10_ = last_fm_core_generate_md5 (self, _tmp9_);
#line 302 "../plugins/LastFM/Core.vala"
	_tmp11_ = _tmp10_;
#line 302 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp9_);
#line 302 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp6_);
#line 302 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp4_);
#line 302 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp2_);
#line 302 "../plugins/LastFM/Core.vala"
	result = _tmp11_;
#line 302 "../plugins/LastFM/Core.vala"
	return result;
#line 2336 "Core.c"
}

gchar*
last_fm_core_generate_tracklove_signature (LastFMCore* self,
                                           const gchar* artist,
                                           const gchar* track)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
#line 305 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 305 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (artist != NULL, NULL);
#line 305 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (track != NULL, NULL);
#line 306 "../plugins/LastFM/Core.vala"
	_tmp0_ = self->api_key;
#line 306 "../plugins/LastFM/Core.vala"
	_tmp1_ = g_strconcat ("api_key", _tmp0_, NULL);
#line 306 "../plugins/LastFM/Core.vala"
	_tmp2_ = _tmp1_;
#line 306 "../plugins/LastFM/Core.vala"
	_tmp3_ = g_strconcat (_tmp2_, "artist", NULL);
#line 306 "../plugins/LastFM/Core.vala"
	_tmp4_ = _tmp3_;
#line 306 "../plugins/LastFM/Core.vala"
	_tmp5_ = g_strconcat (_tmp4_, artist, NULL);
#line 306 "../plugins/LastFM/Core.vala"
	_tmp6_ = _tmp5_;
#line 306 "../plugins/LastFM/Core.vala"
	_tmp7_ = g_strconcat (_tmp6_, "methodtrack.lovesk", NULL);
#line 306 "../plugins/LastFM/Core.vala"
	_tmp8_ = _tmp7_;
#line 306 "../plugins/LastFM/Core.vala"
	_tmp9_ = self->session_key;
#line 306 "../plugins/LastFM/Core.vala"
	_tmp10_ = g_strconcat (_tmp8_, _tmp9_, NULL);
#line 306 "../plugins/LastFM/Core.vala"
	_tmp11_ = _tmp10_;
#line 306 "../plugins/LastFM/Core.vala"
	_tmp12_ = g_strconcat (_tmp11_, "track", NULL);
#line 306 "../plugins/LastFM/Core.vala"
	_tmp13_ = _tmp12_;
#line 306 "../plugins/LastFM/Core.vala"
	_tmp14_ = g_strconcat (_tmp13_, track, NULL);
#line 306 "../plugins/LastFM/Core.vala"
	_tmp15_ = _tmp14_;
#line 306 "../plugins/LastFM/Core.vala"
	_tmp16_ = self->api_secret;
#line 306 "../plugins/LastFM/Core.vala"
	_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
#line 306 "../plugins/LastFM/Core.vala"
	_tmp18_ = _tmp17_;
#line 306 "../plugins/LastFM/Core.vala"
	_tmp19_ = last_fm_core_generate_md5 (self, _tmp18_);
#line 306 "../plugins/LastFM/Core.vala"
	_tmp20_ = _tmp19_;
#line 306 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp18_);
#line 306 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp15_);
#line 306 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp13_);
#line 306 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp11_);
#line 306 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp8_);
#line 306 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp6_);
#line 306 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp4_);
#line 306 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp2_);
#line 306 "../plugins/LastFM/Core.vala"
	result = _tmp20_;
#line 306 "../plugins/LastFM/Core.vala"
	return result;
#line 2434 "Core.c"
}

gchar*
last_fm_core_generate_trackban_signature (LastFMCore* self,
                                          const gchar* artist,
                                          const gchar* track)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
#line 309 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 309 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (artist != NULL, NULL);
#line 309 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (track != NULL, NULL);
#line 310 "../plugins/LastFM/Core.vala"
	_tmp0_ = self->api_key;
#line 310 "../plugins/LastFM/Core.vala"
	_tmp1_ = g_strconcat ("api_key", _tmp0_, NULL);
#line 310 "../plugins/LastFM/Core.vala"
	_tmp2_ = _tmp1_;
#line 310 "../plugins/LastFM/Core.vala"
	_tmp3_ = g_strconcat (_tmp2_, "artist", NULL);
#line 310 "../plugins/LastFM/Core.vala"
	_tmp4_ = _tmp3_;
#line 310 "../plugins/LastFM/Core.vala"
	_tmp5_ = g_strconcat (_tmp4_, artist, NULL);
#line 310 "../plugins/LastFM/Core.vala"
	_tmp6_ = _tmp5_;
#line 310 "../plugins/LastFM/Core.vala"
	_tmp7_ = g_strconcat (_tmp6_, "methodtrack.bansk", NULL);
#line 310 "../plugins/LastFM/Core.vala"
	_tmp8_ = _tmp7_;
#line 310 "../plugins/LastFM/Core.vala"
	_tmp9_ = self->session_key;
#line 310 "../plugins/LastFM/Core.vala"
	_tmp10_ = g_strconcat (_tmp8_, _tmp9_, NULL);
#line 310 "../plugins/LastFM/Core.vala"
	_tmp11_ = _tmp10_;
#line 310 "../plugins/LastFM/Core.vala"
	_tmp12_ = g_strconcat (_tmp11_, "track", NULL);
#line 310 "../plugins/LastFM/Core.vala"
	_tmp13_ = _tmp12_;
#line 310 "../plugins/LastFM/Core.vala"
	_tmp14_ = g_strconcat (_tmp13_, track, NULL);
#line 310 "../plugins/LastFM/Core.vala"
	_tmp15_ = _tmp14_;
#line 310 "../plugins/LastFM/Core.vala"
	_tmp16_ = self->api_secret;
#line 310 "../plugins/LastFM/Core.vala"
	_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
#line 310 "../plugins/LastFM/Core.vala"
	_tmp18_ = _tmp17_;
#line 310 "../plugins/LastFM/Core.vala"
	_tmp19_ = last_fm_core_generate_md5 (self, _tmp18_);
#line 310 "../plugins/LastFM/Core.vala"
	_tmp20_ = _tmp19_;
#line 310 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp18_);
#line 310 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp15_);
#line 310 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp13_);
#line 310 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp11_);
#line 310 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp8_);
#line 310 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp6_);
#line 310 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp4_);
#line 310 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp2_);
#line 310 "../plugins/LastFM/Core.vala"
	result = _tmp20_;
#line 310 "../plugins/LastFM/Core.vala"
	return result;
#line 2532 "Core.c"
}

gchar*
last_fm_core_generate_trackscrobble_signature (LastFMCore* self,
                                               const gchar* artist,
                                               const gchar* track,
                                               gint timestamp)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
#line 313 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 313 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (artist != NULL, NULL);
#line 313 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (track != NULL, NULL);
#line 314 "../plugins/LastFM/Core.vala"
	_tmp0_ = self->api_key;
#line 314 "../plugins/LastFM/Core.vala"
	_tmp1_ = g_strconcat ("api_key", _tmp0_, NULL);
#line 314 "../plugins/LastFM/Core.vala"
	_tmp2_ = _tmp1_;
#line 314 "../plugins/LastFM/Core.vala"
	_tmp3_ = g_strconcat (_tmp2_, "artist", NULL);
#line 314 "../plugins/LastFM/Core.vala"
	_tmp4_ = _tmp3_;
#line 314 "../plugins/LastFM/Core.vala"
	_tmp5_ = g_strconcat (_tmp4_, artist, NULL);
#line 314 "../plugins/LastFM/Core.vala"
	_tmp6_ = _tmp5_;
#line 314 "../plugins/LastFM/Core.vala"
	_tmp7_ = g_strconcat (_tmp6_, "methodtrack.scrobblesk", NULL);
#line 314 "../plugins/LastFM/Core.vala"
	_tmp8_ = _tmp7_;
#line 314 "../plugins/LastFM/Core.vala"
	_tmp9_ = self->session_key;
#line 314 "../plugins/LastFM/Core.vala"
	_tmp10_ = g_strconcat (_tmp8_, _tmp9_, NULL);
#line 314 "../plugins/LastFM/Core.vala"
	_tmp11_ = _tmp10_;
#line 314 "../plugins/LastFM/Core.vala"
	_tmp12_ = g_strconcat (_tmp11_, "timestamp", NULL);
#line 314 "../plugins/LastFM/Core.vala"
	_tmp13_ = _tmp12_;
#line 314 "../plugins/LastFM/Core.vala"
	_tmp14_ = g_strdup_printf ("%i", timestamp);
#line 314 "../plugins/LastFM/Core.vala"
	_tmp15_ = _tmp14_;
#line 314 "../plugins/LastFM/Core.vala"
	_tmp16_ = g_strconcat (_tmp13_, _tmp15_, NULL);
#line 314 "../plugins/LastFM/Core.vala"
	_tmp17_ = _tmp16_;
#line 314 "../plugins/LastFM/Core.vala"
	_tmp18_ = g_strconcat (_tmp17_, "track", NULL);
#line 314 "../plugins/LastFM/Core.vala"
	_tmp19_ = _tmp18_;
#line 314 "../plugins/LastFM/Core.vala"
	_tmp20_ = g_strconcat (_tmp19_, track, NULL);
#line 314 "../plugins/LastFM/Core.vala"
	_tmp21_ = _tmp20_;
#line 314 "../plugins/LastFM/Core.vala"
	_tmp22_ = self->api_secret;
#line 314 "../plugins/LastFM/Core.vala"
	_tmp23_ = g_strconcat (_tmp21_, _tmp22_, NULL);
#line 314 "../plugins/LastFM/Core.vala"
	_tmp24_ = _tmp23_;
#line 314 "../plugins/LastFM/Core.vala"
	_tmp25_ = last_fm_core_generate_md5 (self, _tmp24_);
#line 314 "../plugins/LastFM/Core.vala"
	_tmp26_ = _tmp25_;
#line 314 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp24_);
#line 314 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp21_);
#line 314 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp19_);
#line 314 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp17_);
#line 314 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp15_);
#line 314 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp13_);
#line 314 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp11_);
#line 314 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp8_);
#line 314 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp6_);
#line 314 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp4_);
#line 314 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp2_);
#line 314 "../plugins/LastFM/Core.vala"
	result = _tmp26_;
#line 314 "../plugins/LastFM/Core.vala"
	return result;
#line 2655 "Core.c"
}

gchar*
last_fm_core_generate_trackscrobble_signature2 (LastFMCore* self,
                                                const gchar* artist,
                                                const gchar* track,
                                                const gchar* album,
                                                gint timestamp)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
#line 317 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 317 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (artist != NULL, NULL);
#line 317 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (track != NULL, NULL);
#line 317 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (album != NULL, NULL);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp0_ = g_strconcat ("album", album, NULL);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp1_ = _tmp0_;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp2_ = g_strconcat (_tmp1_, "api_key", NULL);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp3_ = _tmp2_;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp4_ = self->api_key;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp5_ = g_strconcat (_tmp3_, _tmp4_, NULL);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp6_ = _tmp5_;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp7_ = g_strconcat (_tmp6_, "artist", NULL);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp8_ = _tmp7_;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp9_ = g_strconcat (_tmp8_, artist, NULL);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp10_ = _tmp9_;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp11_ = g_strconcat (_tmp10_, "methodtrack.scrobblesk", NULL);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp12_ = _tmp11_;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp13_ = self->session_key;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp14_ = g_strconcat (_tmp12_, _tmp13_, NULL);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp15_ = _tmp14_;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp16_ = g_strconcat (_tmp15_, "timestamp", NULL);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp17_ = _tmp16_;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp18_ = g_strdup_printf ("%i", timestamp);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp19_ = _tmp18_;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp20_ = g_strconcat (_tmp17_, _tmp19_, NULL);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp21_ = _tmp20_;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp22_ = g_strconcat (_tmp21_, "track", NULL);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp23_ = _tmp22_;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp24_ = g_strconcat (_tmp23_, track, NULL);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp25_ = _tmp24_;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp26_ = self->api_secret;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp27_ = g_strconcat (_tmp25_, _tmp26_, NULL);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp28_ = _tmp27_;
#line 318 "../plugins/LastFM/Core.vala"
	_tmp29_ = last_fm_core_generate_md5 (self, _tmp28_);
#line 318 "../plugins/LastFM/Core.vala"
	_tmp30_ = _tmp29_;
#line 318 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp28_);
#line 318 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp25_);
#line 318 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp23_);
#line 318 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp21_);
#line 318 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp19_);
#line 318 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp17_);
#line 318 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp15_);
#line 318 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp12_);
#line 318 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp10_);
#line 318 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp8_);
#line 318 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp6_);
#line 318 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp3_);
#line 318 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp1_);
#line 318 "../plugins/LastFM/Core.vala"
	result = _tmp30_;
#line 318 "../plugins/LastFM/Core.vala"
	return result;
#line 2797 "Core.c"
}

gchar*
last_fm_core_generate_trackupdatenowplaying_signature (LastFMCore* self,
                                                       const gchar* artist,
                                                       const gchar* track)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
#line 321 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 321 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (artist != NULL, NULL);
#line 321 "../plugins/LastFM/Core.vala"
	g_return_val_if_fail (track != NULL, NULL);
#line 322 "../plugins/LastFM/Core.vala"
	_tmp0_ = self->api_key;
#line 322 "../plugins/LastFM/Core.vala"
	_tmp1_ = g_strconcat ("api_key", _tmp0_, NULL);
#line 322 "../plugins/LastFM/Core.vala"
	_tmp2_ = _tmp1_;
#line 322 "../plugins/LastFM/Core.vala"
	_tmp3_ = g_strconcat (_tmp2_, "artist", NULL);
#line 322 "../plugins/LastFM/Core.vala"
	_tmp4_ = _tmp3_;
#line 322 "../plugins/LastFM/Core.vala"
	_tmp5_ = g_strconcat (_tmp4_, artist, NULL);
#line 322 "../plugins/LastFM/Core.vala"
	_tmp6_ = _tmp5_;
#line 322 "../plugins/LastFM/Core.vala"
	_tmp7_ = g_strconcat (_tmp6_, "methodtrack.updateNowPlayingsk", NULL);
#line 322 "../plugins/LastFM/Core.vala"
	_tmp8_ = _tmp7_;
#line 322 "../plugins/LastFM/Core.vala"
	_tmp9_ = self->session_key;
#line 322 "../plugins/LastFM/Core.vala"
	_tmp10_ = g_strconcat (_tmp8_, _tmp9_, NULL);
#line 322 "../plugins/LastFM/Core.vala"
	_tmp11_ = _tmp10_;
#line 322 "../plugins/LastFM/Core.vala"
	_tmp12_ = g_strconcat (_tmp11_, "track", NULL);
#line 322 "../plugins/LastFM/Core.vala"
	_tmp13_ = _tmp12_;
#line 322 "../plugins/LastFM/Core.vala"
	_tmp14_ = g_strconcat (_tmp13_, track, NULL);
#line 322 "../plugins/LastFM/Core.vala"
	_tmp15_ = _tmp14_;
#line 322 "../plugins/LastFM/Core.vala"
	_tmp16_ = self->api_secret;
#line 322 "../plugins/LastFM/Core.vala"
	_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
#line 322 "../plugins/LastFM/Core.vala"
	_tmp18_ = _tmp17_;
#line 322 "../plugins/LastFM/Core.vala"
	_tmp19_ = last_fm_core_generate_md5 (self, _tmp18_);
#line 322 "../plugins/LastFM/Core.vala"
	_tmp20_ = _tmp19_;
#line 322 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp18_);
#line 322 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp15_);
#line 322 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp13_);
#line 322 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp11_);
#line 322 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp8_);
#line 322 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp6_);
#line 322 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp4_);
#line 322 "../plugins/LastFM/Core.vala"
	_g_free0 (_tmp2_);
#line 322 "../plugins/LastFM/Core.vala"
	result = _tmp20_;
#line 322 "../plugins/LastFM/Core.vala"
	return result;
#line 2895 "Core.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 33 "../plugins/LastFM/Core.vala"
	g_return_if_fail (n_param_values == 3);
#line 33 "../plugins/LastFM/Core.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 33 "../plugins/LastFM/Core.vala"
		data1 = closure->data;
#line 33 "../plugins/LastFM/Core.vala"
		data2 = param_values->data[0].v_pointer;
#line 2920 "Core.c"
	} else {
#line 33 "../plugins/LastFM/Core.vala"
		data1 = param_values->data[0].v_pointer;
#line 33 "../plugins/LastFM/Core.vala"
		data2 = closure->data;
#line 2926 "Core.c"
	}
#line 33 "../plugins/LastFM/Core.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 33 "../plugins/LastFM/Core.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 2932 "Core.c"
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 33 "../plugins/LastFM/Core.vala"
	g_return_if_fail (n_param_values == 3);
#line 33 "../plugins/LastFM/Core.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 33 "../plugins/LastFM/Core.vala"
		data1 = closure->data;
#line 33 "../plugins/LastFM/Core.vala"
		data2 = param_values->data[0].v_pointer;
#line 2957 "Core.c"
	} else {
#line 33 "../plugins/LastFM/Core.vala"
		data1 = param_values->data[0].v_pointer;
#line 33 "../plugins/LastFM/Core.vala"
		data2 = closure->data;
#line 2963 "Core.c"
	}
#line 33 "../plugins/LastFM/Core.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
#line 33 "../plugins/LastFM/Core.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 2969 "Core.c"
}

static void
last_fm_core_class_init (LastFMCoreClass * klass,
                         gpointer klass_data)
{
#line 33 "../plugins/LastFM/Core.vala"
	last_fm_core_parent_class = g_type_class_peek_parent (klass);
#line 33 "../plugins/LastFM/Core.vala"
	g_type_class_adjust_private_offset (klass, &LastFMCore_private_offset);
#line 33 "../plugins/LastFM/Core.vala"
	G_OBJECT_CLASS (klass)->finalize = last_fm_core_finalize;
#line 33 "../plugins/LastFM/Core.vala"
	last_fm_core_signals[LAST_FM_CORE_SIMILAR_RETRIEVED_SIGNAL] = g_signal_new ("similar-retrieved", LAST_FM_TYPE_CORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_LINKED_LIST, GEE_TYPE_LINKED_LIST);
#line 33 "../plugins/LastFM/Core.vala"
	last_fm_core_signals[LAST_FM_CORE_LOVED_SIGNAL] = g_signal_new ("loved", LAST_FM_TYPE_CORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
#line 33 "../plugins/LastFM/Core.vala"
	last_fm_core_signals[LAST_FM_CORE_BANED_SIGNAL] = g_signal_new ("baned", LAST_FM_TYPE_CORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
#line 2988 "Core.c"
}

static void
last_fm_core_instance_init (LastFMCore * self,
                            gpointer klass)
{
#line 33 "../plugins/LastFM/Core.vala"
	self->priv = last_fm_core_get_instance_private (self);
#line 38 "../plugins/LastFM/Core.vala"
	self->is_initialized = FALSE;
#line 2999 "Core.c"
}

static void
last_fm_core_finalize (GObject * obj)
{
	LastFMCore * self;
#line 33 "../plugins/LastFM/Core.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LAST_FM_TYPE_CORE, LastFMCore);
#line 41 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (self->priv->similarMedias);
#line 43 "../plugins/LastFM/Core.vala"
	_g_free0 (self->api_key);
#line 44 "../plugins/LastFM/Core.vala"
	_g_free0 (self->api_secret);
#line 45 "../plugins/LastFM/Core.vala"
	_g_free0 (self->session_key);
#line 55 "../plugins/LastFM/Core.vala"
	_g_object_unref0 (self->priv->fetch_cancellable);
#line 33 "../plugins/LastFM/Core.vala"
	G_OBJECT_CLASS (last_fm_core_parent_class)->finalize (obj);
#line 3020 "Core.c"
}

GType
last_fm_core_get_type (void)
{
	return last_fm_core_type_id;
}

GType
last_fm_core_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (LastFMCoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) last_fm_core_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LastFMCore), 0, (GInstanceInitFunc) last_fm_core_instance_init, NULL };
	last_fm_core_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "LastFMCore", &g_define_type_info, 0);
	LastFMCore_private_offset = sizeof (LastFMCorePrivate);
	return last_fm_core_type_id;
}

