/* SimilarMedia.c generated by valac 0.45.3, the Vala compiler
 * generated from SimilarMedia.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>,
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */
/* Merely a place holder for multiple pieces of information regarding
 * the current media playing. Mostly here because of dependence. */

#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include "music-lib.h"
#include <gee.h>
#include <stdlib.h>
#include <string.h>

#define LAST_FM_TYPE_SIMILAR_MEDIAS (last_fm_similar_medias_get_type ())
#define LAST_FM_SIMILAR_MEDIAS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LAST_FM_TYPE_SIMILAR_MEDIAS, LastFMSimilarMedias))
#define LAST_FM_SIMILAR_MEDIAS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LAST_FM_TYPE_SIMILAR_MEDIAS, LastFMSimilarMediasClass))
#define LAST_FM_IS_SIMILAR_MEDIAS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LAST_FM_TYPE_SIMILAR_MEDIAS))
#define LAST_FM_IS_SIMILAR_MEDIAS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LAST_FM_TYPE_SIMILAR_MEDIAS))
#define LAST_FM_SIMILAR_MEDIAS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LAST_FM_TYPE_SIMILAR_MEDIAS, LastFMSimilarMediasClass))

typedef struct _LastFMSimilarMedias LastFMSimilarMedias;
typedef struct _LastFMSimilarMediasClass LastFMSimilarMediasClass;
typedef struct _LastFMSimilarMediasPrivate LastFMSimilarMediasPrivate;
enum  {
	LAST_FM_SIMILAR_MEDIAS_0_PROPERTY,
	LAST_FM_SIMILAR_MEDIAS_NUM_PROPERTIES
};
static GParamSpec* last_fm_similar_medias_properties[LAST_FM_SIMILAR_MEDIAS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define LAST_FM_TYPE_CORE (last_fm_core_get_type ())
#define LAST_FM_CORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LAST_FM_TYPE_CORE, LastFMCore))
#define LAST_FM_CORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LAST_FM_TYPE_CORE, LastFMCoreClass))
#define LAST_FM_IS_CORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LAST_FM_TYPE_CORE))
#define LAST_FM_IS_CORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LAST_FM_TYPE_CORE))
#define LAST_FM_CORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LAST_FM_TYPE_CORE, LastFMCoreClass))

typedef struct _LastFMCore LastFMCore;
typedef struct _LastFMCoreClass LastFMCoreClass;
typedef struct _LastFmSimilarMediasSimilarAsyncData LastFmSimilarMediasSimilarAsyncData;
enum  {
	LAST_FM_SIMILAR_MEDIAS_SIMILAR_RETRIEVED_SIGNAL,
	LAST_FM_SIMILAR_MEDIAS_NUM_SIGNALS
};
static guint last_fm_similar_medias_signals[LAST_FM_SIMILAR_MEDIAS_NUM_SIGNALS] = {0};

struct _LastFMSimilarMedias {
	GObject parent_instance;
	LastFMSimilarMediasPrivate * priv;
	NoiseStaticPlaylist* similar_playlist;
};

struct _LastFMSimilarMediasClass {
	GObjectClass parent_class;
	void (*query_for_similar) (LastFMSimilarMedias* self, NoiseMedia* s);
};

struct _LastFMSimilarMediasPrivate {
	GRecMutex __lock_similar_playlist;
	GCancellable* cancellable;
};

struct _LastFmSimilarMediasSimilarAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	LastFMSimilarMedias* self;
	NoiseMedia* s;
	GCancellable* _tmp0_;
	GeeTreeSet* similar_medias;
	LastFMCore* _tmp1_;
	LastFMCore* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GCancellable* _tmp7_;
	GeeTreeSet* _tmp8_;
	GeeTreeSet* _tmp9_;
	GCancellable* _tmp10_;
	GeeLinkedList* similarIDs;
	GeeLinkedList* _tmp11_;
	GeeLinkedList* similarDont;
	GeeLinkedList* _tmp12_;
	NoiseLibrariesManager* _tmp13_;
	NoiseLibrary* _tmp14_;
	GeeTreeSet* _tmp15_;
	GeeLinkedList* _tmp16_;
	GeeLinkedList* _tmp17_;
	GCancellable* _tmp18_;
	GeeLinkedList* _tmp19_;
	gint64 _tmp20_;
	gint64 _tmp21_;
	GeeCollection* found_medias;
	NoiseLibrariesManager* _tmp22_;
	NoiseLibrary* _tmp23_;
	GeeLinkedList* _tmp24_;
	GeeCollection* _tmp25_;
	GeeCollection* _tmp26_;
	NoiseStaticPlaylist* _tmp27_;
	GeeCollection* _tmp28_;
	GeeLinkedList* _tmp29_;
	GeeLinkedList* _tmp30_;
};

static gint LastFMSimilarMedias_private_offset;
static gpointer last_fm_similar_medias_parent_class = NULL;
static GType last_fm_similar_medias_type_id = 0;

GType last_fm_similar_medias_register_type (GTypeModule * module);
GType last_fm_similar_medias_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LastFMSimilarMedias, g_object_unref)
#define LAST_FM_SIMILAR_MEDIAS_MAX_FETCHED 20
LastFMSimilarMedias* last_fm_similar_medias_new (void);
LastFMSimilarMedias* last_fm_similar_medias_construct (GType object_type);
static void __lambda4_ (LastFMSimilarMedias* self,
                 NoisePlaybackManager* m);
static void ___lambda4__noise_playback_manager_changing_player (NoisePlaybackManager* _sender,
                                                         gpointer self);
void last_fm_similar_medias_query_for_similar (LastFMSimilarMedias* self,
                                               NoiseMedia* s);
static void last_fm_similar_medias_real_query_for_similar (LastFMSimilarMedias* self,
                                                    NoiseMedia* s);
void last_fm_similar_medias_similar_async (LastFMSimilarMedias* self,
                                           NoiseMedia* s,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
void last_fm_similar_medias_similar_finish (LastFMSimilarMedias* self,
                                            GAsyncResult* _res_);
static void last_fm_similar_medias_similar_async_data_free (gpointer _data);
static gboolean last_fm_similar_medias_similar_async_co (LastFmSimilarMediasSimilarAsyncData* _data_);
GType last_fm_core_register_type (GTypeModule * module);
GType last_fm_core_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LastFMCore, g_object_unref)
LastFMCore* last_fm_core_get_default (void);
void last_fm_core_get_similar_tracks (LastFMCore* self,
                                      const gchar* title,
                                      const gchar* artist,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
GeeTreeSet* last_fm_core_get_similar_tracks_finish (LastFMCore* self,
                                                    GAsyncResult* _res_);
static void last_fm_similar_medias_similar_async_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static gint64* _int64_dup (gint64* self);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void last_fm_similar_medias_finalize (GObject * obj);

static inline gpointer
last_fm_similar_medias_get_instance_private (LastFMSimilarMedias* self)
{
	return G_STRUCT_MEMBER_P (self, LastFMSimilarMedias_private_offset);
}

static void
__lambda4_ (LastFMSimilarMedias* self,
            NoisePlaybackManager* m)
{
	GError* _inner_error0_ = NULL;
#line 49 "../plugins/LastFM/SimilarMedia.vala"
	g_return_if_fail (m != NULL);
#line 202 "SimilarMedia.c"
	{
		NoiseStaticPlaylist* _tmp0_;
#line 50 "../plugins/LastFM/SimilarMedia.vala"
		_tmp0_ = self->similar_playlist;
#line 50 "../plugins/LastFM/SimilarMedia.vala"
		g_rec_mutex_lock (&self->priv->__lock_similar_playlist);
#line 209 "SimilarMedia.c"
		{
			NoiseStaticPlaylist* _tmp1_;
#line 51 "../plugins/LastFM/SimilarMedia.vala"
			_tmp1_ = self->similar_playlist;
#line 51 "../plugins/LastFM/SimilarMedia.vala"
			noise_playlist_clear ((NoisePlaylist*) _tmp1_);
#line 216 "SimilarMedia.c"
		}
		__finally3:
		{
			NoiseStaticPlaylist* _tmp2_;
#line 50 "../plugins/LastFM/SimilarMedia.vala"
			_tmp2_ = self->similar_playlist;
#line 50 "../plugins/LastFM/SimilarMedia.vala"
			g_rec_mutex_unlock (&self->priv->__lock_similar_playlist);
#line 225 "SimilarMedia.c"
		}
#line 50 "../plugins/LastFM/SimilarMedia.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 50 "../plugins/LastFM/SimilarMedia.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 50 "../plugins/LastFM/SimilarMedia.vala"
			g_clear_error (&_inner_error0_);
#line 50 "../plugins/LastFM/SimilarMedia.vala"
			return;
#line 235 "SimilarMedia.c"
		}
	}
}

static void
___lambda4__noise_playback_manager_changing_player (NoisePlaybackManager* _sender,
                                                    gpointer self)
{
#line 49 "../plugins/LastFM/SimilarMedia.vala"
	__lambda4_ ((LastFMSimilarMedias*) self, _sender);
#line 246 "SimilarMedia.c"
}

LastFMSimilarMedias*
last_fm_similar_medias_construct (GType object_type)
{
	LastFMSimilarMedias * self = NULL;
	GCancellable* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	NoiseStaticPlaylist* _tmp2_;
	NoiseStaticPlaylist* _tmp3_;
	NoiseStaticPlaylist* _tmp4_;
	NoiseStaticPlaylist* _tmp5_;
	GThemedIcon* _tmp6_;
	NoisePlaybackManager* _tmp7_;
	NoisePlaybackManager* _tmp8_;
#line 41 "../plugins/LastFM/SimilarMedia.vala"
	self = (LastFMSimilarMedias*) g_object_new (object_type, NULL);
#line 42 "../plugins/LastFM/SimilarMedia.vala"
	_tmp0_ = g_cancellable_new ();
#line 42 "../plugins/LastFM/SimilarMedia.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 42 "../plugins/LastFM/SimilarMedia.vala"
	self->priv->cancellable = _tmp0_;
#line 43 "../plugins/LastFM/SimilarMedia.vala"
	_tmp1_ = noise_static_playlist_new ();
#line 43 "../plugins/LastFM/SimilarMedia.vala"
	_g_object_unref0 (self->similar_playlist);
#line 43 "../plugins/LastFM/SimilarMedia.vala"
	self->similar_playlist = _tmp1_;
#line 44 "../plugins/LastFM/SimilarMedia.vala"
	_tmp2_ = self->similar_playlist;
#line 44 "../plugins/LastFM/SimilarMedia.vala"
	noise_playlist_set_name ((NoisePlaylist*) _tmp2_, _ ("Similar"));
#line 45 "../plugins/LastFM/SimilarMedia.vala"
	_tmp3_ = self->similar_playlist;
#line 45 "../plugins/LastFM/SimilarMedia.vala"
	noise_static_playlist_set_read_only (_tmp3_, TRUE);
#line 46 "../plugins/LastFM/SimilarMedia.vala"
	_tmp4_ = self->similar_playlist;
#line 46 "../plugins/LastFM/SimilarMedia.vala"
	noise_static_playlist_set_show_badge (_tmp4_, TRUE);
#line 47 "../plugins/LastFM/SimilarMedia.vala"
	_tmp5_ = self->similar_playlist;
#line 47 "../plugins/LastFM/SimilarMedia.vala"
	_tmp6_ = (GThemedIcon*) g_themed_icon_new ("playlist-similar");
#line 47 "../plugins/LastFM/SimilarMedia.vala"
	_g_object_unref0 (((NoisePlaylist*) _tmp5_)->icon);
#line 47 "../plugins/LastFM/SimilarMedia.vala"
	((NoisePlaylist*) _tmp5_)->icon = (GIcon*) _tmp6_;
#line 49 "../plugins/LastFM/SimilarMedia.vala"
	_tmp7_ = noise_app_get_player ();
#line 49 "../plugins/LastFM/SimilarMedia.vala"
	_tmp8_ = _tmp7_;
#line 49 "../plugins/LastFM/SimilarMedia.vala"
	g_signal_connect_object (_tmp8_, "changing-player", (GCallback) ___lambda4__noise_playback_manager_changing_player, self, 0);
#line 41 "../plugins/LastFM/SimilarMedia.vala"
	return self;
#line 304 "SimilarMedia.c"
}

LastFMSimilarMedias*
last_fm_similar_medias_new (void)
{
#line 41 "../plugins/LastFM/SimilarMedia.vala"
	return last_fm_similar_medias_construct (LAST_FM_TYPE_SIMILAR_MEDIAS);
#line 312 "SimilarMedia.c"
}

static void
last_fm_similar_medias_real_query_for_similar (LastFMSimilarMedias* self,
                                               NoiseMedia* s)
{
	GCancellable* _tmp0_;
#line 56 "../plugins/LastFM/SimilarMedia.vala"
	g_return_if_fail (s != NULL);
#line 57 "../plugins/LastFM/SimilarMedia.vala"
	_tmp0_ = self->priv->cancellable;
#line 57 "../plugins/LastFM/SimilarMedia.vala"
	if (g_cancellable_is_cancelled (_tmp0_) == FALSE) {
#line 326 "SimilarMedia.c"
		GCancellable* _tmp1_;
#line 58 "../plugins/LastFM/SimilarMedia.vala"
		_tmp1_ = self->priv->cancellable;
#line 58 "../plugins/LastFM/SimilarMedia.vala"
		g_cancellable_cancel (_tmp1_);
#line 332 "SimilarMedia.c"
	}
#line 61 "../plugins/LastFM/SimilarMedia.vala"
	last_fm_similar_medias_similar_async (self, s, NULL, NULL);
#line 336 "SimilarMedia.c"
}

void
last_fm_similar_medias_query_for_similar (LastFMSimilarMedias* self,
                                          NoiseMedia* s)
{
#line 56 "../plugins/LastFM/SimilarMedia.vala"
	g_return_if_fail (self != NULL);
#line 56 "../plugins/LastFM/SimilarMedia.vala"
	LAST_FM_SIMILAR_MEDIAS_GET_CLASS (self)->query_for_similar (self, s);
#line 347 "SimilarMedia.c"
}

static void
last_fm_similar_medias_similar_async_data_free (gpointer _data)
{
	LastFmSimilarMediasSimilarAsyncData* _data_;
	_data_ = _data;
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	_g_object_unref0 (_data_->s);
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	_g_object_unref0 (_data_->self);
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	g_slice_free (LastFmSimilarMediasSimilarAsyncData, _data_);
#line 361 "SimilarMedia.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	return self ? g_object_ref (self) : NULL;
#line 369 "SimilarMedia.c"
}

void
last_fm_similar_medias_similar_async (LastFMSimilarMedias* self,
                                      NoiseMedia* s,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	LastFmSimilarMediasSimilarAsyncData* _data_;
	LastFMSimilarMedias* _tmp0_;
	NoiseMedia* _tmp1_;
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	_data_ = g_slice_new0 (LastFmSimilarMediasSimilarAsyncData);
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	g_task_set_task_data (_data_->_async_result, _data_, last_fm_similar_medias_similar_async_data_free);
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	_data_->self = _tmp0_;
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	_tmp1_ = _g_object_ref0 (s);
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	_g_object_unref0 (_data_->s);
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	_data_->s = _tmp1_;
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	last_fm_similar_medias_similar_async_co (_data_);
#line 399 "SimilarMedia.c"
}

void
last_fm_similar_medias_similar_finish (LastFMSimilarMedias* self,
                                       GAsyncResult* _res_)
{
	LastFmSimilarMediasSimilarAsyncData* _data_;
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 409 "SimilarMedia.c"
}

static void
last_fm_similar_medias_similar_async_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	LastFmSimilarMediasSimilarAsyncData* _data_;
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_data_ = _user_data_;
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_source_object_ = source_object;
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_res_ = _res_;
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	last_fm_similar_medias_similar_async_co (_data_);
#line 426 "SimilarMedia.c"
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 71 "../plugins/LastFM/SimilarMedia.vala"
	dup = g_new0 (gint64, 1);
#line 71 "../plugins/LastFM/SimilarMedia.vala"
	memcpy (dup, self, sizeof (gint64));
#line 71 "../plugins/LastFM/SimilarMedia.vala"
	return dup;
#line 439 "SimilarMedia.c"
}

static gboolean
last_fm_similar_medias_similar_async_co (LastFmSimilarMediasSimilarAsyncData* _data_)
{
#line 64 "../plugins/LastFM/SimilarMedia.vala"
	switch (_data_->_state_) {
#line 64 "../plugins/LastFM/SimilarMedia.vala"
		case 0:
#line 449 "SimilarMedia.c"
		goto _state_0;
#line 64 "../plugins/LastFM/SimilarMedia.vala"
		case 1:
#line 453 "SimilarMedia.c"
		goto _state_1;
		default:
#line 64 "../plugins/LastFM/SimilarMedia.vala"
		g_assert_not_reached ();
#line 458 "SimilarMedia.c"
	}
	_state_0:
#line 65 "../plugins/LastFM/SimilarMedia.vala"
	g_debug ("SimilarMedia.vala:65: In the similar thread");
#line 66 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp0_ = _data_->self->priv->cancellable;
#line 66 "../plugins/LastFM/SimilarMedia.vala"
	g_cancellable_reset (_data_->_tmp0_);
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp1_ = last_fm_core_get_default ();
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp3_ = noise_media_get_title (_data_->s);
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp5_ = noise_media_get_artist (_data_->s);
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp7_ = _data_->self->priv->cancellable;
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_state_ = 1;
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	last_fm_core_get_similar_tracks (_data_->_tmp2_, _data_->_tmp4_, _data_->_tmp6_, _data_->_tmp7_, last_fm_similar_medias_similar_async_ready, _data_);
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	return FALSE;
#line 487 "SimilarMedia.c"
	_state_1:
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp8_ = last_fm_core_get_similar_tracks_finish (_data_->_tmp2_, _data_->_res_);
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_g_object_unref0 (_data_->_tmp2_);
#line 67 "../plugins/LastFM/SimilarMedia.vala"
	_data_->similar_medias = _data_->_tmp9_;
#line 68 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp10_ = _data_->self->priv->cancellable;
#line 68 "../plugins/LastFM/SimilarMedia.vala"
	if (g_cancellable_is_cancelled (_data_->_tmp10_)) {
#line 69 "../plugins/LastFM/SimilarMedia.vala"
		_g_object_unref0 (_data_->similar_medias);
#line 69 "../plugins/LastFM/SimilarMedia.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 69 "../plugins/LastFM/SimilarMedia.vala"
		if (_data_->_state_ != 0) {
#line 69 "../plugins/LastFM/SimilarMedia.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 69 "../plugins/LastFM/SimilarMedia.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 511 "SimilarMedia.c"
			}
		}
#line 69 "../plugins/LastFM/SimilarMedia.vala"
		g_object_unref (_data_->_async_result);
#line 69 "../plugins/LastFM/SimilarMedia.vala"
		return FALSE;
#line 518 "SimilarMedia.c"
	}
#line 71 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp11_ = gee_linked_list_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 71 "../plugins/LastFM/SimilarMedia.vala"
	_data_->similarIDs = _data_->_tmp11_;
#line 72 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp12_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 72 "../plugins/LastFM/SimilarMedia.vala"
	_data_->similarDont = _data_->_tmp12_;
#line 73 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp13_ = noise_libraries_manager;
#line 73 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp14_ = _data_->_tmp13_->local_library;
#line 73 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp15_ = _data_->similar_medias;
#line 73 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp16_ = _data_->similarIDs;
#line 73 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp17_ = _data_->similarDont;
#line 73 "../plugins/LastFM/SimilarMedia.vala"
	noise_library_media_from_name (_data_->_tmp14_, (GeeCollection*) _data_->_tmp15_, (GeeCollection*) _data_->_tmp16_, (GeeCollection*) _data_->_tmp17_);
#line 74 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp18_ = _data_->self->priv->cancellable;
#line 74 "../plugins/LastFM/SimilarMedia.vala"
	if (g_cancellable_is_cancelled (_data_->_tmp18_)) {
#line 75 "../plugins/LastFM/SimilarMedia.vala"
		_g_object_unref0 (_data_->similarDont);
#line 75 "../plugins/LastFM/SimilarMedia.vala"
		_g_object_unref0 (_data_->similarIDs);
#line 75 "../plugins/LastFM/SimilarMedia.vala"
		_g_object_unref0 (_data_->similar_medias);
#line 75 "../plugins/LastFM/SimilarMedia.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 75 "../plugins/LastFM/SimilarMedia.vala"
		if (_data_->_state_ != 0) {
#line 75 "../plugins/LastFM/SimilarMedia.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 75 "../plugins/LastFM/SimilarMedia.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 558 "SimilarMedia.c"
			}
		}
#line 75 "../plugins/LastFM/SimilarMedia.vala"
		g_object_unref (_data_->_async_result);
#line 75 "../plugins/LastFM/SimilarMedia.vala"
		return FALSE;
#line 565 "SimilarMedia.c"
	}
#line 77 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp19_ = _data_->similarIDs;
#line 77 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp20_ = noise_media_get_rowid (_data_->s);
#line 77 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp21_ = _data_->_tmp20_;
#line 77 "../plugins/LastFM/SimilarMedia.vala"
	gee_deque_offer_head ((GeeDeque*) _data_->_tmp19_, &_data_->_tmp21_);
#line 78 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp22_ = noise_libraries_manager;
#line 78 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp23_ = _data_->_tmp22_->local_library;
#line 78 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp24_ = _data_->similarIDs;
#line 78 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp25_ = noise_library_medias_from_ids (_data_->_tmp23_, (GeeCollection*) _data_->_tmp24_);
#line 78 "../plugins/LastFM/SimilarMedia.vala"
	_data_->found_medias = _data_->_tmp25_;
#line 79 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp26_ = _data_->found_medias;
#line 79 "../plugins/LastFM/SimilarMedia.vala"
	gee_collection_remove (_data_->_tmp26_, _data_->s);
#line 80 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp27_ = _data_->self->similar_playlist;
#line 80 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp28_ = _data_->found_medias;
#line 80 "../plugins/LastFM/SimilarMedia.vala"
	noise_playlist_add_medias ((NoisePlaylist*) _data_->_tmp27_, _data_->_tmp28_);
#line 81 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp29_ = _data_->similarIDs;
#line 81 "../plugins/LastFM/SimilarMedia.vala"
	_data_->_tmp30_ = _data_->similarDont;
#line 81 "../plugins/LastFM/SimilarMedia.vala"
	g_signal_emit (_data_->self, last_fm_similar_medias_signals[LAST_FM_SIMILAR_MEDIAS_SIMILAR_RETRIEVED_SIGNAL], 0, _data_->_tmp29_, _data_->_tmp30_);
#line 64 "../plugins/LastFM/SimilarMedia.vala"
	_g_object_unref0 (_data_->found_medias);
#line 64 "../plugins/LastFM/SimilarMedia.vala"
	_g_object_unref0 (_data_->similarDont);
#line 64 "../plugins/LastFM/SimilarMedia.vala"
	_g_object_unref0 (_data_->similarIDs);
#line 64 "../plugins/LastFM/SimilarMedia.vala"
	_g_object_unref0 (_data_->similar_medias);
#line 64 "../plugins/LastFM/SimilarMedia.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 64 "../plugins/LastFM/SimilarMedia.vala"
	if (_data_->_state_ != 0) {
#line 64 "../plugins/LastFM/SimilarMedia.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 64 "../plugins/LastFM/SimilarMedia.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 617 "SimilarMedia.c"
		}
	}
#line 64 "../plugins/LastFM/SimilarMedia.vala"
	g_object_unref (_data_->_async_result);
#line 64 "../plugins/LastFM/SimilarMedia.vala"
	return FALSE;
#line 624 "SimilarMedia.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	g_return_if_fail (n_param_values == 3);
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 33 "../plugins/LastFM/SimilarMedia.vala"
		data1 = closure->data;
#line 33 "../plugins/LastFM/SimilarMedia.vala"
		data2 = param_values->data[0].v_pointer;
#line 649 "SimilarMedia.c"
	} else {
#line 33 "../plugins/LastFM/SimilarMedia.vala"
		data1 = param_values->data[0].v_pointer;
#line 33 "../plugins/LastFM/SimilarMedia.vala"
		data2 = closure->data;
#line 655 "SimilarMedia.c"
	}
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 661 "SimilarMedia.c"
}

static void
last_fm_similar_medias_class_init (LastFMSimilarMediasClass * klass,
                                   gpointer klass_data)
{
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	last_fm_similar_medias_parent_class = g_type_class_peek_parent (klass);
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	g_type_class_adjust_private_offset (klass, &LastFMSimilarMedias_private_offset);
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	((LastFMSimilarMediasClass *) klass)->query_for_similar = (void (*) (LastFMSimilarMedias*, NoiseMedia*)) last_fm_similar_medias_real_query_for_similar;
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	G_OBJECT_CLASS (klass)->finalize = last_fm_similar_medias_finalize;
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	last_fm_similar_medias_signals[LAST_FM_SIMILAR_MEDIAS_SIMILAR_RETRIEVED_SIGNAL] = g_signal_new ("similar-retrieved", LAST_FM_TYPE_SIMILAR_MEDIAS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_LINKED_LIST, GEE_TYPE_LINKED_LIST);
#line 678 "SimilarMedia.c"
}

static void
last_fm_similar_medias_instance_init (LastFMSimilarMedias * self,
                                      gpointer klass)
{
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	self->priv = last_fm_similar_medias_get_instance_private (self);
#line 38 "../plugins/LastFM/SimilarMedia.vala"
	g_rec_mutex_init (&self->priv->__lock_similar_playlist);
#line 689 "SimilarMedia.c"
}

static void
last_fm_similar_medias_finalize (GObject * obj)
{
	LastFMSimilarMedias * self;
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LAST_FM_TYPE_SIMILAR_MEDIAS, LastFMSimilarMedias);
#line 38 "../plugins/LastFM/SimilarMedia.vala"
	g_rec_mutex_clear (&self->priv->__lock_similar_playlist);
#line 38 "../plugins/LastFM/SimilarMedia.vala"
	_g_object_unref0 (self->similar_playlist);
#line 39 "../plugins/LastFM/SimilarMedia.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 33 "../plugins/LastFM/SimilarMedia.vala"
	G_OBJECT_CLASS (last_fm_similar_medias_parent_class)->finalize (obj);
#line 706 "SimilarMedia.c"
}

GType
last_fm_similar_medias_get_type (void)
{
	return last_fm_similar_medias_type_id;
}

GType
last_fm_similar_medias_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (LastFMSimilarMediasClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) last_fm_similar_medias_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LastFMSimilarMedias), 0, (GInstanceInitFunc) last_fm_similar_medias_instance_init, NULL };
	last_fm_similar_medias_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "LastFMSimilarMedias", &g_define_type_info, 0);
	LastFMSimilarMedias_private_offset = sizeof (LastFMSimilarMediasPrivate);
	return last_fm_similar_medias_type_id;
}

