/* Tag.c generated by valac 0.45.3, the Vala compiler
 * generated from Tag.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */
/* Merely a place holder for multiple pieces of information regarding
 * the current media playing. Mostly here because of dependence. */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define LAST_FM_TYPE_TAG (last_fm_tag_get_type ())
#define LAST_FM_TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LAST_FM_TYPE_TAG, LastFMTag))
#define LAST_FM_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LAST_FM_TYPE_TAG, LastFMTagClass))
#define LAST_FM_IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LAST_FM_TYPE_TAG))
#define LAST_FM_IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LAST_FM_TYPE_TAG))
#define LAST_FM_TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LAST_FM_TYPE_TAG, LastFMTagClass))

typedef struct _LastFMTag LastFMTag;
typedef struct _LastFMTagClass LastFMTagClass;
typedef struct _LastFMTagPrivate LastFMTagPrivate;
enum  {
	LAST_FM_TAG_0_PROPERTY,
	LAST_FM_TAG_TAG_PROPERTY,
	LAST_FM_TAG_URL_PROPERTY,
	LAST_FM_TAG_NUM_PROPERTIES
};
static GParamSpec* last_fm_tag_properties[LAST_FM_TAG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _LastFMTag {
	GObject parent_instance;
	LastFMTagPrivate * priv;
};

struct _LastFMTagClass {
	GObjectClass parent_class;
};

struct _LastFMTagPrivate {
	gchar* _tag;
	gchar* _url;
};

static gint LastFMTag_private_offset;
static gpointer last_fm_tag_parent_class = NULL;
static GType last_fm_tag_type_id = 0;

GType last_fm_tag_register_type (GTypeModule * module);
GType last_fm_tag_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LastFMTag, g_object_unref)
LastFMTag* last_fm_tag_new_with_string (const gchar* tag);
LastFMTag* last_fm_tag_construct_with_string (GType object_type,
                                              const gchar* tag);
LastFMTag* last_fm_tag_new_with_string_and_url (const gchar* tag,
                                                const gchar* url);
LastFMTag* last_fm_tag_construct_with_string_and_url (GType object_type,
                                                      const gchar* tag,
                                                      const gchar* url);
LastFMTag* last_fm_tag_new (void);
LastFMTag* last_fm_tag_construct (GType object_type);
const gchar* last_fm_tag_get_tag (LastFMTag* self);
void last_fm_tag_set_tag (LastFMTag* self,
                          const gchar* value);
const gchar* last_fm_tag_get_url (LastFMTag* self);
void last_fm_tag_set_url (LastFMTag* self,
                          const gchar* value);
static void last_fm_tag_finalize (GObject * obj);
static void _vala_last_fm_tag_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_last_fm_tag_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
last_fm_tag_get_instance_private (LastFMTag* self)
{
	return G_STRUCT_MEMBER_P (self, LastFMTag_private_offset);
}

LastFMTag*
last_fm_tag_construct_with_string (GType object_type,
                                   const gchar* tag)
{
	LastFMTag * self = NULL;
#line 36 "../plugins/LastFM/Tag.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 37 "../plugins/LastFM/Tag.vala"
	self = (LastFMTag*) g_object_new (object_type, "tag", tag, NULL);
#line 36 "../plugins/LastFM/Tag.vala"
	return self;
#line 123 "Tag.c"
}

LastFMTag*
last_fm_tag_new_with_string (const gchar* tag)
{
#line 36 "../plugins/LastFM/Tag.vala"
	return last_fm_tag_construct_with_string (LAST_FM_TYPE_TAG, tag);
#line 131 "Tag.c"
}

LastFMTag*
last_fm_tag_construct_with_string_and_url (GType object_type,
                                           const gchar* tag,
                                           const gchar* url)
{
	LastFMTag * self = NULL;
#line 40 "../plugins/LastFM/Tag.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 40 "../plugins/LastFM/Tag.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 41 "../plugins/LastFM/Tag.vala"
	self = (LastFMTag*) g_object_new (object_type, "tag", tag, "url", url, NULL);
#line 40 "../plugins/LastFM/Tag.vala"
	return self;
#line 148 "Tag.c"
}

LastFMTag*
last_fm_tag_new_with_string_and_url (const gchar* tag,
                                     const gchar* url)
{
#line 40 "../plugins/LastFM/Tag.vala"
	return last_fm_tag_construct_with_string_and_url (LAST_FM_TYPE_TAG, tag, url);
#line 157 "Tag.c"
}

LastFMTag*
last_fm_tag_construct (GType object_type)
{
	LastFMTag * self = NULL;
#line 32 "../plugins/LastFM/Tag.vala"
	self = (LastFMTag*) g_object_new (object_type, NULL);
#line 32 "../plugins/LastFM/Tag.vala"
	return self;
#line 168 "Tag.c"
}

LastFMTag*
last_fm_tag_new (void)
{
#line 32 "../plugins/LastFM/Tag.vala"
	return last_fm_tag_construct (LAST_FM_TYPE_TAG);
#line 176 "Tag.c"
}

const gchar*
last_fm_tag_get_tag (LastFMTag* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../plugins/LastFM/Tag.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../plugins/LastFM/Tag.vala"
	_tmp0_ = self->priv->_tag;
#line 33 "../plugins/LastFM/Tag.vala"
	result = _tmp0_;
#line 33 "../plugins/LastFM/Tag.vala"
	return result;
#line 192 "Tag.c"
}

void
last_fm_tag_set_tag (LastFMTag* self,
                     const gchar* value)
{
#line 33 "../plugins/LastFM/Tag.vala"
	g_return_if_fail (self != NULL);
#line 33 "../plugins/LastFM/Tag.vala"
	if (g_strcmp0 (value, last_fm_tag_get_tag (self)) != 0) {
#line 203 "Tag.c"
		gchar* _tmp0_;
#line 33 "../plugins/LastFM/Tag.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../plugins/LastFM/Tag.vala"
		_g_free0 (self->priv->_tag);
#line 33 "../plugins/LastFM/Tag.vala"
		self->priv->_tag = _tmp0_;
#line 33 "../plugins/LastFM/Tag.vala"
		g_object_notify_by_pspec ((GObject *) self, last_fm_tag_properties[LAST_FM_TAG_TAG_PROPERTY]);
#line 213 "Tag.c"
	}
}

const gchar*
last_fm_tag_get_url (LastFMTag* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../plugins/LastFM/Tag.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../plugins/LastFM/Tag.vala"
	_tmp0_ = self->priv->_url;
#line 34 "../plugins/LastFM/Tag.vala"
	result = _tmp0_;
#line 34 "../plugins/LastFM/Tag.vala"
	return result;
#line 230 "Tag.c"
}

void
last_fm_tag_set_url (LastFMTag* self,
                     const gchar* value)
{
#line 34 "../plugins/LastFM/Tag.vala"
	g_return_if_fail (self != NULL);
#line 34 "../plugins/LastFM/Tag.vala"
	if (g_strcmp0 (value, last_fm_tag_get_url (self)) != 0) {
#line 241 "Tag.c"
		gchar* _tmp0_;
#line 34 "../plugins/LastFM/Tag.vala"
		_tmp0_ = g_strdup (value);
#line 34 "../plugins/LastFM/Tag.vala"
		_g_free0 (self->priv->_url);
#line 34 "../plugins/LastFM/Tag.vala"
		self->priv->_url = _tmp0_;
#line 34 "../plugins/LastFM/Tag.vala"
		g_object_notify_by_pspec ((GObject *) self, last_fm_tag_properties[LAST_FM_TAG_URL_PROPERTY]);
#line 251 "Tag.c"
	}
}

static void
last_fm_tag_class_init (LastFMTagClass * klass,
                        gpointer klass_data)
{
#line 32 "../plugins/LastFM/Tag.vala"
	last_fm_tag_parent_class = g_type_class_peek_parent (klass);
#line 32 "../plugins/LastFM/Tag.vala"
	g_type_class_adjust_private_offset (klass, &LastFMTag_private_offset);
#line 32 "../plugins/LastFM/Tag.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_last_fm_tag_get_property;
#line 32 "../plugins/LastFM/Tag.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_last_fm_tag_set_property;
#line 32 "../plugins/LastFM/Tag.vala"
	G_OBJECT_CLASS (klass)->finalize = last_fm_tag_finalize;
#line 32 "../plugins/LastFM/Tag.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAST_FM_TAG_TAG_PROPERTY, last_fm_tag_properties[LAST_FM_TAG_TAG_PROPERTY] = g_param_spec_string ("tag", "tag", "tag", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "../plugins/LastFM/Tag.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAST_FM_TAG_URL_PROPERTY, last_fm_tag_properties[LAST_FM_TAG_URL_PROPERTY] = g_param_spec_string ("url", "url", "url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 273 "Tag.c"
}

static void
last_fm_tag_instance_init (LastFMTag * self,
                           gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 32 "../plugins/LastFM/Tag.vala"
	self->priv = last_fm_tag_get_instance_private (self);
#line 33 "../plugins/LastFM/Tag.vala"
	_tmp0_ = g_strdup ("");
#line 33 "../plugins/LastFM/Tag.vala"
	self->priv->_tag = _tmp0_;
#line 34 "../plugins/LastFM/Tag.vala"
	_tmp1_ = g_strdup ("");
#line 34 "../plugins/LastFM/Tag.vala"
	self->priv->_url = _tmp1_;
#line 292 "Tag.c"
}

static void
last_fm_tag_finalize (GObject * obj)
{
	LastFMTag * self;
#line 32 "../plugins/LastFM/Tag.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LAST_FM_TYPE_TAG, LastFMTag);
#line 33 "../plugins/LastFM/Tag.vala"
	_g_free0 (self->priv->_tag);
#line 34 "../plugins/LastFM/Tag.vala"
	_g_free0 (self->priv->_url);
#line 32 "../plugins/LastFM/Tag.vala"
	G_OBJECT_CLASS (last_fm_tag_parent_class)->finalize (obj);
#line 307 "Tag.c"
}

GType
last_fm_tag_get_type (void)
{
	return last_fm_tag_type_id;
}

GType
last_fm_tag_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (LastFMTagClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) last_fm_tag_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LastFMTag), 0, (GInstanceInitFunc) last_fm_tag_instance_init, NULL };
	last_fm_tag_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "LastFMTag", &g_define_type_info, 0);
	LastFMTag_private_offset = sizeof (LastFMTagPrivate);
	return last_fm_tag_type_id;
}

static void
_vala_last_fm_tag_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	LastFMTag * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LAST_FM_TYPE_TAG, LastFMTag);
#line 32 "../plugins/LastFM/Tag.vala"
	switch (property_id) {
#line 32 "../plugins/LastFM/Tag.vala"
		case LAST_FM_TAG_TAG_PROPERTY:
#line 32 "../plugins/LastFM/Tag.vala"
		g_value_set_string (value, last_fm_tag_get_tag (self));
#line 32 "../plugins/LastFM/Tag.vala"
		break;
#line 32 "../plugins/LastFM/Tag.vala"
		case LAST_FM_TAG_URL_PROPERTY:
#line 32 "../plugins/LastFM/Tag.vala"
		g_value_set_string (value, last_fm_tag_get_url (self));
#line 32 "../plugins/LastFM/Tag.vala"
		break;
#line 347 "Tag.c"
		default:
#line 32 "../plugins/LastFM/Tag.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../plugins/LastFM/Tag.vala"
		break;
#line 353 "Tag.c"
	}
}

static void
_vala_last_fm_tag_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	LastFMTag * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LAST_FM_TYPE_TAG, LastFMTag);
#line 32 "../plugins/LastFM/Tag.vala"
	switch (property_id) {
#line 32 "../plugins/LastFM/Tag.vala"
		case LAST_FM_TAG_TAG_PROPERTY:
#line 32 "../plugins/LastFM/Tag.vala"
		last_fm_tag_set_tag (self, g_value_get_string (value));
#line 32 "../plugins/LastFM/Tag.vala"
		break;
#line 32 "../plugins/LastFM/Tag.vala"
		case LAST_FM_TAG_URL_PROPERTY:
#line 32 "../plugins/LastFM/Tag.vala"
		last_fm_tag_set_url (self, g_value_get_string (value));
#line 32 "../plugins/LastFM/Tag.vala"
		break;
#line 379 "Tag.c"
		default:
#line 32 "../plugins/LastFM/Tag.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../plugins/LastFM/Tag.vala"
		break;
#line 385 "Tag.c"
	}
}

